@echo off
:-
:-  Boom builder for iMatix Base2 2.3
:-  Generated by iMatix Boom from product.pwl
:-  
:-  Copyright (c) 1996-2009 iMatix Corporation
:-  All rights reserved.
:-  
:-  This file is licensed under the BSD license as follows:
:-  
:-  Redistribution and use in source and binary forms, with or without
:-  modification, are permitted provided that the following conditions
:-  are met:
:-  
:-  * Redistributions of source code must retain the above copyright
:-    notice, this list of conditions and the following disclaimer.
:-  * Redistributions in binary form must reproduce the above copyright
:-    notice, this list of conditions and the following disclaimer in
:-    the documentation and/or other materials provided with the
:-    distribution.
:-  * Neither the name of iMatix Corporation nor the names of its
:-    contributors may be used to endorse or promote products derived
:-    from this software without specific prior written permission.
:-  
:-  THIS SOFTWARE IS PROVIDED BY IMATIX CORPORATION "AS IS" AND ANY
:-  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
:-  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
:-  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL IMATIX CORPORATION BE
:-  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
:-  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
:-  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
:-  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
:-  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
:-  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
:-  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
:-
:-  Start CMD.EXE version detection
verify other 2>nul
setlocal enableextensions
if errorlevel 0 goto __cmd_ok
echo %0: This command requires command extensions version 2 in CMD.EXE.  
echo %0: Please use a supported system (Windows 2000 or newer).
exit
:__cmd_ok
setlocal enabledelayedexpansion
:-  End CMD.EXE version detection
goto :init
:-
:-  Subroutine: boom_model_init
:-  Initialises BOOM_MODEL to default if not set
:-  Expands BOOM_MODEL components into individual environment variables
:-
:boom_model_init
if "!BOOM_MODEL!"=="" (
    set BOOM_MODEL=release,st
)
set BOOM_MODEL__PLACEHOLDER=1
for /f "usebackq delims==" %%v in (`set BOOM_MODEL_`) do set %%v=
set BOOM_MODEL__PLACEHOLDER=
for %%m in (!BOOM_MODEL!) do set BOOM_MODEL_%%m=1
:-  If the user set BOOM_MODEL but did not include release/debug or st/mt
:-  set these to defaults.
if not "!BOOM_MODEL_RELEASE!"=="1" (
    if not "!BOOM_MODEL_DEBUG!"=="1" (
        set BOOM_MODEL_RELEASE=1
        set BOOM_MODEL=!BOOM_MODEL!,release
    )
)
if not "!BOOM_MODEL_ST!"=="1" (
    if not "!BOOM_MODEL_MT!"=="1" (
        set BOOM_MODEL_ST=1
        set BOOM_MODEL=!BOOM_MODEL!,st
    )
)
goto :eof
:init
setlocal
:-
:-  Set environment variables to point to install location
:-  Start by using final IBASE, then handle -install path
set self=%0
set MY_VERSION=2.3
set OLDPATH=!PATH!
set OLDPERLLIB=!PERLLIB!
if .!IBASE!==. (
    echo boom E: [base2]: The IBASE variable is not set.           Please set it to the location where iMatix Base2 should be installed.
    exit /b 1
)
if .%1==.-v (
    set BOOM_TRACE=1
    shift
)
call :boom_model_init
if .%1==.-install goto tempinst
:-  Normal use, use IBASE
    set PATH=!IBASE!\bin;!PATH!
    set PERLLIB=!IBASE!\bin;!PERLLIB!
    set INCDIR_ALT=!IBASE!\include
    set _INSTALL_ROOT=!IBASE!
    goto process

:tempinst
:-  Building product, we use -install directory first, then IBASE
    if not exist %2 (
       echo "Invalid command syntax - please contact imatix-tech"
       exit /b 1
    )
    pushd %2
    set _LOCAL_BASE=!cd!
    popd
    set PATH=!_LOCAL_BASE!\bin;!IBASE!\bin;!PATH!
    set PERLLIB=!_LOCAL_BASE!\bin;!IBASE!\bin;!PERLLIB!
    set INCDIR_ALT=!_LOCAL_BASE!\include;!IBASE!\include
    set _INSTALL_ROOT=!_LOCAL_BASE!
    shift
    shift
    goto process

:batch
    shift

:process
    set state=initial
    set event=ok
    set debug=0
    goto s_!state!

:-----------------------------   ALLGEN PROJECTS   ----------------------------

:a_allgen_projects
    pushd xnf
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake allgen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    goto :eof

:---------------------   BUILD PRODUCT INSTALL PACKAGES   ---------------------

:a_build_product_install_packages
    echo boom I: [base2]: building Base Install...
    if exist _install\nul rmdir /s /q _install
    mkdir _install
    mkdir _install\lib
    mkdir _install\include
    mkdir _install\bin
    pushd xnf
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
    call boomake -install ..\_install install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    if exist base2-!MY_VERSION! rmdir /s/q base2-!MY_VERSION!
    ren _install base2-!MY_VERSION!
    if "!BOOM_TRACE!"=="1" echo pkg_zip base2-!MY_VERSION!
    verify>nul
    call pkg_zip base2-!MY_VERSION!
    if errorlevel 1 (
        echo boom E: [base2]: 'pkg_zip base2-!MY_VERSION!' failed - stop.
        set _exception=1
        goto :eof
    )
    rmdir /s/q base2-!MY_VERSION!
    goto :eof

:----------------------   BUILD PRODUCT SOURCE PACKAGES   ---------------------

:a_build_product_source_packages
    if exist _package.lst del _package.lst
    if exist project.pdl echo project.pdl>>_package.lst
    if exist readme.txt echo readme.txt>>_package.lst
    if exist release.txt echo release.txt>>_package.lst
    if exist stamp_generate echo stamp_generate>>_package.lst
    if exist configure echo configure>>_package.lst
    if exist Makefile.unix echo Makefile.unix>>_package.lst
    if exist boomake echo boomake>>_package.lst
    if exist configure.bat echo configure.bat>>_package.lst
    if exist Makefile.win32 echo Makefile.win32>>_package.lst
    if exist boomake.bat echo boomake.bat>>_package.lst
    if exist boomakew.bat echo boomakew.bat>>_package.lst
    pushd xnf
    popd
    if exist xnf\xnf.xnf echo xnf\xnf.xnf>>_package.lst
    if exist xnf\xnf_base.xnf echo xnf\xnf_base.xnf>>_package.lst
    if exist xnf\xnf_gen.gsl echo xnf\xnf_gen.gsl>>_package.lst
    if exist xnf\xnf_preproc.gsl echo xnf\xnf_preproc.gsl>>_package.lst
    if exist xnf\xnf_inherit.gsl echo xnf\xnf_inherit.gsl>>_package.lst
    if exist xnf\xnf_parse.gsl echo xnf\xnf_parse.gsl>>_package.lst
    if exist xnf\xnf_produce.gsl echo xnf\xnf_produce.gsl>>_package.lst
    if exist xnf\xnf_doc.txt echo xnf\xnf_doc.txt>>_package.lst
    if exist xnf\dfl.xnf echo xnf\dfl.xnf>>_package.lst
    if exist xnf\dfl_gen.gsl echo xnf\dfl_gen.gsl>>_package.lst
    if exist xnf\dfl_preproc.gsl echo xnf\dfl_preproc.gsl>>_package.lst
    if exist xnf\dfl_inherit.gsl echo xnf\dfl_inherit.gsl>>_package.lst
    if exist xnf\dfl_parse.gsl echo xnf\dfl_parse.gsl>>_package.lst
    if exist xnf\dfl_doc.txt echo xnf\dfl_doc.txt>>_package.lst
    if exist xnf\prelude.pdl echo xnf\prelude.pdl>>_package.lst
    if exist xnf\license.gpl echo xnf\license.gpl>>_package.lst
    if exist xnf\project.pdl echo xnf\project.pdl>>_package.lst
    if exist xnf\readme.txt echo xnf\readme.txt>>_package.lst
    if exist xnf\stamp_generate echo xnf\stamp_generate>>_package.lst
    if exist xnf\configure echo xnf\configure>>_package.lst
    if exist xnf\Makefile.unix echo xnf\Makefile.unix>>_package.lst
    if exist xnf\boomake echo xnf\boomake>>_package.lst
    if exist xnf\configure.bat echo xnf\configure.bat>>_package.lst
    if exist xnf\Makefile.win32 echo xnf\Makefile.win32>>_package.lst
    if exist xnf\boomake.bat echo xnf\boomake.bat>>_package.lst
    if exist xnf\boomakew.bat echo xnf\boomakew.bat>>_package.lst
    pushd icl
    popd
    if exist icl\version.h echo icl\version.h>>_package.lst
    if exist icl\icl_stdc.xnf echo icl\icl_stdc.xnf>>_package.lst
    if exist icl\icl.xnf echo icl\icl.xnf>>_package.lst
    if exist icl\icl_gen.gsl echo icl\icl_gen.gsl>>_package.lst
    if exist icl\icl_preproc.gsl echo icl\icl_preproc.gsl>>_package.lst
    if exist icl\icl_inherit.gsl echo icl\icl_inherit.gsl>>_package.lst
    if exist icl\icl_parse.gsl echo icl\icl_parse.gsl>>_package.lst
    if exist icl\icl_doc.txt echo icl\icl_doc.txt>>_package.lst
    if exist icl\base.h echo icl\base.h>>_package.lst
    if exist icl\icl_stdc.gsl echo icl\icl_stdc.gsl>>_package.lst
    if exist icl\icl_stdc_lib.gsl echo icl\icl_stdc_lib.gsl>>_package.lst
    if exist icl\icl_perl.gsl echo icl\icl_perl.gsl>>_package.lst
    if exist icl\icl_java.gsl echo icl\icl_java.gsl>>_package.lst
    if exist icl\icl_ruby.gsl echo icl\icl_ruby.gsl>>_package.lst
    if exist icl\icl_doc.gsl echo icl\icl_doc.gsl>>_package.lst
    if exist icl\icl_classes.pdl echo icl\icl_classes.pdl>>_package.lst
    if exist icl\icl_base.icl echo icl\icl_base.icl>>_package.lst
    if exist icl\icl_init.icl echo icl\icl_init.icl>>_package.lst
    if exist icl\icl_object.icl echo icl\icl_object.icl>>_package.lst
    if exist icl\icl_thread.icl echo icl\icl_thread.icl>>_package.lst
    if exist icl\icl_mutex.icl echo icl\icl_mutex.icl>>_package.lst
    if exist icl\icl_cond.icl echo icl\icl_cond.icl>>_package.lst
    if exist icl\icl_rwlock.icl echo icl\icl_rwlock.icl>>_package.lst
    if exist icl\icl_apr.icl echo icl\icl_apr.icl>>_package.lst
    if exist icl\icl_stats.icl echo icl\icl_stats.icl>>_package.lst
    if exist icl\icl_trace.icl echo icl\icl_trace.icl>>_package.lst
    if exist icl\icl_destroy.icl echo icl\icl_destroy.icl>>_package.lst
    if exist icl\icl_destroy_list.icl echo icl\icl_destroy_list.icl>>_package.lst
    if exist icl\icl_system.icl echo icl\icl_system.icl>>_package.lst
    if exist icl\icl_system_list.icl echo icl\icl_system_list.icl>>_package.lst
    if exist icl\icl_console.icl echo icl\icl_console.icl>>_package.lst
    if exist icl\icl_longstr.icl echo icl\icl_longstr.icl>>_package.lst
    if exist icl\icl_shortstr.icl echo icl\icl_shortstr.icl>>_package.lst
    if exist icl\icl_tracker.icl echo icl\icl_tracker.icl>>_package.lst
    if exist icl\icl_mem.icl echo icl\icl_mem.icl>>_package.lst
    if exist icl\icl_mem_lib.icl echo icl\icl_mem_lib.icl>>_package.lst
    if exist icl\icl_mem_fat.icl echo icl\icl_mem_fat.icl>>_package.lst
    if exist icl\icl_mem_fat_list.icl echo icl\icl_mem_fat_list.icl>>_package.lst
    if exist icl\icl_mem_thin.icl echo icl\icl_mem_thin.icl>>_package.lst
    if exist icl\icl_mem_thin_list.icl echo icl\icl_mem_thin_list.icl>>_package.lst
    if exist icl\icl_cache.icl echo icl\icl_cache.icl>>_package.lst
    if exist icl\icl_cache_list.icl echo icl\icl_cache_list.icl>>_package.lst
    if exist icl\icl_list_item.icl echo icl\icl_list_item.icl>>_package.lst
    if exist icl\icl_list_head.icl echo icl\icl_list_head.icl>>_package.lst
    if exist icl\icl_hash_item.icl echo icl\icl_hash_item.icl>>_package.lst
    if exist icl\icl_hash_head.icl echo icl\icl_hash_head.icl>>_package.lst
    if exist icl\icl_array_item.icl echo icl\icl_array_item.icl>>_package.lst
    if exist icl\icl_array_head.icl echo icl\icl_array_head.icl>>_package.lst
    if exist icl\icl_stack_item.icl echo icl\icl_stack_item.icl>>_package.lst
    if exist icl\icl_stack_head.icl echo icl\icl_stack_head.icl>>_package.lst
    if exist icl\icl_queue_item.icl echo icl\icl_queue_item.icl>>_package.lst
    if exist icl\icl_queue_head.icl echo icl\icl_queue_head.icl>>_package.lst
    if exist icl\icl_iter_list_item.icl echo icl\icl_iter_list_item.icl>>_package.lst
    if exist icl\icl_iter_list_head.icl echo icl\icl_iter_list_head.icl>>_package.lst
    if exist icl\icl_stats_examine.c echo icl\icl_stats_examine.c>>_package.lst
    if exist icl\icl_demo_rwlock.icl echo icl\icl_demo_rwlock.icl>>_package.lst
    if exist icl\icl_demo_thread.icl echo icl\icl_demo_thread.icl>>_package.lst
    if exist icl\icl_demo_plain.icl echo icl\icl_demo_plain.icl>>_package.lst
    if exist icl\icl_demo_cache.icl echo icl\icl_demo_cache.icl>>_package.lst
    if exist icl\icl_demo_local.icl echo icl\icl_demo_local.icl>>_package.lst
    if exist icl\icl_demo_possess.icl echo icl\icl_demo_possess.icl>>_package.lst
    if exist icl\icl_demo_links.icl echo icl\icl_demo_links.icl>>_package.lst
    if exist icl\icl_demo_list.icl echo icl\icl_demo_list.icl>>_package.lst
    if exist icl\icl_demo_list_list.icl echo icl\icl_demo_list_list.icl>>_package.lst
    if exist icl\icl_demo_list2.icl echo icl\icl_demo_list2.icl>>_package.lst
    if exist icl\icl_demo_list2_list.icl echo icl\icl_demo_list2_list.icl>>_package.lst
    if exist icl\icl_demo_list2_list2.icl echo icl\icl_demo_list2_list2.icl>>_package.lst
    if exist icl\icl_demo_hash_int.icl echo icl\icl_demo_hash_int.icl>>_package.lst
    if exist icl\icl_demo_hash_int_table.icl echo icl\icl_demo_hash_int_table.icl>>_package.lst
    if exist icl\icl_demo_hash_str.icl echo icl\icl_demo_hash_str.icl>>_package.lst
    if exist icl\icl_demo_hash_str_table.icl echo icl\icl_demo_hash_str_table.icl>>_package.lst
    if exist icl\icl_demo_hash_lstr.icl echo icl\icl_demo_hash_lstr.icl>>_package.lst
    if exist icl\icl_demo_hash_lstr_table.icl echo icl\icl_demo_hash_lstr_table.icl>>_package.lst
    if exist icl\icl_demo_serial.icl echo icl\icl_demo_serial.icl>>_package.lst
    if exist icl\icl_demo_array.icl echo icl\icl_demo_array.icl>>_package.lst
    if exist icl\icl_demo_array_array.icl echo icl\icl_demo_array_array.icl>>_package.lst
    if exist icl\icl_demo_stack.icl echo icl\icl_demo_stack.icl>>_package.lst
    if exist icl\icl_demo_stack_stack.icl echo icl\icl_demo_stack_stack.icl>>_package.lst
    if exist icl\icl_demo_queue.icl echo icl\icl_demo_queue.icl>>_package.lst
    if exist icl\icl_demo_queue_queue.icl echo icl\icl_demo_queue_queue.icl>>_package.lst
    if exist icl\icl_demo_scope.icl echo icl\icl_demo_scope.icl>>_package.lst
    if exist icl\icl_list_lib.gsl echo icl\icl_list_lib.gsl>>_package.lst
    if exist icl\icl_list_head.gsl echo icl\icl_list_head.gsl>>_package.lst
    if exist icl\icl_iter_list_head.gsl echo icl\icl_iter_list_head.gsl>>_package.lst
    if exist icl\icl_hash_head.gsl echo icl\icl_hash_head.gsl>>_package.lst
    if exist icl\icl_array_head.gsl echo icl\icl_array_head.gsl>>_package.lst
    if exist icl\icl_stack_head.gsl echo icl\icl_stack_head.gsl>>_package.lst
    if exist icl\icl_queue_head.gsl echo icl\icl_queue_head.gsl>>_package.lst
    if exist icl\icl_serialise.gsl echo icl\icl_serialise.gsl>>_package.lst
    if exist icl\icl.h echo icl\icl.h>>_package.lst
    if exist icl\icl_prettyc.pl echo icl\icl_prettyc.pl>>_package.lst
    if exist icl\icl_make_doc.sh echo icl\icl_make_doc.sh>>_package.lst
    if exist icl\icl_make_doc.ignore echo icl\icl_make_doc.ignore>>_package.lst
    if exist icl\prelude.pdl echo icl\prelude.pdl>>_package.lst
    if exist icl\license.gpl echo icl\license.gpl>>_package.lst
    if exist icl\project.pdl echo icl\project.pdl>>_package.lst
    if exist icl\readme.txt echo icl\readme.txt>>_package.lst
    if exist icl\icl_mutex_test.c echo icl\icl_mutex_test.c>>_package.lst
    if exist icl\icl_mutex.h echo icl\icl_mutex.h>>_package.lst
    if exist icl\icl_mutex.c echo icl\icl_mutex.c>>_package.lst
    if exist icl\icl_cond_test.c echo icl\icl_cond_test.c>>_package.lst
    if exist icl\icl_cond.h echo icl\icl_cond.h>>_package.lst
    if exist icl\icl_cond.c echo icl\icl_cond.c>>_package.lst
    if exist icl\icl_rwlock_test.c echo icl\icl_rwlock_test.c>>_package.lst
    if exist icl\icl_rwlock.h echo icl\icl_rwlock.h>>_package.lst
    if exist icl\icl_rwlock.c echo icl\icl_rwlock.c>>_package.lst
    if exist icl\icl_apr_test.c echo icl\icl_apr_test.c>>_package.lst
    if exist icl\icl_apr.h echo icl\icl_apr.h>>_package.lst
    if exist icl\icl_apr.c echo icl\icl_apr.c>>_package.lst
    if exist icl\icl_stats_test.c echo icl\icl_stats_test.c>>_package.lst
    if exist icl\icl_stats.h echo icl\icl_stats.h>>_package.lst
    if exist icl\icl_stats.c echo icl\icl_stats.c>>_package.lst
    if exist icl\icl_trace_test.c echo icl\icl_trace_test.c>>_package.lst
    if exist icl\icl_trace.h echo icl\icl_trace.h>>_package.lst
    if exist icl\icl_trace.c echo icl\icl_trace.c>>_package.lst
    if exist icl\icl_destroy_test.c echo icl\icl_destroy_test.c>>_package.lst
    if exist icl\icl_destroy.h echo icl\icl_destroy.h>>_package.lst
    if exist icl\icl_destroy.c echo icl\icl_destroy.c>>_package.lst
    if exist icl\icl_destroy_list_test.c echo icl\icl_destroy_list_test.c>>_package.lst
    if exist icl\icl_destroy_list.h echo icl\icl_destroy_list.h>>_package.lst
    if exist icl\icl_destroy_list.c echo icl\icl_destroy_list.c>>_package.lst
    if exist icl\icl_system_test.c echo icl\icl_system_test.c>>_package.lst
    if exist icl\icl_system.h echo icl\icl_system.h>>_package.lst
    if exist icl\icl_system.c echo icl\icl_system.c>>_package.lst
    if exist icl\icl_system_list_test.c echo icl\icl_system_list_test.c>>_package.lst
    if exist icl\icl_system_list.h echo icl\icl_system_list.h>>_package.lst
    if exist icl\icl_system_list.c echo icl\icl_system_list.c>>_package.lst
    if exist icl\icl_console_test.c echo icl\icl_console_test.c>>_package.lst
    if exist icl\icl_console.h echo icl\icl_console.h>>_package.lst
    if exist icl\icl_console.c echo icl\icl_console.c>>_package.lst
    if exist icl\icl_longstr_test.c echo icl\icl_longstr_test.c>>_package.lst
    if exist icl\icl_longstr.h echo icl\icl_longstr.h>>_package.lst
    if exist icl\icl_longstr.c echo icl\icl_longstr.c>>_package.lst
    if exist icl\icl_shortstr_test.c echo icl\icl_shortstr_test.c>>_package.lst
    if exist icl\icl_shortstr.h echo icl\icl_shortstr.h>>_package.lst
    if exist icl\icl_shortstr.c echo icl\icl_shortstr.c>>_package.lst
    if exist icl\icl_mem_test.c echo icl\icl_mem_test.c>>_package.lst
    if exist icl\icl_mem.h echo icl\icl_mem.h>>_package.lst
    if exist icl\icl_mem.c echo icl\icl_mem.c>>_package.lst
    if exist icl\icl_mem_fat_test.c echo icl\icl_mem_fat_test.c>>_package.lst
    if exist icl\icl_mem_fat.h echo icl\icl_mem_fat.h>>_package.lst
    if exist icl\icl_mem_fat.c echo icl\icl_mem_fat.c>>_package.lst
    if exist icl\icl_mem_fat_list_test.c echo icl\icl_mem_fat_list_test.c>>_package.lst
    if exist icl\icl_mem_fat_list.h echo icl\icl_mem_fat_list.h>>_package.lst
    if exist icl\icl_mem_fat_list.c echo icl\icl_mem_fat_list.c>>_package.lst
    if exist icl\icl_mem_thin_test.c echo icl\icl_mem_thin_test.c>>_package.lst
    if exist icl\icl_mem_thin.h echo icl\icl_mem_thin.h>>_package.lst
    if exist icl\icl_mem_thin.c echo icl\icl_mem_thin.c>>_package.lst
    if exist icl\icl_mem_thin_list_test.c echo icl\icl_mem_thin_list_test.c>>_package.lst
    if exist icl\icl_mem_thin_list.h echo icl\icl_mem_thin_list.h>>_package.lst
    if exist icl\icl_mem_thin_list.c echo icl\icl_mem_thin_list.c>>_package.lst
    if exist icl\icl_cache_test.c echo icl\icl_cache_test.c>>_package.lst
    if exist icl\icl_cache.h echo icl\icl_cache.h>>_package.lst
    if exist icl\icl_cache.c echo icl\icl_cache.c>>_package.lst
    if exist icl\icl_cache_list_test.c echo icl\icl_cache_list_test.c>>_package.lst
    if exist icl\icl_cache_list.h echo icl\icl_cache_list.h>>_package.lst
    if exist icl\icl_cache_list.c echo icl\icl_cache_list.c>>_package.lst
    if exist icl\icl_demo_rwlock_test.c echo icl\icl_demo_rwlock_test.c>>_package.lst
    if exist icl\icl_demo_rwlock.h echo icl\icl_demo_rwlock.h>>_package.lst
    if exist icl\icl_demo_rwlock.c echo icl\icl_demo_rwlock.c>>_package.lst
    if exist icl\icl_demo_thread_test.c echo icl\icl_demo_thread_test.c>>_package.lst
    if exist icl\icl_demo_thread.h echo icl\icl_demo_thread.h>>_package.lst
    if exist icl\icl_demo_thread.c echo icl\icl_demo_thread.c>>_package.lst
    if exist icl\icl_demo_plain_test.c echo icl\icl_demo_plain_test.c>>_package.lst
    if exist icl\icl_demo_plain.h echo icl\icl_demo_plain.h>>_package.lst
    if exist icl\icl_demo_plain.c echo icl\icl_demo_plain.c>>_package.lst
    if exist icl\icl_demo_cache_test.c echo icl\icl_demo_cache_test.c>>_package.lst
    if exist icl\icl_demo_cache.h echo icl\icl_demo_cache.h>>_package.lst
    if exist icl\icl_demo_cache.c echo icl\icl_demo_cache.c>>_package.lst
    if exist icl\icl_demo_local_test.c echo icl\icl_demo_local_test.c>>_package.lst
    if exist icl\icl_demo_local.h echo icl\icl_demo_local.h>>_package.lst
    if exist icl\icl_demo_local.c echo icl\icl_demo_local.c>>_package.lst
    if exist icl\icl_demo_possess_test.c echo icl\icl_demo_possess_test.c>>_package.lst
    if exist icl\icl_demo_possess.h echo icl\icl_demo_possess.h>>_package.lst
    if exist icl\icl_demo_possess.c echo icl\icl_demo_possess.c>>_package.lst
    if exist icl\icl_demo_links_test.c echo icl\icl_demo_links_test.c>>_package.lst
    if exist icl\icl_demo_links.h echo icl\icl_demo_links.h>>_package.lst
    if exist icl\icl_demo_links.c echo icl\icl_demo_links.c>>_package.lst
    if exist icl\icl_demo_list_test.c echo icl\icl_demo_list_test.c>>_package.lst
    if exist icl\icl_demo_list.h echo icl\icl_demo_list.h>>_package.lst
    if exist icl\icl_demo_list.c echo icl\icl_demo_list.c>>_package.lst
    if exist icl\icl_demo_list_list_test.c echo icl\icl_demo_list_list_test.c>>_package.lst
    if exist icl\icl_demo_list_list.h echo icl\icl_demo_list_list.h>>_package.lst
    if exist icl\icl_demo_list_list.c echo icl\icl_demo_list_list.c>>_package.lst
    if exist icl\icl_demo_list2_test.c echo icl\icl_demo_list2_test.c>>_package.lst
    if exist icl\icl_demo_list2.h echo icl\icl_demo_list2.h>>_package.lst
    if exist icl\icl_demo_list2.c echo icl\icl_demo_list2.c>>_package.lst
    if exist icl\icl_demo_list2_list_test.c echo icl\icl_demo_list2_list_test.c>>_package.lst
    if exist icl\icl_demo_list2_list.h echo icl\icl_demo_list2_list.h>>_package.lst
    if exist icl\icl_demo_list2_list.c echo icl\icl_demo_list2_list.c>>_package.lst
    if exist icl\icl_demo_list2_list2_test.c echo icl\icl_demo_list2_list2_test.c>>_package.lst
    if exist icl\icl_demo_list2_list2.h echo icl\icl_demo_list2_list2.h>>_package.lst
    if exist icl\icl_demo_list2_list2.c echo icl\icl_demo_list2_list2.c>>_package.lst
    if exist icl\icl_demo_hash_int_test.c echo icl\icl_demo_hash_int_test.c>>_package.lst
    if exist icl\icl_demo_hash_int.h echo icl\icl_demo_hash_int.h>>_package.lst
    if exist icl\icl_demo_hash_int.c echo icl\icl_demo_hash_int.c>>_package.lst
    if exist icl\icl_demo_hash_int_table_test.c echo icl\icl_demo_hash_int_table_test.c>>_package.lst
    if exist icl\icl_demo_hash_int_table.h echo icl\icl_demo_hash_int_table.h>>_package.lst
    if exist icl\icl_demo_hash_int_table.c echo icl\icl_demo_hash_int_table.c>>_package.lst
    if exist icl\icl_demo_hash_str_test.c echo icl\icl_demo_hash_str_test.c>>_package.lst
    if exist icl\icl_demo_hash_str.h echo icl\icl_demo_hash_str.h>>_package.lst
    if exist icl\icl_demo_hash_str.c echo icl\icl_demo_hash_str.c>>_package.lst
    if exist icl\icl_demo_hash_str_table_test.c echo icl\icl_demo_hash_str_table_test.c>>_package.lst
    if exist icl\icl_demo_hash_str_table.h echo icl\icl_demo_hash_str_table.h>>_package.lst
    if exist icl\icl_demo_hash_str_table.c echo icl\icl_demo_hash_str_table.c>>_package.lst
    if exist icl\icl_demo_hash_lstr_test.c echo icl\icl_demo_hash_lstr_test.c>>_package.lst
    if exist icl\icl_demo_hash_lstr.h echo icl\icl_demo_hash_lstr.h>>_package.lst
    if exist icl\icl_demo_hash_lstr.c echo icl\icl_demo_hash_lstr.c>>_package.lst
    if exist icl\icl_demo_hash_lstr_table_test.c echo icl\icl_demo_hash_lstr_table_test.c>>_package.lst
    if exist icl\icl_demo_hash_lstr_table.h echo icl\icl_demo_hash_lstr_table.h>>_package.lst
    if exist icl\icl_demo_hash_lstr_table.c echo icl\icl_demo_hash_lstr_table.c>>_package.lst
    if exist icl\icl_demo_serial_test.c echo icl\icl_demo_serial_test.c>>_package.lst
    if exist icl\icl_demo_serial.h echo icl\icl_demo_serial.h>>_package.lst
    if exist icl\icl_demo_serial.c echo icl\icl_demo_serial.c>>_package.lst
    if exist icl\icl_demo_array_test.c echo icl\icl_demo_array_test.c>>_package.lst
    if exist icl\icl_demo_array.h echo icl\icl_demo_array.h>>_package.lst
    if exist icl\icl_demo_array.c echo icl\icl_demo_array.c>>_package.lst
    if exist icl\icl_demo_array_array_test.c echo icl\icl_demo_array_array_test.c>>_package.lst
    if exist icl\icl_demo_array_array.h echo icl\icl_demo_array_array.h>>_package.lst
    if exist icl\icl_demo_array_array.c echo icl\icl_demo_array_array.c>>_package.lst
    if exist icl\icl_demo_stack_test.c echo icl\icl_demo_stack_test.c>>_package.lst
    if exist icl\icl_demo_stack.h echo icl\icl_demo_stack.h>>_package.lst
    if exist icl\icl_demo_stack.c echo icl\icl_demo_stack.c>>_package.lst
    if exist icl\icl_demo_stack_stack_test.c echo icl\icl_demo_stack_stack_test.c>>_package.lst
    if exist icl\icl_demo_stack_stack.h echo icl\icl_demo_stack_stack.h>>_package.lst
    if exist icl\icl_demo_stack_stack.c echo icl\icl_demo_stack_stack.c>>_package.lst
    if exist icl\icl_demo_queue_test.c echo icl\icl_demo_queue_test.c>>_package.lst
    if exist icl\icl_demo_queue.h echo icl\icl_demo_queue.h>>_package.lst
    if exist icl\icl_demo_queue.c echo icl\icl_demo_queue.c>>_package.lst
    if exist icl\icl_demo_queue_queue_test.c echo icl\icl_demo_queue_queue_test.c>>_package.lst
    if exist icl\icl_demo_queue_queue.h echo icl\icl_demo_queue_queue.h>>_package.lst
    if exist icl\icl_demo_queue_queue.c echo icl\icl_demo_queue_queue.c>>_package.lst
    if exist icl\icl_demo_scope_test.c echo icl\icl_demo_scope_test.c>>_package.lst
    if exist icl\icl_demo_scope.h echo icl\icl_demo_scope.h>>_package.lst
    if exist icl\icl_demo_scope.c echo icl\icl_demo_scope.c>>_package.lst
    if exist icl\stamp_generate echo icl\stamp_generate>>_package.lst
    if exist icl\configure echo icl\configure>>_package.lst
    if exist icl\Makefile.unix echo icl\Makefile.unix>>_package.lst
    if exist icl\boomake echo icl\boomake>>_package.lst
    if exist icl\configure.bat echo icl\configure.bat>>_package.lst
    if exist icl\Makefile.win32 echo icl\Makefile.win32>>_package.lst
    if exist icl\boomake.bat echo icl\boomake.bat>>_package.lst
    if exist icl\boomakew.bat echo icl\boomakew.bat>>_package.lst
    if exist icl\libicl.vcproj echo icl\libicl.vcproj>>_package.lst
    pushd ipr
    popd
    if exist ipr\version.h echo ipr\version.h>>_package.lst
    if exist ipr\ipr_bits.icl echo ipr\ipr_bits.icl>>_package.lst
    if exist ipr\ipr_bucket.icl echo ipr\ipr_bucket.icl>>_package.lst
    if exist ipr\ipr_bucket_list.icl echo ipr\ipr_bucket_list.icl>>_package.lst
    if exist ipr\ipr_mother.icl echo ipr\ipr_mother.icl>>_package.lst
    if exist ipr\ipr_config.icl echo ipr\ipr_config.icl>>_package.lst
    if exist ipr\ipr_crc.icl echo ipr\ipr_crc.icl>>_package.lst
    if exist ipr\ipr_dict.icl echo ipr\ipr_dict.icl>>_package.lst
    if exist ipr\ipr_dict_table.icl echo ipr\ipr_dict_table.icl>>_package.lst
    if exist ipr\ipr_dict_list.icl echo ipr\ipr_dict_list.icl>>_package.lst
    if exist ipr\ipr_symbol.icl echo ipr\ipr_symbol.icl>>_package.lst
    if exist ipr\ipr_symbol_table.icl echo ipr\ipr_symbol_table.icl>>_package.lst
    if exist ipr\ipr_dir.icl echo ipr\ipr_dir.icl>>_package.lst
    if exist ipr\ipr_file.icl echo ipr\ipr_file.icl>>_package.lst
    if exist ipr\ipr_finfo.icl echo ipr\ipr_finfo.icl>>_package.lst
    if exist ipr\ipr_finfo_list.icl echo ipr\ipr_finfo_list.icl>>_package.lst
    if exist ipr\ipr_hash.icl echo ipr\ipr_hash.icl>>_package.lst
    if exist ipr\ipr_hash_table.icl echo ipr\ipr_hash_table.icl>>_package.lst
    if exist ipr\ipr_http.icl echo ipr\ipr_http.icl>>_package.lst
    if exist ipr\ipr_index.icl echo ipr\ipr_index.icl>>_package.lst
    if exist ipr\ipr_log.icl echo ipr\ipr_log.icl>>_package.lst
    if exist ipr\ipr_looseref.icl echo ipr\ipr_looseref.icl>>_package.lst
    if exist ipr\ipr_looseref_list.icl echo ipr\ipr_looseref_list.icl>>_package.lst
    if exist ipr\ipr_token.icl echo ipr\ipr_token.icl>>_package.lst
    if exist ipr\ipr_token_list.icl echo ipr\ipr_token_list.icl>>_package.lst
    if exist ipr\ipr_meter.icl echo ipr\ipr_meter.icl>>_package.lst
    if exist ipr\ipr_net.icl echo ipr\ipr_net.icl>>_package.lst
    if exist ipr\ipr_nonce.icl echo ipr\ipr_nonce.icl>>_package.lst
    if exist ipr\ipr_nonce_table.icl echo ipr\ipr_nonce_table.icl>>_package.lst
    if exist ipr\ipr_password.icl echo ipr\ipr_password.icl>>_package.lst
    if exist ipr\ipr_password_table.icl echo ipr\ipr_password_table.icl>>_package.lst
    if exist ipr\ipr_password_list.icl echo ipr\ipr_password_list.icl>>_package.lst
    if exist ipr\ipr_path.icl echo ipr\ipr_path.icl>>_package.lst
    if exist ipr\ipr_process.icl echo ipr\ipr_process.icl>>_package.lst
    if exist ipr\ipr_regexp.icl echo ipr\ipr_regexp.icl>>_package.lst
    if exist ipr\ipr_sasl.icl echo ipr\ipr_sasl.icl>>_package.lst
    if exist ipr\ipr_stat.icl echo ipr\ipr_stat.icl>>_package.lst
    if exist ipr\ipr_str.icl echo ipr\ipr_str.icl>>_package.lst
    if exist ipr\ipr_uid.icl echo ipr\ipr_uid.icl>>_package.lst
    if exist ipr\ipr_time.icl echo ipr\ipr_time.icl>>_package.lst
    if exist ipr\ipr_tree.icl echo ipr\ipr_tree.icl>>_package.lst
    if exist ipr\ipr_xml.icl echo ipr\ipr_xml.icl>>_package.lst
    if exist ipr\ipr_xml_list.icl echo ipr\ipr_xml_list.icl>>_package.lst
    if exist ipr\ipr_xml_attr.icl echo ipr\ipr_xml_attr.icl>>_package.lst
    if exist ipr\ipr_xml_attr_list.icl echo ipr\ipr_xml_attr_list.icl>>_package.lst
    if exist ipr\ipr_xmll.h echo ipr\ipr_xmll.h>>_package.lst
    if exist ipr\ipr_xmll.c echo ipr\ipr_xmll.c>>_package.lst
    if exist ipr\ipr_portal.icl echo ipr\ipr_portal.icl>>_package.lst
    if exist ipr\ipr_portal.gsl echo ipr\ipr_portal.gsl>>_package.lst
    if exist ipr\ipr_portal_sync.gsl echo ipr\ipr_portal_sync.gsl>>_package.lst
    if exist ipr\ipr_portal_async.gsl echo ipr\ipr_portal_async.gsl>>_package.lst
    if exist ipr\ipr_demo_portal.icl echo ipr\ipr_demo_portal.icl>>_package.lst
    if exist ipr\ipr_demo_portal_client.icl echo ipr\ipr_demo_portal_client.icl>>_package.lst
    if exist ipr\ipr_demo_portal_server.icl echo ipr\ipr_demo_portal_server.icl>>_package.lst
    if exist ipr\ipr_demo_portal_front.icl echo ipr\ipr_demo_portal_front.icl>>_package.lst
    if exist ipr\ipr_demo_portal_back.icl echo ipr\ipr_demo_portal_back.icl>>_package.lst
    if exist ipr\ipr_config_test1.xml echo ipr\ipr_config_test1.xml>>_package.lst
    if exist ipr\ipr_config_test2.xml echo ipr\ipr_config_test2.xml>>_package.lst
    if exist ipr\ipr_config_test3.xml echo ipr\ipr_config_test3.xml>>_package.lst
    if exist ipr\ipr.h echo ipr\ipr.h>>_package.lst
    if exist ipr\ipr_classes.pdl echo ipr\ipr_classes.pdl>>_package.lst
    if exist ipr\ipr_resource.pl echo ipr\ipr_resource.pl>>_package.lst
    if exist ipr\prelude.pdl echo ipr\prelude.pdl>>_package.lst
    if exist ipr\license.gpl echo ipr\license.gpl>>_package.lst
    if exist ipr\project.pdl echo ipr\project.pdl>>_package.lst
    if exist ipr\readme.txt echo ipr\readme.txt>>_package.lst
    if exist ipr\ipr_bits_test.c echo ipr\ipr_bits_test.c>>_package.lst
    if exist ipr\ipr_bits.h echo ipr\ipr_bits.h>>_package.lst
    if exist ipr\ipr_bits.c echo ipr\ipr_bits.c>>_package.lst
    if exist ipr\ipr_bucket_test.c echo ipr\ipr_bucket_test.c>>_package.lst
    if exist ipr\ipr_bucket.h echo ipr\ipr_bucket.h>>_package.lst
    if exist ipr\ipr_bucket.c echo ipr\ipr_bucket.c>>_package.lst
    if exist ipr\ipr_bucket_list_test.c echo ipr\ipr_bucket_list_test.c>>_package.lst
    if exist ipr\ipr_bucket_list.h echo ipr\ipr_bucket_list.h>>_package.lst
    if exist ipr\ipr_bucket_list.c echo ipr\ipr_bucket_list.c>>_package.lst
    if exist ipr\ipr_mother_test.c echo ipr\ipr_mother_test.c>>_package.lst
    if exist ipr\ipr_mother.h echo ipr\ipr_mother.h>>_package.lst
    if exist ipr\ipr_mother.c echo ipr\ipr_mother.c>>_package.lst
    if exist ipr\ipr_config_test.c echo ipr\ipr_config_test.c>>_package.lst
    if exist ipr\ipr_config.h echo ipr\ipr_config.h>>_package.lst
    if exist ipr\ipr_config.c echo ipr\ipr_config.c>>_package.lst
    if exist ipr\ipr_crc_test.c echo ipr\ipr_crc_test.c>>_package.lst
    if exist ipr\ipr_crc.h echo ipr\ipr_crc.h>>_package.lst
    if exist ipr\ipr_crc.c echo ipr\ipr_crc.c>>_package.lst
    if exist ipr\ipr_dict_test.c echo ipr\ipr_dict_test.c>>_package.lst
    if exist ipr\ipr_dict.h echo ipr\ipr_dict.h>>_package.lst
    if exist ipr\ipr_dict.c echo ipr\ipr_dict.c>>_package.lst
    if exist ipr\ipr_dict_table_test.c echo ipr\ipr_dict_table_test.c>>_package.lst
    if exist ipr\ipr_dict_table.h echo ipr\ipr_dict_table.h>>_package.lst
    if exist ipr\ipr_dict_table.c echo ipr\ipr_dict_table.c>>_package.lst
    if exist ipr\ipr_dict_list_test.c echo ipr\ipr_dict_list_test.c>>_package.lst
    if exist ipr\ipr_dict_list.h echo ipr\ipr_dict_list.h>>_package.lst
    if exist ipr\ipr_dict_list.c echo ipr\ipr_dict_list.c>>_package.lst
    if exist ipr\ipr_symbol_test.c echo ipr\ipr_symbol_test.c>>_package.lst
    if exist ipr\ipr_symbol.h echo ipr\ipr_symbol.h>>_package.lst
    if exist ipr\ipr_symbol.c echo ipr\ipr_symbol.c>>_package.lst
    if exist ipr\ipr_symbol_table_test.c echo ipr\ipr_symbol_table_test.c>>_package.lst
    if exist ipr\ipr_symbol_table.h echo ipr\ipr_symbol_table.h>>_package.lst
    if exist ipr\ipr_symbol_table.c echo ipr\ipr_symbol_table.c>>_package.lst
    if exist ipr\ipr_dir_test.c echo ipr\ipr_dir_test.c>>_package.lst
    if exist ipr\ipr_dir.h echo ipr\ipr_dir.h>>_package.lst
    if exist ipr\ipr_dir.c echo ipr\ipr_dir.c>>_package.lst
    if exist ipr\ipr_file_test.c echo ipr\ipr_file_test.c>>_package.lst
    if exist ipr\ipr_file.h echo ipr\ipr_file.h>>_package.lst
    if exist ipr\ipr_file.c echo ipr\ipr_file.c>>_package.lst
    if exist ipr\ipr_finfo_test.c echo ipr\ipr_finfo_test.c>>_package.lst
    if exist ipr\ipr_finfo.h echo ipr\ipr_finfo.h>>_package.lst
    if exist ipr\ipr_finfo.c echo ipr\ipr_finfo.c>>_package.lst
    if exist ipr\ipr_finfo_list_test.c echo ipr\ipr_finfo_list_test.c>>_package.lst
    if exist ipr\ipr_finfo_list.h echo ipr\ipr_finfo_list.h>>_package.lst
    if exist ipr\ipr_finfo_list.c echo ipr\ipr_finfo_list.c>>_package.lst
    if exist ipr\ipr_hash_test.c echo ipr\ipr_hash_test.c>>_package.lst
    if exist ipr\ipr_hash.h echo ipr\ipr_hash.h>>_package.lst
    if exist ipr\ipr_hash.c echo ipr\ipr_hash.c>>_package.lst
    if exist ipr\ipr_hash_table_test.c echo ipr\ipr_hash_table_test.c>>_package.lst
    if exist ipr\ipr_hash_table.h echo ipr\ipr_hash_table.h>>_package.lst
    if exist ipr\ipr_hash_table.c echo ipr\ipr_hash_table.c>>_package.lst
    if exist ipr\ipr_http_test.c echo ipr\ipr_http_test.c>>_package.lst
    if exist ipr\ipr_http.h echo ipr\ipr_http.h>>_package.lst
    if exist ipr\ipr_http.c echo ipr\ipr_http.c>>_package.lst
    if exist ipr\ipr_index_test.c echo ipr\ipr_index_test.c>>_package.lst
    if exist ipr\ipr_index.h echo ipr\ipr_index.h>>_package.lst
    if exist ipr\ipr_index.c echo ipr\ipr_index.c>>_package.lst
    if exist ipr\ipr_log_test.c echo ipr\ipr_log_test.c>>_package.lst
    if exist ipr\ipr_log.h echo ipr\ipr_log.h>>_package.lst
    if exist ipr\ipr_log.c echo ipr\ipr_log.c>>_package.lst
    if exist ipr\ipr_looseref_test.c echo ipr\ipr_looseref_test.c>>_package.lst
    if exist ipr\ipr_looseref.h echo ipr\ipr_looseref.h>>_package.lst
    if exist ipr\ipr_looseref.c echo ipr\ipr_looseref.c>>_package.lst
    if exist ipr\ipr_looseref_list_test.c echo ipr\ipr_looseref_list_test.c>>_package.lst
    if exist ipr\ipr_looseref_list.h echo ipr\ipr_looseref_list.h>>_package.lst
    if exist ipr\ipr_looseref_list.c echo ipr\ipr_looseref_list.c>>_package.lst
    if exist ipr\ipr_token_test.c echo ipr\ipr_token_test.c>>_package.lst
    if exist ipr\ipr_token.h echo ipr\ipr_token.h>>_package.lst
    if exist ipr\ipr_token.c echo ipr\ipr_token.c>>_package.lst
    if exist ipr\ipr_token_list_test.c echo ipr\ipr_token_list_test.c>>_package.lst
    if exist ipr\ipr_token_list.h echo ipr\ipr_token_list.h>>_package.lst
    if exist ipr\ipr_token_list.c echo ipr\ipr_token_list.c>>_package.lst
    if exist ipr\ipr_meter_test.c echo ipr\ipr_meter_test.c>>_package.lst
    if exist ipr\ipr_meter.h echo ipr\ipr_meter.h>>_package.lst
    if exist ipr\ipr_meter.c echo ipr\ipr_meter.c>>_package.lst
    if exist ipr\ipr_net_test.c echo ipr\ipr_net_test.c>>_package.lst
    if exist ipr\ipr_net.h echo ipr\ipr_net.h>>_package.lst
    if exist ipr\ipr_net.c echo ipr\ipr_net.c>>_package.lst
    if exist ipr\ipr_nonce_test.c echo ipr\ipr_nonce_test.c>>_package.lst
    if exist ipr\ipr_nonce.h echo ipr\ipr_nonce.h>>_package.lst
    if exist ipr\ipr_nonce.c echo ipr\ipr_nonce.c>>_package.lst
    if exist ipr\ipr_nonce_table_test.c echo ipr\ipr_nonce_table_test.c>>_package.lst
    if exist ipr\ipr_nonce_table.h echo ipr\ipr_nonce_table.h>>_package.lst
    if exist ipr\ipr_nonce_table.c echo ipr\ipr_nonce_table.c>>_package.lst
    if exist ipr\ipr_password_test.c echo ipr\ipr_password_test.c>>_package.lst
    if exist ipr\ipr_password.h echo ipr\ipr_password.h>>_package.lst
    if exist ipr\ipr_password.c echo ipr\ipr_password.c>>_package.lst
    if exist ipr\ipr_password_table_test.c echo ipr\ipr_password_table_test.c>>_package.lst
    if exist ipr\ipr_password_table.h echo ipr\ipr_password_table.h>>_package.lst
    if exist ipr\ipr_password_table.c echo ipr\ipr_password_table.c>>_package.lst
    if exist ipr\ipr_password_list_test.c echo ipr\ipr_password_list_test.c>>_package.lst
    if exist ipr\ipr_password_list.h echo ipr\ipr_password_list.h>>_package.lst
    if exist ipr\ipr_password_list.c echo ipr\ipr_password_list.c>>_package.lst
    if exist ipr\ipr_path_test.c echo ipr\ipr_path_test.c>>_package.lst
    if exist ipr\ipr_path.h echo ipr\ipr_path.h>>_package.lst
    if exist ipr\ipr_path.c echo ipr\ipr_path.c>>_package.lst
    if exist ipr\ipr_process_test.c echo ipr\ipr_process_test.c>>_package.lst
    if exist ipr\ipr_process.h echo ipr\ipr_process.h>>_package.lst
    if exist ipr\ipr_process.c echo ipr\ipr_process.c>>_package.lst
    if exist ipr\ipr_regexp_test.c echo ipr\ipr_regexp_test.c>>_package.lst
    if exist ipr\ipr_regexp.h echo ipr\ipr_regexp.h>>_package.lst
    if exist ipr\ipr_regexp.c echo ipr\ipr_regexp.c>>_package.lst
    if exist ipr\ipr_sasl_test.c echo ipr\ipr_sasl_test.c>>_package.lst
    if exist ipr\ipr_sasl.h echo ipr\ipr_sasl.h>>_package.lst
    if exist ipr\ipr_sasl.c echo ipr\ipr_sasl.c>>_package.lst
    if exist ipr\ipr_stat_test.c echo ipr\ipr_stat_test.c>>_package.lst
    if exist ipr\ipr_stat.h echo ipr\ipr_stat.h>>_package.lst
    if exist ipr\ipr_stat.c echo ipr\ipr_stat.c>>_package.lst
    if exist ipr\ipr_str_test.c echo ipr\ipr_str_test.c>>_package.lst
    if exist ipr\ipr_str.h echo ipr\ipr_str.h>>_package.lst
    if exist ipr\ipr_str.c echo ipr\ipr_str.c>>_package.lst
    if exist ipr\ipr_uid_test.c echo ipr\ipr_uid_test.c>>_package.lst
    if exist ipr\ipr_uid.h echo ipr\ipr_uid.h>>_package.lst
    if exist ipr\ipr_uid.c echo ipr\ipr_uid.c>>_package.lst
    if exist ipr\ipr_time_test.c echo ipr\ipr_time_test.c>>_package.lst
    if exist ipr\ipr_time.h echo ipr\ipr_time.h>>_package.lst
    if exist ipr\ipr_time.c echo ipr\ipr_time.c>>_package.lst
    if exist ipr\ipr_tree_test.c echo ipr\ipr_tree_test.c>>_package.lst
    if exist ipr\ipr_tree.h echo ipr\ipr_tree.h>>_package.lst
    if exist ipr\ipr_tree.c echo ipr\ipr_tree.c>>_package.lst
    if exist ipr\ipr_xml_test.c echo ipr\ipr_xml_test.c>>_package.lst
    if exist ipr\ipr_xml.h echo ipr\ipr_xml.h>>_package.lst
    if exist ipr\ipr_xml.c echo ipr\ipr_xml.c>>_package.lst
    if exist ipr\ipr_xml_list_test.c echo ipr\ipr_xml_list_test.c>>_package.lst
    if exist ipr\ipr_xml_list.h echo ipr\ipr_xml_list.h>>_package.lst
    if exist ipr\ipr_xml_list.c echo ipr\ipr_xml_list.c>>_package.lst
    if exist ipr\ipr_xml_attr_test.c echo ipr\ipr_xml_attr_test.c>>_package.lst
    if exist ipr\ipr_xml_attr.h echo ipr\ipr_xml_attr.h>>_package.lst
    if exist ipr\ipr_xml_attr.c echo ipr\ipr_xml_attr.c>>_package.lst
    if exist ipr\ipr_xml_attr_list_test.c echo ipr\ipr_xml_attr_list_test.c>>_package.lst
    if exist ipr\ipr_xml_attr_list.h echo ipr\ipr_xml_attr_list.h>>_package.lst
    if exist ipr\ipr_xml_attr_list.c echo ipr\ipr_xml_attr_list.c>>_package.lst
    if exist ipr\ipr_demo_portal_test.c echo ipr\ipr_demo_portal_test.c>>_package.lst
    if exist ipr\ipr_demo_portal.h echo ipr\ipr_demo_portal.h>>_package.lst
    if exist ipr\ipr_demo_portal.c echo ipr\ipr_demo_portal.c>>_package.lst
    if exist ipr\ipr_demo_portal_client_test.c echo ipr\ipr_demo_portal_client_test.c>>_package.lst
    if exist ipr\ipr_demo_portal_client.h echo ipr\ipr_demo_portal_client.h>>_package.lst
    if exist ipr\ipr_demo_portal_client.c echo ipr\ipr_demo_portal_client.c>>_package.lst
    if exist ipr\ipr_demo_portal_server_test.c echo ipr\ipr_demo_portal_server_test.c>>_package.lst
    if exist ipr\ipr_demo_portal_server.h echo ipr\ipr_demo_portal_server.h>>_package.lst
    if exist ipr\ipr_demo_portal_server.c echo ipr\ipr_demo_portal_server.c>>_package.lst
    if exist ipr\stamp_generate echo ipr\stamp_generate>>_package.lst
    if exist ipr\configure echo ipr\configure>>_package.lst
    if exist ipr\Makefile.unix echo ipr\Makefile.unix>>_package.lst
    if exist ipr\boomake echo ipr\boomake>>_package.lst
    if exist ipr\configure.bat echo ipr\configure.bat>>_package.lst
    if exist ipr\Makefile.win32 echo ipr\Makefile.win32>>_package.lst
    if exist ipr\boomake.bat echo ipr\boomake.bat>>_package.lst
    if exist ipr\boomakew.bat echo ipr\boomakew.bat>>_package.lst
    if exist ipr\libipr.vcproj echo ipr\libipr.vcproj>>_package.lst
    pushd smt
    popd
    if exist smt\version.h echo smt\version.h>>_package.lst
    if exist smt\icl_smt.gsl echo smt\icl_smt.gsl>>_package.lst
    if exist smt\smt_object.xnf echo smt\smt_object.xnf>>_package.lst
    if exist smt\smt_object.icl echo smt\smt_object.icl>>_package.lst
    if exist smt\smt_object_gen.gsl echo smt\smt_object_gen.gsl>>_package.lst
    if exist smt\smt_object_preproc.gsl echo smt\smt_object_preproc.gsl>>_package.lst
    if exist smt\smt_object_inherit.gsl echo smt\smt_object_inherit.gsl>>_package.lst
    if exist smt\smt_object_parse.gsl echo smt\smt_object_parse.gsl>>_package.lst
    if exist smt\smt_object_doc.txt echo smt\smt_object_doc.txt>>_package.lst
    if exist smt\smt_object_tracker.icl echo smt\smt_object_tracker.icl>>_package.lst
    if exist smt\smt.xnf echo smt\smt.xnf>>_package.lst
    if exist smt\smt_gen.gsl echo smt\smt_gen.gsl>>_package.lst
    if exist smt\smt_preproc.gsl echo smt\smt_preproc.gsl>>_package.lst
    if exist smt\smt_inherit.gsl echo smt\smt_inherit.gsl>>_package.lst
    if exist smt\smt_parse.gsl echo smt\smt_parse.gsl>>_package.lst
    if exist smt\smt_doc.txt echo smt\smt_doc.txt>>_package.lst
    if exist smt\smt_stdc.gsl echo smt\smt_stdc.gsl>>_package.lst
    if exist smt\smt_doc.gsl echo smt\smt_doc.gsl>>_package.lst
    if exist smt\smt_classes.pdl echo smt\smt_classes.pdl>>_package.lst
    if exist smt\smt_method.icl echo smt\smt_method.icl>>_package.lst
    if exist smt\smt_method_queue.icl echo smt\smt_method_queue.icl>>_package.lst
    if exist smt\smt_method_list.icl echo smt\smt_method_list.icl>>_package.lst
    if exist smt\smt_os_thread.icl echo smt\smt_os_thread.icl>>_package.lst
    if exist smt\smt_os_thread_by_status.icl echo smt\smt_os_thread_by_status.icl>>_package.lst
    if exist smt\smt_os_thread_list.icl echo smt\smt_os_thread_list.icl>>_package.lst
    if exist smt\smt_thread.icl echo smt\smt_thread.icl>>_package.lst
    if exist smt\smt_thread_by_status.icl echo smt\smt_thread_by_status.icl>>_package.lst
    if exist smt\smt_thread_list.icl echo smt\smt_thread_list.icl>>_package.lst
    if exist smt\smt_thread_queue.icl echo smt\smt_thread_queue.icl>>_package.lst
    if exist smt\smt_fileio.icl echo smt\smt_fileio.icl>>_package.lst
    if exist smt\smt_fileio_request.icl echo smt\smt_fileio_request.icl>>_package.lst
    if exist smt\smt_timer_request.icl echo smt\smt_timer_request.icl>>_package.lst
    if exist smt\smt_timer_request_list.icl echo smt\smt_timer_request_list.icl>>_package.lst
    if exist smt\smt_timer_request_by_thread.icl echo smt\smt_timer_request_by_thread.icl>>_package.lst
    if exist smt\smt_socket.icl echo smt\smt_socket.icl>>_package.lst
    if exist smt\smt_socket_request.icl echo smt\smt_socket_request.icl>>_package.lst
    if exist smt\smt_socket_request_by_thread.icl echo smt\smt_socket_request_by_thread.icl>>_package.lst
    if exist smt\smt_socket_request_by_socket.icl echo smt\smt_socket_request_by_socket.icl>>_package.lst
    if exist smt\smt_position.icl echo smt\smt_position.icl>>_package.lst
    if exist smt\smt_position_list.icl echo smt\smt_position_list.icl>>_package.lst
    if exist smt\smt_signal.icl echo smt\smt_signal.icl>>_package.lst
    if exist smt\smt_signal_table.icl echo smt\smt_signal_table.icl>>_package.lst
    if exist smt\smt_signal_by_thread.icl echo smt\smt_signal_by_thread.icl>>_package.lst
    if exist smt\smt_coremark.icl echo smt\smt_coremark.icl>>_package.lst
    if exist smt\smt_log.icl echo smt\smt_log.icl>>_package.lst
    if exist smt\smt_demo_portal.icl echo smt\smt_demo_portal.icl>>_package.lst
    if exist smt\smt_demo_portal_client.icl echo smt\smt_demo_portal_client.icl>>_package.lst
    if exist smt\smt_demo_portal_server.icl echo smt\smt_demo_portal_server.icl>>_package.lst
    if exist smt\smt_demo_portal_front.icl echo smt\smt_demo_portal_front.icl>>_package.lst
    if exist smt\smt_demo_portal_back.icl echo smt\smt_demo_portal_back.icl>>_package.lst
    if exist smt\smt_echo.smt echo smt\smt_echo.smt>>_package.lst
    if exist smt\tstnull.smt echo smt\tstnull.smt>>_package.lst
    if exist smt\tstsock.smt echo smt\tstsock.smt>>_package.lst
    if exist smt\smt_demo_timer.smt echo smt\smt_demo_timer.smt>>_package.lst
    if exist smt\smt_demo_object.icl echo smt\smt_demo_object.icl>>_package.lst
    if exist smt\smt_demo_object_action.icl echo smt\smt_demo_object_action.icl>>_package.lst
    if exist smt\smt_demo_server.smt echo smt\smt_demo_server.smt>>_package.lst
    if exist smt\smt_demo_client.smt echo smt\smt_demo_client.smt>>_package.lst
    if exist smt\smt.h echo smt\smt.h>>_package.lst
    if exist smt\icl_make_doc.ignore echo smt\icl_make_doc.ignore>>_package.lst
    if exist smt\prelude.pdl echo smt\prelude.pdl>>_package.lst
    if exist smt\license.gpl echo smt\license.gpl>>_package.lst
    if exist smt\project.pdl echo smt\project.pdl>>_package.lst
    if exist smt\readme.txt echo smt\readme.txt>>_package.lst
    if exist smt\smt_method_test.c echo smt\smt_method_test.c>>_package.lst
    if exist smt\smt_method.h echo smt\smt_method.h>>_package.lst
    if exist smt\smt_method.c echo smt\smt_method.c>>_package.lst
    if exist smt\smt_method_queue_test.c echo smt\smt_method_queue_test.c>>_package.lst
    if exist smt\smt_method_queue.h echo smt\smt_method_queue.h>>_package.lst
    if exist smt\smt_method_queue.c echo smt\smt_method_queue.c>>_package.lst
    if exist smt\smt_method_list_test.c echo smt\smt_method_list_test.c>>_package.lst
    if exist smt\smt_method_list.h echo smt\smt_method_list.h>>_package.lst
    if exist smt\smt_method_list.c echo smt\smt_method_list.c>>_package.lst
    if exist smt\smt_os_thread_test.c echo smt\smt_os_thread_test.c>>_package.lst
    if exist smt\smt_os_thread.h echo smt\smt_os_thread.h>>_package.lst
    if exist smt\smt_os_thread.c echo smt\smt_os_thread.c>>_package.lst
    if exist smt\smt_os_thread_by_status_test.c echo smt\smt_os_thread_by_status_test.c>>_package.lst
    if exist smt\smt_os_thread_by_status.h echo smt\smt_os_thread_by_status.h>>_package.lst
    if exist smt\smt_os_thread_by_status.c echo smt\smt_os_thread_by_status.c>>_package.lst
    if exist smt\smt_os_thread_list_test.c echo smt\smt_os_thread_list_test.c>>_package.lst
    if exist smt\smt_os_thread_list.h echo smt\smt_os_thread_list.h>>_package.lst
    if exist smt\smt_os_thread_list.c echo smt\smt_os_thread_list.c>>_package.lst
    if exist smt\smt_thread_test.c echo smt\smt_thread_test.c>>_package.lst
    if exist smt\smt_thread.h echo smt\smt_thread.h>>_package.lst
    if exist smt\smt_thread.c echo smt\smt_thread.c>>_package.lst
    if exist smt\smt_thread_by_status_test.c echo smt\smt_thread_by_status_test.c>>_package.lst
    if exist smt\smt_thread_by_status.h echo smt\smt_thread_by_status.h>>_package.lst
    if exist smt\smt_thread_by_status.c echo smt\smt_thread_by_status.c>>_package.lst
    if exist smt\smt_thread_list_test.c echo smt\smt_thread_list_test.c>>_package.lst
    if exist smt\smt_thread_list.h echo smt\smt_thread_list.h>>_package.lst
    if exist smt\smt_thread_list.c echo smt\smt_thread_list.c>>_package.lst
    if exist smt\smt_thread_queue_test.c echo smt\smt_thread_queue_test.c>>_package.lst
    if exist smt\smt_thread_queue.h echo smt\smt_thread_queue.h>>_package.lst
    if exist smt\smt_thread_queue.c echo smt\smt_thread_queue.c>>_package.lst
    if exist smt\smt_fileio_test.c echo smt\smt_fileio_test.c>>_package.lst
    if exist smt\smt_fileio.h echo smt\smt_fileio.h>>_package.lst
    if exist smt\smt_fileio.c echo smt\smt_fileio.c>>_package.lst
    if exist smt\smt_fileio_request_test.c echo smt\smt_fileio_request_test.c>>_package.lst
    if exist smt\smt_fileio_request.h echo smt\smt_fileio_request.h>>_package.lst
    if exist smt\smt_fileio_request.c echo smt\smt_fileio_request.c>>_package.lst
    if exist smt\smt_timer_request_test.c echo smt\smt_timer_request_test.c>>_package.lst
    if exist smt\smt_timer_request.h echo smt\smt_timer_request.h>>_package.lst
    if exist smt\smt_timer_request.c echo smt\smt_timer_request.c>>_package.lst
    if exist smt\smt_timer_request_list_test.c echo smt\smt_timer_request_list_test.c>>_package.lst
    if exist smt\smt_timer_request_list.h echo smt\smt_timer_request_list.h>>_package.lst
    if exist smt\smt_timer_request_list.c echo smt\smt_timer_request_list.c>>_package.lst
    if exist smt\smt_timer_request_by_thread_test.c echo smt\smt_timer_request_by_thread_test.c>>_package.lst
    if exist smt\smt_timer_request_by_thread.h echo smt\smt_timer_request_by_thread.h>>_package.lst
    if exist smt\smt_timer_request_by_thread.c echo smt\smt_timer_request_by_thread.c>>_package.lst
    if exist smt\smt_socket_test.c echo smt\smt_socket_test.c>>_package.lst
    if exist smt\smt_socket.h echo smt\smt_socket.h>>_package.lst
    if exist smt\smt_socket.c echo smt\smt_socket.c>>_package.lst
    if exist smt\smt_socket_request_test.c echo smt\smt_socket_request_test.c>>_package.lst
    if exist smt\smt_socket_request.h echo smt\smt_socket_request.h>>_package.lst
    if exist smt\smt_socket_request.c echo smt\smt_socket_request.c>>_package.lst
    if exist smt\smt_socket_request_by_thread_test.c echo smt\smt_socket_request_by_thread_test.c>>_package.lst
    if exist smt\smt_socket_request_by_thread.h echo smt\smt_socket_request_by_thread.h>>_package.lst
    if exist smt\smt_socket_request_by_thread.c echo smt\smt_socket_request_by_thread.c>>_package.lst
    if exist smt\smt_socket_request_by_socket_test.c echo smt\smt_socket_request_by_socket_test.c>>_package.lst
    if exist smt\smt_socket_request_by_socket.h echo smt\smt_socket_request_by_socket.h>>_package.lst
    if exist smt\smt_socket_request_by_socket.c echo smt\smt_socket_request_by_socket.c>>_package.lst
    if exist smt\smt_position_test.c echo smt\smt_position_test.c>>_package.lst
    if exist smt\smt_position.h echo smt\smt_position.h>>_package.lst
    if exist smt\smt_position.c echo smt\smt_position.c>>_package.lst
    if exist smt\smt_position_list_test.c echo smt\smt_position_list_test.c>>_package.lst
    if exist smt\smt_position_list.h echo smt\smt_position_list.h>>_package.lst
    if exist smt\smt_position_list.c echo smt\smt_position_list.c>>_package.lst
    if exist smt\smt_signal_test.c echo smt\smt_signal_test.c>>_package.lst
    if exist smt\smt_signal.h echo smt\smt_signal.h>>_package.lst
    if exist smt\smt_signal.c echo smt\smt_signal.c>>_package.lst
    if exist smt\smt_signal_table_test.c echo smt\smt_signal_table_test.c>>_package.lst
    if exist smt\smt_signal_table.h echo smt\smt_signal_table.h>>_package.lst
    if exist smt\smt_signal_table.c echo smt\smt_signal_table.c>>_package.lst
    if exist smt\smt_signal_by_thread_test.c echo smt\smt_signal_by_thread_test.c>>_package.lst
    if exist smt\smt_signal_by_thread.h echo smt\smt_signal_by_thread.h>>_package.lst
    if exist smt\smt_signal_by_thread.c echo smt\smt_signal_by_thread.c>>_package.lst
    if exist smt\smt_coremark_agent.smt echo smt\smt_coremark_agent.smt>>_package.lst
    if exist smt\smt_coremark_agent.h echo smt\smt_coremark_agent.h>>_package.lst
    if exist smt\smt_coremark_agent.c echo smt\smt_coremark_agent.c>>_package.lst
    if exist smt\smt_coremark_test.c echo smt\smt_coremark_test.c>>_package.lst
    if exist smt\smt_coremark.h echo smt\smt_coremark.h>>_package.lst
    if exist smt\smt_coremark.c echo smt\smt_coremark.c>>_package.lst
    if exist smt\smt_log_agent.smt echo smt\smt_log_agent.smt>>_package.lst
    if exist smt\smt_log_agent.h echo smt\smt_log_agent.h>>_package.lst
    if exist smt\smt_log_agent.c echo smt\smt_log_agent.c>>_package.lst
    if exist smt\smt_log_test.c echo smt\smt_log_test.c>>_package.lst
    if exist smt\smt_log.h echo smt\smt_log.h>>_package.lst
    if exist smt\smt_log.c echo smt\smt_log.c>>_package.lst
    if exist smt\smt_demo_portal_test.c echo smt\smt_demo_portal_test.c>>_package.lst
    if exist smt\smt_demo_portal.h echo smt\smt_demo_portal.h>>_package.lst
    if exist smt\smt_demo_portal.c echo smt\smt_demo_portal.c>>_package.lst
    if exist smt\smt_demo_portal_client_agent.smt echo smt\smt_demo_portal_client_agent.smt>>_package.lst
    if exist smt\smt_demo_portal_client_agent.h echo smt\smt_demo_portal_client_agent.h>>_package.lst
    if exist smt\smt_demo_portal_client_agent.c echo smt\smt_demo_portal_client_agent.c>>_package.lst
    if exist smt\smt_demo_portal_client_test.c echo smt\smt_demo_portal_client_test.c>>_package.lst
    if exist smt\smt_demo_portal_client.h echo smt\smt_demo_portal_client.h>>_package.lst
    if exist smt\smt_demo_portal_client.c echo smt\smt_demo_portal_client.c>>_package.lst
    if exist smt\smt_demo_portal_server_agent.smt echo smt\smt_demo_portal_server_agent.smt>>_package.lst
    if exist smt\smt_demo_portal_server_agent.h echo smt\smt_demo_portal_server_agent.h>>_package.lst
    if exist smt\smt_demo_portal_server_agent.c echo smt\smt_demo_portal_server_agent.c>>_package.lst
    if exist smt\smt_demo_portal_server_test.c echo smt\smt_demo_portal_server_test.c>>_package.lst
    if exist smt\smt_demo_portal_server.h echo smt\smt_demo_portal_server.h>>_package.lst
    if exist smt\smt_demo_portal_server.c echo smt\smt_demo_portal_server.c>>_package.lst
    if exist smt\smt_echo.h echo smt\smt_echo.h>>_package.lst
    if exist smt\smt_echo.c echo smt\smt_echo.c>>_package.lst
    if exist smt\tstnull.h echo smt\tstnull.h>>_package.lst
    if exist smt\tstnull.c echo smt\tstnull.c>>_package.lst
    if exist smt\tstsock.h echo smt\tstsock.h>>_package.lst
    if exist smt\tstsock.c echo smt\tstsock.c>>_package.lst
    if exist smt\smt_demo_timer.c echo smt\smt_demo_timer.c>>_package.lst
    if exist smt\smt_demo_timer.h echo smt\smt_demo_timer.h>>_package.lst
    if exist smt\smt_demo_object_agent.smt echo smt\smt_demo_object_agent.smt>>_package.lst
    if exist smt\smt_demo_object_agent.h echo smt\smt_demo_object_agent.h>>_package.lst
    if exist smt\smt_demo_object_agent.c echo smt\smt_demo_object_agent.c>>_package.lst
    if exist smt\smt_demo_object_test.c echo smt\smt_demo_object_test.c>>_package.lst
    if exist smt\smt_demo_object.h echo smt\smt_demo_object.h>>_package.lst
    if exist smt\smt_demo_object.c echo smt\smt_demo_object.c>>_package.lst
    if exist smt\smt_demo_object_action_agent.smt echo smt\smt_demo_object_action_agent.smt>>_package.lst
    if exist smt\smt_demo_object_action_agent.h echo smt\smt_demo_object_action_agent.h>>_package.lst
    if exist smt\smt_demo_object_action_agent.c echo smt\smt_demo_object_action_agent.c>>_package.lst
    if exist smt\smt_demo_object_action_test.c echo smt\smt_demo_object_action_test.c>>_package.lst
    if exist smt\smt_demo_object_action.h echo smt\smt_demo_object_action.h>>_package.lst
    if exist smt\smt_demo_object_action.c echo smt\smt_demo_object_action.c>>_package.lst
    if exist smt\smt_demo_server.h echo smt\smt_demo_server.h>>_package.lst
    if exist smt\smt_demo_server.c echo smt\smt_demo_server.c>>_package.lst
    if exist smt\smt_demo_client.h echo smt\smt_demo_client.h>>_package.lst
    if exist smt\smt_demo_client.c echo smt\smt_demo_client.c>>_package.lst
    if exist smt\stamp_generate echo smt\stamp_generate>>_package.lst
    if exist smt\configure echo smt\configure>>_package.lst
    if exist smt\Makefile.unix echo smt\Makefile.unix>>_package.lst
    if exist smt\boomake echo smt\boomake>>_package.lst
    if exist smt\configure.bat echo smt\configure.bat>>_package.lst
    if exist smt\Makefile.win32 echo smt\Makefile.win32>>_package.lst
    if exist smt\boomake.bat echo smt\boomake.bat>>_package.lst
    if exist smt\boomakew.bat echo smt\boomakew.bat>>_package.lst
    if exist smt\libsmt.vcproj echo smt\libsmt.vcproj>>_package.lst
    pushd opf
    popd
    if exist opf\version.h echo opf\version.h>>_package.lst
    if exist opf\opf_gen.gsl echo opf\opf_gen.gsl>>_package.lst
    if exist opf\opf_gen_class.gsl echo opf\opf_gen_class.gsl>>_package.lst
    if exist opf\opf_gen_docs.gsl echo opf\opf_gen_docs.gsl>>_package.lst
    if exist opf\opf_classes.pdl echo opf\opf_classes.pdl>>_package.lst
    if exist opf\example.opf echo opf\example.opf>>_package.lst
    if exist opf\prelude.pdl echo opf\prelude.pdl>>_package.lst
    if exist opf\license.gpl echo opf\license.gpl>>_package.lst
    if exist opf\project.pdl echo opf\project.pdl>>_package.lst
    if exist opf\readme.txt echo opf\readme.txt>>_package.lst
    if exist opf\example.icl echo opf\example.icl>>_package.lst
    if exist opf\example_test.c echo opf\example_test.c>>_package.lst
    if exist opf\example.h echo opf\example.h>>_package.lst
    if exist opf\example.c echo opf\example.c>>_package.lst
    if exist opf\example.txt echo opf\example.txt>>_package.lst
    if exist opf\stamp_generate echo opf\stamp_generate>>_package.lst
    if exist opf\configure echo opf\configure>>_package.lst
    if exist opf\Makefile.unix echo opf\Makefile.unix>>_package.lst
    if exist opf\boomake echo opf\boomake>>_package.lst
    if exist opf\configure.bat echo opf\configure.bat>>_package.lst
    if exist opf\Makefile.win32 echo opf\Makefile.win32>>_package.lst
    if exist opf\boomake.bat echo opf\boomake.bat>>_package.lst
    if exist opf\boomakew.bat echo opf\boomakew.bat>>_package.lst
    if exist opf\libopf.vcproj echo opf\libopf.vcproj>>_package.lst
    pushd asl
    popd
    if exist asl\version.h echo asl\version.h>>_package.lst
    if exist asl\asl.h echo asl\asl.h>>_package.lst
    if exist asl\asl.xnf echo asl\asl.xnf>>_package.lst
    if exist asl\asl_gen.gsl echo asl\asl_gen.gsl>>_package.lst
    if exist asl\asl_preproc.gsl echo asl\asl_preproc.gsl>>_package.lst
    if exist asl\asl_inherit.gsl echo asl\asl_inherit.gsl>>_package.lst
    if exist asl\asl_parse.gsl echo asl\asl_parse.gsl>>_package.lst
    if exist asl\asl_doc.txt echo asl\asl_doc.txt>>_package.lst
    if exist asl\asl_stdc.gsl echo asl\asl_stdc.gsl>>_package.lst
    if exist asl\asl_java.gsl echo asl\asl_java.gsl>>_package.lst
    if exist asl\asl_csharp.gsl echo asl\asl_csharp.gsl>>_package.lst
    if exist asl\asl_doc.gsl echo asl\asl_doc.gsl>>_package.lst
    if exist asl\asl_constants.gsl echo asl\asl_constants.gsl>>_package.lst
    if exist asl\asl_method_class.gsl echo asl\asl_method_class.gsl>>_package.lst
    if exist asl\asl_content_class.gsl echo asl\asl_content_class.gsl>>_package.lst
    if exist asl\asl_client_connection.gsl echo asl\asl_client_connection.gsl>>_package.lst
    if exist asl\asl_client_session.gsl echo asl\asl_client_session.gsl>>_package.lst
    if exist asl\asl_client_agent.gsl echo asl\asl_client_agent.gsl>>_package.lst
    if exist asl\asl_server_agent.gsl echo asl\asl_server_agent.gsl>>_package.lst
    if exist asl\asl_agent_common.gsl echo asl\asl_agent_common.gsl>>_package.lst
    if exist asl\asl_channel.icl echo asl\asl_channel.icl>>_package.lst
    if exist asl\asl_server_connection.icl echo asl\asl_server_connection.icl>>_package.lst
    if exist asl\asl_server_channel.icl echo asl\asl_server_channel.icl>>_package.lst
    if exist asl\asl_client_channel.icl echo asl\asl_client_channel.icl>>_package.lst
    if exist asl\asl_broker.icl echo asl\asl_broker.icl>>_package.lst
    if exist asl\asl_field.icl echo asl\asl_field.icl>>_package.lst
    if exist asl\asl_field_list.icl echo asl\asl_field_list.icl>>_package.lst
    if exist asl\asl_base.asl echo asl\asl_base.asl>>_package.lst
    if exist asl\asl_constants.asl echo asl\asl_constants.asl>>_package.lst
    if exist asl\asl_connection.asl echo asl\asl_connection.asl>>_package.lst
    if exist asl\asl_channel.asl echo asl\asl_channel.asl>>_package.lst
    if exist asl\asl_client.asl echo asl\asl_client.asl>>_package.lst
    if exist asl\asl_server.asl echo asl\asl_server.asl>>_package.lst
    if exist asl\asl_direct.asl echo asl\asl_direct.asl>>_package.lst
    if exist asl\demo.asl echo asl\demo.asl>>_package.lst
    if exist asl\demo_exchange.asl echo asl\demo_exchange.asl>>_package.lst
    if exist asl\demo_queue.asl echo asl\demo_queue.asl>>_package.lst
    if exist asl\demo_basic.asl echo asl\demo_basic.asl>>_package.lst
    if exist asl\demo_cli.c echo asl\demo_cli.c>>_package.lst
    if exist asl\demo_client_proto.asl echo asl\demo_client_proto.asl>>_package.lst
    if exist asl\demo_client_method.icl echo asl\demo_client_method.icl>>_package.lst
    if exist asl\demo_client_agent.smt echo asl\demo_client_agent.smt>>_package.lst
    if exist asl\demo_client_config.opf echo asl\demo_client_config.opf>>_package.lst
    if exist asl\demo_client_classes.icl echo asl\demo_client_classes.icl>>_package.lst
    if exist asl\demo_client_connection.icl echo asl\demo_client_connection.icl>>_package.lst
    if exist asl\demo_client_session.icl echo asl\demo_client_session.icl>>_package.lst
    if exist asl\demo_client_channel.icl echo asl\demo_client_channel.icl>>_package.lst
    if exist asl\demo_client_channel_table.icl echo asl\demo_client_channel_table.icl>>_package.lst
    if exist asl\demo_srv.c echo asl\demo_srv.c>>_package.lst
    if exist asl\demo_server_proto.asl echo asl\demo_server_proto.asl>>_package.lst
    if exist asl\demo_server_main.inc echo asl\demo_server_main.inc>>_package.lst
    if exist asl\demo_server_config.opf echo asl\demo_server_config.opf>>_package.lst
    if exist asl\demo_server_method.icl echo asl\demo_server_method.icl>>_package.lst
    if exist asl\demo_server_agent.smt echo asl\demo_server_agent.smt>>_package.lst
    if exist asl\demo_server_classes.icl echo asl\demo_server_classes.icl>>_package.lst
    if exist asl\demo_server_connection.icl echo asl\demo_server_connection.icl>>_package.lst
    if exist asl\demo_server_connection_table.icl echo asl\demo_server_connection_table.icl>>_package.lst
    if exist asl\demo_server_connection_list.icl echo asl\demo_server_connection_list.icl>>_package.lst
    if exist asl\demo_server_channel.icl echo asl\demo_server_channel.icl>>_package.lst
    if exist asl\demo_server_channel_agent.smt echo asl\demo_server_channel_agent.smt>>_package.lst
    if exist asl\demo_server_channel_table.icl echo asl\demo_server_channel_table.icl>>_package.lst
    if exist asl\demo_broker.icl echo asl\demo_broker.icl>>_package.lst
    if exist asl\demo_broker_agent.smt echo asl\demo_broker_agent.smt>>_package.lst
    if exist asl\demo_exchange.icl echo asl\demo_exchange.icl>>_package.lst
    if exist asl\demo_exchange_table.icl echo asl\demo_exchange_table.icl>>_package.lst
    if exist asl\demo_exchange_agent.smt echo asl\demo_exchange_agent.smt>>_package.lst
    if exist asl\demo_queue.icl echo asl\demo_queue.icl>>_package.lst
    if exist asl\demo_queue_table.icl echo asl\demo_queue_table.icl>>_package.lst
    if exist asl\demo_queue_list.icl echo asl\demo_queue_list.icl>>_package.lst
    if exist asl\demo_queue_agent.smt echo asl\demo_queue_agent.smt>>_package.lst
    if exist asl\demo_lease.icl echo asl\demo_lease.icl>>_package.lst
    if exist asl\demo_lease_table.icl echo asl\demo_lease_table.icl>>_package.lst
    if exist asl\demo_content_basic.icl echo asl\demo_content_basic.icl>>_package.lst
    if exist asl\demo_content_basic_list.icl echo asl\demo_content_basic_list.icl>>_package.lst
    if exist asl\demo_constants.icl echo asl\demo_constants.icl>>_package.lst
    if exist asl\demo_srv_resource.rc echo asl\demo_srv_resource.rc>>_package.lst
    if exist asl\demo_srv_base.cfg echo asl\demo_srv_base.cfg>>_package.lst
    if exist asl\icl_make_doc.ignore echo asl\icl_make_doc.ignore>>_package.lst
    if exist asl\prelude.pdl echo asl\prelude.pdl>>_package.lst
    if exist asl\license.gpl echo asl\license.gpl>>_package.lst
    if exist asl\project.pdl echo asl\project.pdl>>_package.lst
    if exist asl\readme.txt echo asl\readme.txt>>_package.lst
    if exist asl\asl_field_test.c echo asl\asl_field_test.c>>_package.lst
    if exist asl\asl_field.h echo asl\asl_field.h>>_package.lst
    if exist asl\asl_field.c echo asl\asl_field.c>>_package.lst
    if exist asl\asl_field_list_test.c echo asl\asl_field_list_test.c>>_package.lst
    if exist asl\asl_field_list.h echo asl\asl_field_list.h>>_package.lst
    if exist asl\asl_field_list.c echo asl\asl_field_list.c>>_package.lst
    if exist asl\demo_client_method_test.c echo asl\demo_client_method_test.c>>_package.lst
    if exist asl\demo_client_method.h echo asl\demo_client_method.h>>_package.lst
    if exist asl\demo_client_method.c echo asl\demo_client_method.c>>_package.lst
    if exist asl\demo_client_agent.h echo asl\demo_client_agent.h>>_package.lst
    if exist asl\demo_client_agent.c echo asl\demo_client_agent.c>>_package.lst
    if exist asl\demo_client_config.icl echo asl\demo_client_config.icl>>_package.lst
    if exist asl\demo_client_config_test.c echo asl\demo_client_config_test.c>>_package.lst
    if exist asl\demo_client_config.h echo asl\demo_client_config.h>>_package.lst
    if exist asl\demo_client_config.c echo asl\demo_client_config.c>>_package.lst
    if exist asl\demo_client_config.txt echo asl\demo_client_config.txt>>_package.lst
    if exist asl\demo_client_classes.h echo asl\demo_client_classes.h>>_package.lst
    if exist asl\demo_client_classes.c echo asl\demo_client_classes.c>>_package.lst
    if exist asl\demo_client_connection_test.c echo asl\demo_client_connection_test.c>>_package.lst
    if exist asl\demo_client_connection.h echo asl\demo_client_connection.h>>_package.lst
    if exist asl\demo_client_connection.c echo asl\demo_client_connection.c>>_package.lst
    if exist asl\demo_client_session_test.c echo asl\demo_client_session_test.c>>_package.lst
    if exist asl\demo_client_session.h echo asl\demo_client_session.h>>_package.lst
    if exist asl\demo_client_session.c echo asl\demo_client_session.c>>_package.lst
    if exist asl\demo_client_channel_test.c echo asl\demo_client_channel_test.c>>_package.lst
    if exist asl\demo_client_channel.h echo asl\demo_client_channel.h>>_package.lst
    if exist asl\demo_client_channel.c echo asl\demo_client_channel.c>>_package.lst
    if exist asl\demo_client_channel_table_test.c echo asl\demo_client_channel_table_test.c>>_package.lst
    if exist asl\demo_client_channel_table.h echo asl\demo_client_channel_table.h>>_package.lst
    if exist asl\demo_client_channel_table.c echo asl\demo_client_channel_table.c>>_package.lst
    if exist asl\demo_server_config.icl echo asl\demo_server_config.icl>>_package.lst
    if exist asl\demo_server_config_test.c echo asl\demo_server_config_test.c>>_package.lst
    if exist asl\demo_server_config.h echo asl\demo_server_config.h>>_package.lst
    if exist asl\demo_server_config.c echo asl\demo_server_config.c>>_package.lst
    if exist asl\demo_server_config.txt echo asl\demo_server_config.txt>>_package.lst
    if exist asl\demo_server_method_test.c echo asl\demo_server_method_test.c>>_package.lst
    if exist asl\demo_server_method.h echo asl\demo_server_method.h>>_package.lst
    if exist asl\demo_server_method.c echo asl\demo_server_method.c>>_package.lst
    if exist asl\demo_server_agent.h echo asl\demo_server_agent.h>>_package.lst
    if exist asl\demo_server_agent.c echo asl\demo_server_agent.c>>_package.lst
    if exist asl\demo_server_classes.h echo asl\demo_server_classes.h>>_package.lst
    if exist asl\demo_server_classes.c echo asl\demo_server_classes.c>>_package.lst
    if exist asl\demo_server_connection_test.c echo asl\demo_server_connection_test.c>>_package.lst
    if exist asl\demo_server_connection.h echo asl\demo_server_connection.h>>_package.lst
    if exist asl\demo_server_connection.c echo asl\demo_server_connection.c>>_package.lst
    if exist asl\demo_server_connection_table_test.c echo asl\demo_server_connection_table_test.c>>_package.lst
    if exist asl\demo_server_connection_table.h echo asl\demo_server_connection_table.h>>_package.lst
    if exist asl\demo_server_connection_table.c echo asl\demo_server_connection_table.c>>_package.lst
    if exist asl\demo_server_connection_list_test.c echo asl\demo_server_connection_list_test.c>>_package.lst
    if exist asl\demo_server_connection_list.h echo asl\demo_server_connection_list.h>>_package.lst
    if exist asl\demo_server_connection_list.c echo asl\demo_server_connection_list.c>>_package.lst
    if exist asl\demo_server_channel_test.c echo asl\demo_server_channel_test.c>>_package.lst
    if exist asl\demo_server_channel.h echo asl\demo_server_channel.h>>_package.lst
    if exist asl\demo_server_channel.c echo asl\demo_server_channel.c>>_package.lst
    if exist asl\demo_server_channel_agent.h echo asl\demo_server_channel_agent.h>>_package.lst
    if exist asl\demo_server_channel_agent.c echo asl\demo_server_channel_agent.c>>_package.lst
    if exist asl\demo_server_channel_table_test.c echo asl\demo_server_channel_table_test.c>>_package.lst
    if exist asl\demo_server_channel_table.h echo asl\demo_server_channel_table.h>>_package.lst
    if exist asl\demo_server_channel_table.c echo asl\demo_server_channel_table.c>>_package.lst
    if exist asl\demo_broker_test.c echo asl\demo_broker_test.c>>_package.lst
    if exist asl\demo_broker.h echo asl\demo_broker.h>>_package.lst
    if exist asl\demo_broker.c echo asl\demo_broker.c>>_package.lst
    if exist asl\demo_broker_agent.h echo asl\demo_broker_agent.h>>_package.lst
    if exist asl\demo_broker_agent.c echo asl\demo_broker_agent.c>>_package.lst
    if exist asl\demo_exchange_test.c echo asl\demo_exchange_test.c>>_package.lst
    if exist asl\demo_exchange.h echo asl\demo_exchange.h>>_package.lst
    if exist asl\demo_exchange.c echo asl\demo_exchange.c>>_package.lst
    if exist asl\demo_exchange_table_test.c echo asl\demo_exchange_table_test.c>>_package.lst
    if exist asl\demo_exchange_table.h echo asl\demo_exchange_table.h>>_package.lst
    if exist asl\demo_exchange_table.c echo asl\demo_exchange_table.c>>_package.lst
    if exist asl\demo_exchange_agent.h echo asl\demo_exchange_agent.h>>_package.lst
    if exist asl\demo_exchange_agent.c echo asl\demo_exchange_agent.c>>_package.lst
    if exist asl\demo_queue_test.c echo asl\demo_queue_test.c>>_package.lst
    if exist asl\demo_queue.h echo asl\demo_queue.h>>_package.lst
    if exist asl\demo_queue.c echo asl\demo_queue.c>>_package.lst
    if exist asl\demo_queue_table_test.c echo asl\demo_queue_table_test.c>>_package.lst
    if exist asl\demo_queue_table.h echo asl\demo_queue_table.h>>_package.lst
    if exist asl\demo_queue_table.c echo asl\demo_queue_table.c>>_package.lst
    if exist asl\demo_queue_list_test.c echo asl\demo_queue_list_test.c>>_package.lst
    if exist asl\demo_queue_list.h echo asl\demo_queue_list.h>>_package.lst
    if exist asl\demo_queue_list.c echo asl\demo_queue_list.c>>_package.lst
    if exist asl\demo_queue_agent.h echo asl\demo_queue_agent.h>>_package.lst
    if exist asl\demo_queue_agent.c echo asl\demo_queue_agent.c>>_package.lst
    if exist asl\demo_lease_test.c echo asl\demo_lease_test.c>>_package.lst
    if exist asl\demo_lease.h echo asl\demo_lease.h>>_package.lst
    if exist asl\demo_lease.c echo asl\demo_lease.c>>_package.lst
    if exist asl\demo_lease_table_test.c echo asl\demo_lease_table_test.c>>_package.lst
    if exist asl\demo_lease_table.h echo asl\demo_lease_table.h>>_package.lst
    if exist asl\demo_lease_table.c echo asl\demo_lease_table.c>>_package.lst
    if exist asl\demo_content_basic_test.c echo asl\demo_content_basic_test.c>>_package.lst
    if exist asl\demo_content_basic.h echo asl\demo_content_basic.h>>_package.lst
    if exist asl\demo_content_basic.c echo asl\demo_content_basic.c>>_package.lst
    if exist asl\demo_content_basic_list_test.c echo asl\demo_content_basic_list_test.c>>_package.lst
    if exist asl\demo_content_basic_list.h echo asl\demo_content_basic_list.h>>_package.lst
    if exist asl\demo_content_basic_list.c echo asl\demo_content_basic_list.c>>_package.lst
    if exist asl\demo_constants.h echo asl\demo_constants.h>>_package.lst
    if exist asl\demo_constants.c echo asl\demo_constants.c>>_package.lst
    if exist asl\demo_srv_resource.icl echo asl\demo_srv_resource.icl>>_package.lst
    if exist asl\demo_srv_resource_test.c echo asl\demo_srv_resource_test.c>>_package.lst
    if exist asl\demo_srv_resource.h echo asl\demo_srv_resource.h>>_package.lst
    if exist asl\demo_srv_resource.c echo asl\demo_srv_resource.c>>_package.lst
    if exist asl\stamp_generate echo asl\stamp_generate>>_package.lst
    if exist asl\configure echo asl\configure>>_package.lst
    if exist asl\Makefile.unix echo asl\Makefile.unix>>_package.lst
    if exist asl\boomake echo asl\boomake>>_package.lst
    if exist asl\configure.bat echo asl\configure.bat>>_package.lst
    if exist asl\Makefile.win32 echo asl\Makefile.win32>>_package.lst
    if exist asl\boomake.bat echo asl\boomake.bat>>_package.lst
    if exist asl\boomakew.bat echo asl\boomakew.bat>>_package.lst
    if exist asl\libasl.vcproj echo asl\libasl.vcproj>>_package.lst
    if exist asl\pal\asl_pal.gsl echo asl\pal\asl_pal.gsl>>_package.lst
    if exist asl\pal\asl_pal_stdc.gsl echo asl\pal\asl_pal_stdc.gsl>>_package.lst
    if exist asl\pal\asl_pal_xnf.gsl echo asl\pal\asl_pal_xnf.gsl>>_package.lst
    if exist asl\pal\asl_pal_txt.gsl echo asl\pal\asl_pal_txt.gsl>>_package.lst
    if exist asl\pal\palguide.txt echo asl\pal\palguide.txt>>_package.lst
    if exist asl\pal\pal echo asl\pal\pal>>_package.lst
    if exist asl\pal\pal.bat echo asl\pal\pal.bat>>_package.lst
    if exist asl\pal\demo_pal.xnf echo asl\pal\demo_pal.xnf>>_package.lst
    if exist asl\pal\demo_pal_stdc.gsl echo asl\pal\demo_pal_stdc.gsl>>_package.lst
    if exist asl\pal\demo_pal_codegen.gsl echo asl\pal\demo_pal_codegen.gsl>>_package.lst
    if exist asl\pal\demo_pal_gen.gsl echo asl\pal\demo_pal_gen.gsl>>_package.lst
    if exist asl\pal\demo_pal_inherit.gsl echo asl\pal\demo_pal_inherit.gsl>>_package.lst
    if exist asl\pal\demo_pal_parse.gsl echo asl\pal\demo_pal_parse.gsl>>_package.lst
    if exist asl\pal\demo_pal_preproc.gsl echo asl\pal\demo_pal_preproc.gsl>>_package.lst
    if exist asl\pal\hello.pal echo asl\pal\hello.pal>>_package.lst
    if exist asl\pal\loop1.pal echo asl\pal\loop1.pal>>_package.lst
    if exist asl\pal\loop2.pal echo asl\pal\loop2.pal>>_package.lst
    if exist asl\pal\content.pal echo asl\pal\content.pal>>_package.lst
    if exist asl\pal\macros.pal echo asl\pal\macros.pal>>_package.lst
    if exist asl\pal\session.pal echo asl\pal\session.pal>>_package.lst
    if exist asl\pal\single.pal echo asl\pal\single.pal>>_package.lst
    if exist asl\pal\single2.pal echo asl\pal\single2.pal>>_package.lst
    if exist asl\pal\symbols.pal echo asl\pal\symbols.pal>>_package.lst
    if exist asl\pal\waiting.pal echo asl\pal\waiting.pal>>_package.lst
    if exist asl\pal\content_file.pal echo asl\pal\content_file.pal>>_package.lst
    if exist asl\pal\content_exec.pal echo asl\pal\content_exec.pal>>_package.lst
    if exist asl\pal\content_body.pal echo asl\pal\content_body.pal>>_package.lst
    if exist asl\pal\cmdline.pal echo asl\pal\cmdline.pal>>_package.lst
    if exist asl\pal\webserver.pal echo asl\pal\webserver.pal>>_package.lst
    if exist asl\pal\stress.pal echo asl\pal\stress.pal>>_package.lst
    if exist asl\pal\im_read.pal echo asl\pal\im_read.pal>>_package.lst
    if exist asl\pal\im_send.pal echo asl\pal\im_send.pal>>_package.lst
    if exist asl\pal\palguide*.html echo asl\pal\palguide*.html>>_package.lst
    pushd http
    popd
    if exist http\version.h echo http\version.h>>_package.lst
    if exist http\http_config.opf echo http\http_config.opf>>_package.lst
    if exist http\http_main.inc echo http\http_main.inc>>_package.lst
    if exist http\http_address.icl echo http\http_address.icl>>_package.lst
    if exist http\http_address_table.icl echo http\http_address_table.icl>>_package.lst
    if exist http\http_request.icl echo http\http_request.icl>>_package.lst
    if exist http\http_response.icl echo http\http_response.icl>>_package.lst
    if exist http\http_driver_module.icl echo http\http_driver_module.icl>>_package.lst
    if exist http\http_access_module.icl echo http\http_access_module.icl>>_package.lst
    if exist http\http_driver_context.icl echo http\http_driver_context.icl>>_package.lst
    if exist http\http_access_context.icl echo http\http_access_context.icl>>_package.lst
    if exist http\http_driver_file.icl echo http\http_driver_file.icl>>_package.lst
    if exist http\http_driver_cgi.icl echo http\http_driver_cgi.icl>>_package.lst
    if exist http\http_driver_null.icl echo http\http_driver_null.icl>>_package.lst
    if exist http\http_access_logger.icl echo http\http_access_logger.icl>>_package.lst
    if exist http\http_access_policy.icl echo http\http_access_policy.icl>>_package.lst
    if exist http\http_access_refresh.icl echo http\http_access_refresh.icl>>_package.lst
    if exist http\http_access_dos.icl echo http\http_access_dos.icl>>_package.lst
    if exist http\http_refresh.pl echo http\http_refresh.pl>>_package.lst
    if exist http\http_agent.smt echo http\http_agent.smt>>_package.lst
    if exist http\http_server.icl echo http\http_server.icl>>_package.lst
    if exist http\http.icl echo http\http.icl>>_package.lst
    if exist http\http_static.rc echo http\http_static.rc>>_package.lst
    if exist http\http_base.cfg echo http\http_base.cfg>>_package.lst
    if exist http\http_base.css echo http\http_base.css>>_package.lst
    if exist http\httpd.c echo http\httpd.c>>_package.lst
    if exist http\prelude.pdl echo http\prelude.pdl>>_package.lst
    if exist http\license.gpl echo http\license.gpl>>_package.lst
    if exist http\project.pdl echo http\project.pdl>>_package.lst
    if exist http\readme.txt echo http\readme.txt>>_package.lst
    if exist http\http_config.icl echo http\http_config.icl>>_package.lst
    if exist http\http_config_test.c echo http\http_config_test.c>>_package.lst
    if exist http\http_config.h echo http\http_config.h>>_package.lst
    if exist http\http_config.c echo http\http_config.c>>_package.lst
    if exist http\http_config.txt echo http\http_config.txt>>_package.lst
    if exist http\http_address_test.c echo http\http_address_test.c>>_package.lst
    if exist http\http_address.h echo http\http_address.h>>_package.lst
    if exist http\http_address.c echo http\http_address.c>>_package.lst
    if exist http\http_address_table_test.c echo http\http_address_table_test.c>>_package.lst
    if exist http\http_address_table.h echo http\http_address_table.h>>_package.lst
    if exist http\http_address_table.c echo http\http_address_table.c>>_package.lst
    if exist http\http_request_test.c echo http\http_request_test.c>>_package.lst
    if exist http\http_request.h echo http\http_request.h>>_package.lst
    if exist http\http_request.c echo http\http_request.c>>_package.lst
    if exist http\http_response_test.c echo http\http_response_test.c>>_package.lst
    if exist http\http_response.h echo http\http_response.h>>_package.lst
    if exist http\http_response.c echo http\http_response.c>>_package.lst
    if exist http\http_driver_module_front.icl echo http\http_driver_module_front.icl>>_package.lst
    if exist http\http_driver_module_back.icl echo http\http_driver_module_back.icl>>_package.lst
    if exist http\http_driver_module_test.c echo http\http_driver_module_test.c>>_package.lst
    if exist http\http_driver_module.h echo http\http_driver_module.h>>_package.lst
    if exist http\http_driver_module.c echo http\http_driver_module.c>>_package.lst
    if exist http\http_access_module_front.icl echo http\http_access_module_front.icl>>_package.lst
    if exist http\http_access_module_back.icl echo http\http_access_module_back.icl>>_package.lst
    if exist http\http_access_module_test.c echo http\http_access_module_test.c>>_package.lst
    if exist http\http_access_module.h echo http\http_access_module.h>>_package.lst
    if exist http\http_access_module.c echo http\http_access_module.c>>_package.lst
    if exist http\http_driver_context_test.c echo http\http_driver_context_test.c>>_package.lst
    if exist http\http_driver_context.h echo http\http_driver_context.h>>_package.lst
    if exist http\http_driver_context.c echo http\http_driver_context.c>>_package.lst
    if exist http\http_access_context_test.c echo http\http_access_context_test.c>>_package.lst
    if exist http\http_access_context.h echo http\http_access_context.h>>_package.lst
    if exist http\http_access_context.c echo http\http_access_context.c>>_package.lst
    if exist http\http_driver_file_agent.smt echo http\http_driver_file_agent.smt>>_package.lst
    if exist http\http_driver_file_agent.h echo http\http_driver_file_agent.h>>_package.lst
    if exist http\http_driver_file_agent.c echo http\http_driver_file_agent.c>>_package.lst
    if exist http\http_driver_file_test.c echo http\http_driver_file_test.c>>_package.lst
    if exist http\http_driver_file.h echo http\http_driver_file.h>>_package.lst
    if exist http\http_driver_file.c echo http\http_driver_file.c>>_package.lst
    if exist http\http_driver_cgi_agent.smt echo http\http_driver_cgi_agent.smt>>_package.lst
    if exist http\http_driver_cgi_agent.h echo http\http_driver_cgi_agent.h>>_package.lst
    if exist http\http_driver_cgi_agent.c echo http\http_driver_cgi_agent.c>>_package.lst
    if exist http\http_driver_cgi_test.c echo http\http_driver_cgi_test.c>>_package.lst
    if exist http\http_driver_cgi.h echo http\http_driver_cgi.h>>_package.lst
    if exist http\http_driver_cgi.c echo http\http_driver_cgi.c>>_package.lst
    if exist http\http_driver_null_agent.smt echo http\http_driver_null_agent.smt>>_package.lst
    if exist http\http_driver_null_agent.h echo http\http_driver_null_agent.h>>_package.lst
    if exist http\http_driver_null_agent.c echo http\http_driver_null_agent.c>>_package.lst
    if exist http\http_driver_null_test.c echo http\http_driver_null_test.c>>_package.lst
    if exist http\http_driver_null.h echo http\http_driver_null.h>>_package.lst
    if exist http\http_driver_null.c echo http\http_driver_null.c>>_package.lst
    if exist http\http_access_logger_agent.smt echo http\http_access_logger_agent.smt>>_package.lst
    if exist http\http_access_logger_agent.h echo http\http_access_logger_agent.h>>_package.lst
    if exist http\http_access_logger_agent.c echo http\http_access_logger_agent.c>>_package.lst
    if exist http\http_access_logger_test.c echo http\http_access_logger_test.c>>_package.lst
    if exist http\http_access_logger.h echo http\http_access_logger.h>>_package.lst
    if exist http\http_access_logger.c echo http\http_access_logger.c>>_package.lst
    if exist http\http_access_policy_agent.smt echo http\http_access_policy_agent.smt>>_package.lst
    if exist http\http_access_policy_agent.h echo http\http_access_policy_agent.h>>_package.lst
    if exist http\http_access_policy_agent.c echo http\http_access_policy_agent.c>>_package.lst
    if exist http\http_access_policy_test.c echo http\http_access_policy_test.c>>_package.lst
    if exist http\http_access_policy.h echo http\http_access_policy.h>>_package.lst
    if exist http\http_access_policy.c echo http\http_access_policy.c>>_package.lst
    if exist http\http_access_refresh_agent.smt echo http\http_access_refresh_agent.smt>>_package.lst
    if exist http\http_access_refresh_agent.h echo http\http_access_refresh_agent.h>>_package.lst
    if exist http\http_access_refresh_agent.c echo http\http_access_refresh_agent.c>>_package.lst
    if exist http\http_access_refresh_test.c echo http\http_access_refresh_test.c>>_package.lst
    if exist http\http_access_refresh.h echo http\http_access_refresh.h>>_package.lst
    if exist http\http_access_refresh.c echo http\http_access_refresh.c>>_package.lst
    if exist http\http_access_dos_agent.smt echo http\http_access_dos_agent.smt>>_package.lst
    if exist http\http_access_dos_agent.h echo http\http_access_dos_agent.h>>_package.lst
    if exist http\http_access_dos_agent.c echo http\http_access_dos_agent.c>>_package.lst
    if exist http\http_access_dos_test.c echo http\http_access_dos_test.c>>_package.lst
    if exist http\http_access_dos.h echo http\http_access_dos.h>>_package.lst
    if exist http\http_access_dos.c echo http\http_access_dos.c>>_package.lst
    if exist http\http_agent.h echo http\http_agent.h>>_package.lst
    if exist http\http_agent.c echo http\http_agent.c>>_package.lst
    if exist http\http_server_agent.smt echo http\http_server_agent.smt>>_package.lst
    if exist http\http_server_agent.h echo http\http_server_agent.h>>_package.lst
    if exist http\http_server_agent.c echo http\http_server_agent.c>>_package.lst
    if exist http\http_server_test.c echo http\http_server_test.c>>_package.lst
    if exist http\http_server.h echo http\http_server.h>>_package.lst
    if exist http\http_server.c echo http\http_server.c>>_package.lst
    if exist http\http.h echo http\http.h>>_package.lst
    if exist http\http.c echo http\http.c>>_package.lst
    if exist http\http_static.icl echo http\http_static.icl>>_package.lst
    if exist http\http_static_test.c echo http\http_static_test.c>>_package.lst
    if exist http\http_static.h echo http\http_static.h>>_package.lst
    if exist http\http_static.c echo http\http_static.c>>_package.lst
    if exist http\stamp_generate echo http\stamp_generate>>_package.lst
    if exist http\configure echo http\configure>>_package.lst
    if exist http\Makefile.unix echo http\Makefile.unix>>_package.lst
    if exist http\boomake echo http\boomake>>_package.lst
    if exist http\configure.bat echo http\configure.bat>>_package.lst
    if exist http\Makefile.win32 echo http\Makefile.win32>>_package.lst
    if exist http\boomake.bat echo http\boomake.bat>>_package.lst
    if exist http\boomakew.bat echo http\boomakew.bat>>_package.lst
    if exist http\libhttp.vcproj echo http\libhttp.vcproj>>_package.lst
    if exist http\webpages\default.html echo http\webpages\default.html>>_package.lst
    if exist http\webpages\default.css echo http\webpages\default.css>>_package.lst
    pushd xitami
    popd
    if exist xitami\version.h echo xitami\version.h>>_package.lst
    if exist xitami\xitami.c echo xitami\xitami.c>>_package.lst
    if exist xitami\prelude.pdl echo xitami\prelude.pdl>>_package.lst
    if exist xitami\license.gpl echo xitami\license.gpl>>_package.lst
    if exist xitami\project.pdl echo xitami\project.pdl>>_package.lst
    if exist xitami\readme.txt echo xitami\readme.txt>>_package.lst
    if exist xitami\stamp_generate echo xitami\stamp_generate>>_package.lst
    if exist xitami\configure echo xitami\configure>>_package.lst
    if exist xitami\Makefile.unix echo xitami\Makefile.unix>>_package.lst
    if exist xitami\boomake echo xitami\boomake>>_package.lst
    if exist xitami\configure.bat echo xitami\configure.bat>>_package.lst
    if exist xitami\Makefile.win32 echo xitami\Makefile.win32>>_package.lst
    if exist xitami\boomake.bat echo xitami\boomake.bat>>_package.lst
    if exist xitami\boomakew.bat echo xitami\boomakew.bat>>_package.lst
    if exist xitami\xitami.vcproj echo xitami\xitami.vcproj>>_package.lst
    if exist xitami\liblocal.vcproj echo xitami\liblocal.vcproj>>_package.lst
    if exist xitami\webpages\default.html echo xitami\webpages\default.html>>_package.lst
    if exist xitami\webpages\default.css echo xitami\webpages\default.css>>_package.lst
    echo "Source package successfully generated">xnf\stamp_source
    echo "xnf\stamp_source">>_package.lst
    echo "Source package successfully generated">icl\stamp_source
    echo "icl\stamp_source">>_package.lst
    echo "Source package successfully generated">ipr\stamp_source
    echo "ipr\stamp_source">>_package.lst
    echo "Source package successfully generated">smt\stamp_source
    echo "smt\stamp_source">>_package.lst
    echo "Source package successfully generated">opf\stamp_source
    echo "opf\stamp_source">>_package.lst
    echo "Source package successfully generated">asl\stamp_source
    echo "asl\stamp_source">>_package.lst
    echo "Source package successfully generated">http\stamp_source
    echo "http\stamp_source">>_package.lst
    echo "Source package successfully generated">xitami\stamp_source
    echo "xitami\stamp_source">>_package.lst
    echo "Source package successfully generated">stamp_source
    echo "stamp_source">>_package.lst
    echo boom I: [base2]: Building base2-!MY_VERSION!-src.zip...
    zip  -rq _package -@<_package.lst
    unzip -q _package -d base2-!MY_VERSION!
    if exist  base2-!MY_VERSION!-src.zip del base2-!MY_VERSION!-src.zip
    zip -rmq base2-!MY_VERSION!-src.zip base2-!MY_VERSION!
    del _package.zip
    del _package.lst
    del stamp_source
    del xnf\stamp_source
    del icl\stamp_source
    del ipr\stamp_source
    del smt\stamp_source
    del opf\stamp_source
    del asl\stamp_source
    del http\stamp_source
    del xitami\stamp_source
    goto :eof

:-----------------------------   BUILD PROJECTS   -----------------------------

:a_build_projects
    if exist _install\nul rmdir /s /q _install
    mkdir _install
    mkdir _install\lib
    mkdir _install\include
    mkdir _install\bin
    pushd xnf
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake -install ..\_install build install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    goto :eof

:-------------------------   CHECK OPERATING CONTEXT   ------------------------

:a_check_operating_context
    set event=repository
    if exist stamp_source   set event=source
    if exist stamp_stripped set event=stripped
    goto :eof

:-----------------------------   CLEAN PROJECTS   -----------------------------

:a_clean_projects
    if exist _install\nul rmdir /s /q _install
    pushd xnf
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake clean
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    goto :eof

:----------------------------   COMPILE PROJECTS   ----------------------------

:a_compile_projects
    pushd xnf
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake compile
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    goto :eof

:----------------------------   INSTALL PROJECTS   ----------------------------

:a_install_projects
    pushd xnf
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake install
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    if exist installer.bat (
    if "!BOOM_TRACE!"=="1" echo installer
    verify>nul
    call installer
    if errorlevel 1 (
        echo boom E: [base2]: 'installer' failed - stop.
        set _exception=1
        goto :eof
    )
    )
    goto :eof

:-----------------------------   REGEN PROJECTS   -----------------------------

:a_regen_projects
    pushd xnf
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake regen
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    goto :eof

:-------------------------   REPORT HELP INFORMATION   ------------------------

:a_report_help_information
    echo The commands you can currently use on this project are:
    echo.
    goto r_!state!
    goto :eof

:-------------------------   REPORT PROJECT VERSION   -------------------------

:a_report_project_version
    echo base2-2.3
    goto :eof

:------------------------------   TEST PROJECTS   -----------------------------

:a_test_projects
    pushd xnf
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd icl
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd ipr
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd smt
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd opf
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd asl
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd http
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    pushd xitami
    if exist boomake.bat (
        call boomake test
    ) else (
        echo boom E: [base2]: project is not configured - run 'boom configure'
    )
    popd
    if exist selftest.bat (
    if "!BOOM_TRACE!"=="1" echo selftest
    verify>nul
    call selftest
    if errorlevel 1 (
        echo boom E: [base2]: 'selftest' failed - stop.
        set _exception=1
        goto :eof
    )
    )
    goto :eof

:-----------------------   USE SOURCE CONTROL REVISION   ----------------------

:a_use_source_control_revision
    set SVN_REVISION=svn
    if exist .svn
ul (
        for /f "usebackq tokens=1,2 delims=: " %%v in (`svn info`) do if "%%v"=="Revision" set SVN_REVISION=%%w
    )
    set MY_VERSION=!MY_VERSION!-!SVN_REVISION!
    goto :eof

:s_initial
    if "!debug!"=="1" echo State: initial
    if "!event!"=="" goto s_1_empty
    if "!event!"=="ok" goto s_1_1
    goto s_win32
:s_1_1
    if "!debug!"=="1" echo Event: ok
    set event=
    if "!debug!"=="1" echo Action: check operating context
    set _exception=
    call :a_check_operating_context
    if "!_exception!"=="1" exit /b 1
    set state=initial_check
    goto s_!state!
:s_1_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_initial
:r_initial
    goto r_win32

:s_initial_check
    if "!debug!"=="1" echo State: initial check
    if "!event!"=="" goto s_2_empty
    if "!event!"=="repository" goto s_2_1
    if "!event!"=="source" goto s_2_2
    if "!event!"=="stripped" goto s_2_3
    goto s_win32
:s_2_1
    if "!debug!"=="1" echo Event: repository
    set event=
    set state=repository
    goto s_!state!
:s_2_2
    if "!debug!"=="1" echo Event: source
    set event=
    set state=source
    goto s_!state!
:s_2_3
    if "!debug!"=="1" echo Event: stripped
    set event=
    set state=stripped
    goto s_!state!
:s_2_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_initial_check
:r_initial_check
    goto r_win32

:s_repository
    if "!debug!"=="1" echo State: repository
    if "!event!"=="" goto s_3_empty
    if "!event!"=="build" goto s_3_1
    if "!event!"=="compile" goto s_3_2
    if "!event!"=="clean" goto s_3_3
    if "!event!"=="regen" goto s_3_4
    if "!event!"=="allgen" goto s_3_5
    if "!event!"=="distrib" goto s_3_6
    if "!event!"=="distsrc" goto s_3_7
    if "!event!"=="distrev" goto s_3_8
    goto s_default
:s_3_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: build projects
    set _exception=
    call :a_build_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_2
    if "!debug!"=="1" echo Event: compile
    set event=
    if "!debug!"=="1" echo Action: compile projects
    set _exception=
    call :a_compile_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_3
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: clean projects
    set _exception=
    call :a_clean_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_4
    if "!debug!"=="1" echo Event: regen
    set event=
    if "!debug!"=="1" echo Action: regen projects
    set _exception=
    call :a_regen_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_5
    if "!debug!"=="1" echo Event: allgen
    set event=
    if "!debug!"=="1" echo Action: allgen projects
    set _exception=
    call :a_allgen_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_6
    if "!debug!"=="1" echo Event: distrib
    set event=
    if "!debug!"=="1" echo Action: build projects
    set _exception=
    call :a_build_projects
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build product source packages
    set _exception=
    call :a_build_product_source_packages
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build product install packages
    set _exception=
    call :a_build_product_install_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_7
    if "!debug!"=="1" echo Event: distsrc
    set event=
    if "!debug!"=="1" echo Action: allgen projects
    set _exception=
    call :a_allgen_projects
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build product source packages
    set _exception=
    call :a_build_product_source_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_8
    if "!debug!"=="1" echo Event: distrev
    set event=
    if "!debug!"=="1" echo Action: allgen projects
    set _exception=
    call :a_allgen_projects
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: use source control revision
    set _exception=
    call :a_use_source_control_revision
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build product source packages
    set _exception=
    call :a_build_product_source_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_repository
:r_repository
echo build:
    echo   For each project in the product, regenerate code and build binary
    echo     files ready for installation.  The projects are built in their
    echo     individual directories and installed into the temporary install tree.
echo compile:
    echo   For each project in the product, build binary files ready for installation,
    echo     but don't run the code generation phase .  The projects are built in their
    echo     individual directories and installed into the temporary install tree.
echo clean:
    echo   Deletes generated project files.  This action removes generated source
    echo     and binary files.
echo regen:
    echo   For each project in the product, regenerate any source files that
    echo     are produced via GSL, Libero or another code generation tool.
    echo     Generates only those files that are required to build under
    echo     the current model.
echo allgen:
    echo   For each project in the product, regenerate any source files that
    echo     are produced via GSL, Libero or another code generation tool.
    echo     Generates all files.
echo distrib:
    echo   Build all projects and create full distribution packages.  If you do
    echo     not want to rebuild the projects, you can use the 'distsrc' and 'distbin'
    echo     actions as shortcuts.
echo distsrc:
    echo   Build source distribution packages based on product version number.
echo distrev:
    echo   Build source distribution packages based on source control revision
    echo     number.
    goto r_default

:s_source
    if "!debug!"=="1" echo State: source
    if "!event!"=="" goto s_4_empty
    if "!event!"=="build" goto s_4_1
    if "!event!"=="clean" goto s_4_2
    if "!event!"=="regen" goto s_4_3
    if "!event!"=="allgen" goto s_4_4
    goto s_default
:s_4_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: build projects
    set _exception=
    call :a_build_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_2
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: clean projects
    set _exception=
    call :a_clean_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_3
    if "!debug!"=="1" echo Event: regen
    set event=
    if "!debug!"=="1" echo Action: regen projects
    set _exception=
    call :a_regen_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_4
    if "!debug!"=="1" echo Event: allgen
    set event=
    if "!debug!"=="1" echo Action: allgen projects
    set _exception=
    call :a_allgen_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_source
:r_source
echo build:
    echo   For each project in the product, build binary files ready for
    echo     installation.  The projects are built in their individual directories
    echo     and installed into the temporary install tree.
echo clean:
    echo   Deletes generated project files.  This action removes generated binary
    echo     files.
echo regen:
    echo   For each project in the product, regenerate any source files that
    echo     are produced via GSL, Libero or another code generation tool.
    echo     Generates only those files that are required to build under
    echo     the current model.
echo allgen:
    echo   For each project in the product, regenerate any source files that
    echo     are produced via GSL, Libero or another code generation tool.
    echo     Generates all files.
    goto r_default

:s_stripped
    if "!debug!"=="1" echo State: stripped
    if "!event!"=="" goto s_5_empty
    if "!event!"=="build" goto s_5_1
    if "!event!"=="clean" goto s_5_2
    goto s_default
:s_5_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: build projects
    set _exception=
    call :a_build_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_5_2
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: clean projects
    set _exception=
    call :a_clean_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_5_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_stripped
:r_stripped
echo build:
    echo   For each project in the product, build binary files ready for
    echo     installation.  The projects are built in their individual directories
    echo     and installed into the temporary install tree.
echo clean:
    echo   Deletes generated project files.  This action removes generated binary
    echo     files.
    goto r_default

:s_default
    if "!debug!"=="1" echo State: default
    if "!event!"=="" goto s_6_empty
    if "!event!"=="install" goto s_6_1
    if "!event!"=="distbin" goto s_6_2
    if "!event!"=="test" goto s_6_3
    if "!event!"=="help" goto s_6_4
    if "!event!"=="version" goto s_6_5
    if "!event!"=="empty" goto s_6_6
    goto s_win32
:s_6_1
    if "!debug!"=="1" echo Event: install
    set event=
    if "!debug!"=="1" echo Action: install projects
    set _exception=
    call :a_install_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_2
    if "!debug!"=="1" echo Event: distbin
    set event=
    if "!debug!"=="1" echo Action: build product install packages
    set _exception=
    call :a_build_product_install_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_3
    if "!debug!"=="1" echo Event: test
    set event=
    if "!debug!"=="1" echo Action: test projects
    set _exception=
    call :a_test_projects
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_4
    if "!debug!"=="1" echo Event: help
    set event=
    if "!debug!"=="1" echo Action: report help information
    set _exception=
    call :a_report_help_information
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_5
    if "!debug!"=="1" echo Event: version
    set event=
    if "!debug!"=="1" echo Action: report project version
    set _exception=
    call :a_report_project_version
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_6
    if "!debug!"=="1" echo Event: empty
    set event=
    if "!debug!"=="1" echo Action: report help information
    set _exception=
    call :a_report_help_information
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_default
:r_default
echo install:
    echo   Install each project into its target directory.  The projects must
    echo     have been built (and installed into the temporary install tree, which
    echo     is what the build action does).
echo distbin:
    echo   Build binary distribution packages.  The actual packages built depend on
    echo     the project packagers used, but typically you will get a ZIP or TGZ file
    echo     containing all the projects' deliverables.  Note that this action works
    echo     entirely from the temporary install tree, which the 'build' action makes.
echo test:
    echo   Runs each project's test process.
echo help:
    echo   Shows a list of the commands allowed on the project.
echo version:
    echo   Show product version.
    goto r_win32


exit /b 0
