@echo off
:-
:-  Boom builder for iPR 1.0a1
:-  Generated by iMatix Boom from standard.pwl
:-  
:-  Copyright (c) 1996-2009 iMatix Corporation
:-  All rights reserved.
:-  
:-  This file is licensed under the BSD license as follows:
:-  
:-  Redistribution and use in source and binary forms, with or without
:-  modification, are permitted provided that the following conditions
:-  are met:
:-  
:-  * Redistributions of source code must retain the above copyright
:-    notice, this list of conditions and the following disclaimer.
:-  * Redistributions in binary form must reproduce the above copyright
:-    notice, this list of conditions and the following disclaimer in
:-    the documentation and/or other materials provided with the
:-    distribution.
:-  * Neither the name of iMatix Corporation nor the names of its
:-    contributors may be used to endorse or promote products derived
:-    from this software without specific prior written permission.
:-  
:-  THIS SOFTWARE IS PROVIDED BY IMATIX CORPORATION "AS IS" AND ANY
:-  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
:-  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
:-  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL IMATIX CORPORATION BE
:-  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
:-  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
:-  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
:-  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
:-  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
:-  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
:-  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
:-
:-  Start CMD.EXE version detection
verify other 2>nul
setlocal enableextensions
if errorlevel 0 goto __cmd_ok
echo %0: This command requires command extensions version 2 in CMD.EXE.  
echo %0: Please use a supported system (Windows 2000 or newer).
exit
:__cmd_ok
setlocal enabledelayedexpansion
:-  End CMD.EXE version detection
goto :init
:-
:-  Subroutine: boom_model_init
:-  Initialises BOOM_MODEL to default if not set
:-  Expands BOOM_MODEL components into individual environment variables
:-
:boom_model_init
if "!BOOM_MODEL!"=="" (
    set BOOM_MODEL=release,st
)
set BOOM_MODEL__PLACEHOLDER=1
for /f "usebackq delims==" %%v in (`set BOOM_MODEL_`) do set %%v=
set BOOM_MODEL__PLACEHOLDER=
for %%m in (!BOOM_MODEL!) do set BOOM_MODEL_%%m=1
:-  If the user set BOOM_MODEL but did not include release/debug or st/mt
:-  set these to defaults.
if not "!BOOM_MODEL_RELEASE!"=="1" (
    if not "!BOOM_MODEL_DEBUG!"=="1" (
        set BOOM_MODEL_RELEASE=1
        set BOOM_MODEL=!BOOM_MODEL!,release
    )
)
if not "!BOOM_MODEL_ST!"=="1" (
    if not "!BOOM_MODEL_MT!"=="1" (
        set BOOM_MODEL_ST=1
        set BOOM_MODEL=!BOOM_MODEL!,st
    )
)
goto :eof
:init
setlocal
:-
:-  Set environment variables to point to install location
:-  Start by using final IBASE, then handle -install path
set self=%0
set MY_VERSION=1.0a1
set OLDPATH=!PATH!
set OLDPERLLIB=!PERLLIB!
if .!IBASE!==. (
    echo boom E: [ipr]: The IBASE variable is not set.             Please set it to the location where iPR should be installed.
    exit /b 1
)
if .%1==.-v (
    set BOOM_TRACE=1
    shift
)
call :boom_model_init
if .%1==.-install goto tempinst
:-  Normal use, use IBASE
    set PATH=!IBASE!\bin;!PATH!
    set PERLLIB=!IBASE!\bin;!PERLLIB!
    set INCDIR_ALT=!IBASE!\include
    set _INSTALL_ROOT=!IBASE!
    goto process

:tempinst
:-  Building product, we use -install directory first, then IBASE
    if not exist %2 (
       echo "Invalid command syntax - please contact imatix-tech"
       exit /b 1
    )
    pushd %2
    set _LOCAL_BASE=!cd!
    popd
    set PATH=!_LOCAL_BASE!\bin;!IBASE!\bin;!PATH!
    set PERLLIB=!_LOCAL_BASE!\bin;!IBASE!\bin;!PERLLIB!
    set INCDIR_ALT=!_LOCAL_BASE!\include;!IBASE!\include
    set _INSTALL_ROOT=!_LOCAL_BASE!
    shift
    shift
    goto process

:batch
    shift

:process
    set state=initial
    set event=ok
    set debug=0
    goto s_!state!

:---------------------------   BUILD BINARY FILES   ---------------------------

:a_build_binary_files
    goto :eof

:--------------------------   BUILD SOURCE PACKAGES   -------------------------

:a_build_source_packages
   if exist _package.lst del _package.lst
    if exist ipr\version.h echo ipr\version.h>>_package.lst
    if exist ipr\ipr_bits.icl echo ipr\ipr_bits.icl>>_package.lst
    if exist ipr\ipr_bucket.icl echo ipr\ipr_bucket.icl>>_package.lst
    if exist ipr\ipr_bucket_list.icl echo ipr\ipr_bucket_list.icl>>_package.lst
    if exist ipr\ipr_mother.icl echo ipr\ipr_mother.icl>>_package.lst
    if exist ipr\ipr_config.icl echo ipr\ipr_config.icl>>_package.lst
    if exist ipr\ipr_crc.icl echo ipr\ipr_crc.icl>>_package.lst
    if exist ipr\ipr_dict.icl echo ipr\ipr_dict.icl>>_package.lst
    if exist ipr\ipr_dict_table.icl echo ipr\ipr_dict_table.icl>>_package.lst
    if exist ipr\ipr_dict_list.icl echo ipr\ipr_dict_list.icl>>_package.lst
    if exist ipr\ipr_symbol.icl echo ipr\ipr_symbol.icl>>_package.lst
    if exist ipr\ipr_symbol_table.icl echo ipr\ipr_symbol_table.icl>>_package.lst
    if exist ipr\ipr_dir.icl echo ipr\ipr_dir.icl>>_package.lst
    if exist ipr\ipr_file.icl echo ipr\ipr_file.icl>>_package.lst
    if exist ipr\ipr_finfo.icl echo ipr\ipr_finfo.icl>>_package.lst
    if exist ipr\ipr_finfo_list.icl echo ipr\ipr_finfo_list.icl>>_package.lst
    if exist ipr\ipr_hash.icl echo ipr\ipr_hash.icl>>_package.lst
    if exist ipr\ipr_hash_table.icl echo ipr\ipr_hash_table.icl>>_package.lst
    if exist ipr\ipr_http.icl echo ipr\ipr_http.icl>>_package.lst
    if exist ipr\ipr_index.icl echo ipr\ipr_index.icl>>_package.lst
    if exist ipr\ipr_log.icl echo ipr\ipr_log.icl>>_package.lst
    if exist ipr\ipr_looseref.icl echo ipr\ipr_looseref.icl>>_package.lst
    if exist ipr\ipr_looseref_list.icl echo ipr\ipr_looseref_list.icl>>_package.lst
    if exist ipr\ipr_token.icl echo ipr\ipr_token.icl>>_package.lst
    if exist ipr\ipr_token_list.icl echo ipr\ipr_token_list.icl>>_package.lst
    if exist ipr\ipr_meter.icl echo ipr\ipr_meter.icl>>_package.lst
    if exist ipr\ipr_net.icl echo ipr\ipr_net.icl>>_package.lst
    if exist ipr\ipr_nonce.icl echo ipr\ipr_nonce.icl>>_package.lst
    if exist ipr\ipr_nonce_table.icl echo ipr\ipr_nonce_table.icl>>_package.lst
    if exist ipr\ipr_password.icl echo ipr\ipr_password.icl>>_package.lst
    if exist ipr\ipr_password_table.icl echo ipr\ipr_password_table.icl>>_package.lst
    if exist ipr\ipr_password_list.icl echo ipr\ipr_password_list.icl>>_package.lst
    if exist ipr\ipr_path.icl echo ipr\ipr_path.icl>>_package.lst
    if exist ipr\ipr_process.icl echo ipr\ipr_process.icl>>_package.lst
    if exist ipr\ipr_regexp.icl echo ipr\ipr_regexp.icl>>_package.lst
    if exist ipr\ipr_sasl.icl echo ipr\ipr_sasl.icl>>_package.lst
    if exist ipr\ipr_stat.icl echo ipr\ipr_stat.icl>>_package.lst
    if exist ipr\ipr_str.icl echo ipr\ipr_str.icl>>_package.lst
    if exist ipr\ipr_uid.icl echo ipr\ipr_uid.icl>>_package.lst
    if exist ipr\ipr_time.icl echo ipr\ipr_time.icl>>_package.lst
    if exist ipr\ipr_tree.icl echo ipr\ipr_tree.icl>>_package.lst
    if exist ipr\ipr_xml.icl echo ipr\ipr_xml.icl>>_package.lst
    if exist ipr\ipr_xml_list.icl echo ipr\ipr_xml_list.icl>>_package.lst
    if exist ipr\ipr_xml_attr.icl echo ipr\ipr_xml_attr.icl>>_package.lst
    if exist ipr\ipr_xml_attr_list.icl echo ipr\ipr_xml_attr_list.icl>>_package.lst
    if exist ipr\ipr_xmll.h echo ipr\ipr_xmll.h>>_package.lst
    if exist ipr\ipr_xmll.c echo ipr\ipr_xmll.c>>_package.lst
    if exist ipr\ipr_portal.icl echo ipr\ipr_portal.icl>>_package.lst
    if exist ipr\ipr_portal.gsl echo ipr\ipr_portal.gsl>>_package.lst
    if exist ipr\ipr_portal_sync.gsl echo ipr\ipr_portal_sync.gsl>>_package.lst
    if exist ipr\ipr_portal_async.gsl echo ipr\ipr_portal_async.gsl>>_package.lst
    if exist ipr\ipr_demo_portal.icl echo ipr\ipr_demo_portal.icl>>_package.lst
    if exist ipr\ipr_demo_portal_client.icl echo ipr\ipr_demo_portal_client.icl>>_package.lst
    if exist ipr\ipr_demo_portal_server.icl echo ipr\ipr_demo_portal_server.icl>>_package.lst
    if exist ipr\ipr_demo_portal_front.icl echo ipr\ipr_demo_portal_front.icl>>_package.lst
    if exist ipr\ipr_demo_portal_back.icl echo ipr\ipr_demo_portal_back.icl>>_package.lst
    if exist ipr\ipr_config_test1.xml echo ipr\ipr_config_test1.xml>>_package.lst
    if exist ipr\ipr_config_test2.xml echo ipr\ipr_config_test2.xml>>_package.lst
    if exist ipr\ipr_config_test3.xml echo ipr\ipr_config_test3.xml>>_package.lst
    if exist ipr\ipr.h echo ipr\ipr.h>>_package.lst
    if exist ipr\ipr_classes.pdl echo ipr\ipr_classes.pdl>>_package.lst
    if exist ipr\ipr_resource.pl echo ipr\ipr_resource.pl>>_package.lst
    if exist ipr\prelude.pdl echo ipr\prelude.pdl>>_package.lst
    if exist ipr\license.gpl echo ipr\license.gpl>>_package.lst
    if exist ipr\project.pdl echo ipr\project.pdl>>_package.lst
    if exist ipr\readme.txt echo ipr\readme.txt>>_package.lst
    if exist ipr\ipr_bits_test.c echo ipr\ipr_bits_test.c>>_package.lst
    if exist ipr\ipr_bits.h echo ipr\ipr_bits.h>>_package.lst
    if exist ipr\ipr_bits.c echo ipr\ipr_bits.c>>_package.lst
    if exist ipr\ipr_bucket_test.c echo ipr\ipr_bucket_test.c>>_package.lst
    if exist ipr\ipr_bucket.h echo ipr\ipr_bucket.h>>_package.lst
    if exist ipr\ipr_bucket.c echo ipr\ipr_bucket.c>>_package.lst
    if exist ipr\ipr_bucket_list_test.c echo ipr\ipr_bucket_list_test.c>>_package.lst
    if exist ipr\ipr_bucket_list.h echo ipr\ipr_bucket_list.h>>_package.lst
    if exist ipr\ipr_bucket_list.c echo ipr\ipr_bucket_list.c>>_package.lst
    if exist ipr\ipr_mother_test.c echo ipr\ipr_mother_test.c>>_package.lst
    if exist ipr\ipr_mother.h echo ipr\ipr_mother.h>>_package.lst
    if exist ipr\ipr_mother.c echo ipr\ipr_mother.c>>_package.lst
    if exist ipr\ipr_config_test.c echo ipr\ipr_config_test.c>>_package.lst
    if exist ipr\ipr_config.h echo ipr\ipr_config.h>>_package.lst
    if exist ipr\ipr_config.c echo ipr\ipr_config.c>>_package.lst
    if exist ipr\ipr_crc_test.c echo ipr\ipr_crc_test.c>>_package.lst
    if exist ipr\ipr_crc.h echo ipr\ipr_crc.h>>_package.lst
    if exist ipr\ipr_crc.c echo ipr\ipr_crc.c>>_package.lst
    if exist ipr\ipr_dict_test.c echo ipr\ipr_dict_test.c>>_package.lst
    if exist ipr\ipr_dict.h echo ipr\ipr_dict.h>>_package.lst
    if exist ipr\ipr_dict.c echo ipr\ipr_dict.c>>_package.lst
    if exist ipr\ipr_dict_table_test.c echo ipr\ipr_dict_table_test.c>>_package.lst
    if exist ipr\ipr_dict_table.h echo ipr\ipr_dict_table.h>>_package.lst
    if exist ipr\ipr_dict_table.c echo ipr\ipr_dict_table.c>>_package.lst
    if exist ipr\ipr_dict_list_test.c echo ipr\ipr_dict_list_test.c>>_package.lst
    if exist ipr\ipr_dict_list.h echo ipr\ipr_dict_list.h>>_package.lst
    if exist ipr\ipr_dict_list.c echo ipr\ipr_dict_list.c>>_package.lst
    if exist ipr\ipr_symbol_test.c echo ipr\ipr_symbol_test.c>>_package.lst
    if exist ipr\ipr_symbol.h echo ipr\ipr_symbol.h>>_package.lst
    if exist ipr\ipr_symbol.c echo ipr\ipr_symbol.c>>_package.lst
    if exist ipr\ipr_symbol_table_test.c echo ipr\ipr_symbol_table_test.c>>_package.lst
    if exist ipr\ipr_symbol_table.h echo ipr\ipr_symbol_table.h>>_package.lst
    if exist ipr\ipr_symbol_table.c echo ipr\ipr_symbol_table.c>>_package.lst
    if exist ipr\ipr_dir_test.c echo ipr\ipr_dir_test.c>>_package.lst
    if exist ipr\ipr_dir.h echo ipr\ipr_dir.h>>_package.lst
    if exist ipr\ipr_dir.c echo ipr\ipr_dir.c>>_package.lst
    if exist ipr\ipr_file_test.c echo ipr\ipr_file_test.c>>_package.lst
    if exist ipr\ipr_file.h echo ipr\ipr_file.h>>_package.lst
    if exist ipr\ipr_file.c echo ipr\ipr_file.c>>_package.lst
    if exist ipr\ipr_finfo_test.c echo ipr\ipr_finfo_test.c>>_package.lst
    if exist ipr\ipr_finfo.h echo ipr\ipr_finfo.h>>_package.lst
    if exist ipr\ipr_finfo.c echo ipr\ipr_finfo.c>>_package.lst
    if exist ipr\ipr_finfo_list_test.c echo ipr\ipr_finfo_list_test.c>>_package.lst
    if exist ipr\ipr_finfo_list.h echo ipr\ipr_finfo_list.h>>_package.lst
    if exist ipr\ipr_finfo_list.c echo ipr\ipr_finfo_list.c>>_package.lst
    if exist ipr\ipr_hash_test.c echo ipr\ipr_hash_test.c>>_package.lst
    if exist ipr\ipr_hash.h echo ipr\ipr_hash.h>>_package.lst
    if exist ipr\ipr_hash.c echo ipr\ipr_hash.c>>_package.lst
    if exist ipr\ipr_hash_table_test.c echo ipr\ipr_hash_table_test.c>>_package.lst
    if exist ipr\ipr_hash_table.h echo ipr\ipr_hash_table.h>>_package.lst
    if exist ipr\ipr_hash_table.c echo ipr\ipr_hash_table.c>>_package.lst
    if exist ipr\ipr_http_test.c echo ipr\ipr_http_test.c>>_package.lst
    if exist ipr\ipr_http.h echo ipr\ipr_http.h>>_package.lst
    if exist ipr\ipr_http.c echo ipr\ipr_http.c>>_package.lst
    if exist ipr\ipr_index_test.c echo ipr\ipr_index_test.c>>_package.lst
    if exist ipr\ipr_index.h echo ipr\ipr_index.h>>_package.lst
    if exist ipr\ipr_index.c echo ipr\ipr_index.c>>_package.lst
    if exist ipr\ipr_log_test.c echo ipr\ipr_log_test.c>>_package.lst
    if exist ipr\ipr_log.h echo ipr\ipr_log.h>>_package.lst
    if exist ipr\ipr_log.c echo ipr\ipr_log.c>>_package.lst
    if exist ipr\ipr_looseref_test.c echo ipr\ipr_looseref_test.c>>_package.lst
    if exist ipr\ipr_looseref.h echo ipr\ipr_looseref.h>>_package.lst
    if exist ipr\ipr_looseref.c echo ipr\ipr_looseref.c>>_package.lst
    if exist ipr\ipr_looseref_list_test.c echo ipr\ipr_looseref_list_test.c>>_package.lst
    if exist ipr\ipr_looseref_list.h echo ipr\ipr_looseref_list.h>>_package.lst
    if exist ipr\ipr_looseref_list.c echo ipr\ipr_looseref_list.c>>_package.lst
    if exist ipr\ipr_token_test.c echo ipr\ipr_token_test.c>>_package.lst
    if exist ipr\ipr_token.h echo ipr\ipr_token.h>>_package.lst
    if exist ipr\ipr_token.c echo ipr\ipr_token.c>>_package.lst
    if exist ipr\ipr_token_list_test.c echo ipr\ipr_token_list_test.c>>_package.lst
    if exist ipr\ipr_token_list.h echo ipr\ipr_token_list.h>>_package.lst
    if exist ipr\ipr_token_list.c echo ipr\ipr_token_list.c>>_package.lst
    if exist ipr\ipr_meter_test.c echo ipr\ipr_meter_test.c>>_package.lst
    if exist ipr\ipr_meter.h echo ipr\ipr_meter.h>>_package.lst
    if exist ipr\ipr_meter.c echo ipr\ipr_meter.c>>_package.lst
    if exist ipr\ipr_net_test.c echo ipr\ipr_net_test.c>>_package.lst
    if exist ipr\ipr_net.h echo ipr\ipr_net.h>>_package.lst
    if exist ipr\ipr_net.c echo ipr\ipr_net.c>>_package.lst
    if exist ipr\ipr_nonce_test.c echo ipr\ipr_nonce_test.c>>_package.lst
    if exist ipr\ipr_nonce.h echo ipr\ipr_nonce.h>>_package.lst
    if exist ipr\ipr_nonce.c echo ipr\ipr_nonce.c>>_package.lst
    if exist ipr\ipr_nonce_table_test.c echo ipr\ipr_nonce_table_test.c>>_package.lst
    if exist ipr\ipr_nonce_table.h echo ipr\ipr_nonce_table.h>>_package.lst
    if exist ipr\ipr_nonce_table.c echo ipr\ipr_nonce_table.c>>_package.lst
    if exist ipr\ipr_password_test.c echo ipr\ipr_password_test.c>>_package.lst
    if exist ipr\ipr_password.h echo ipr\ipr_password.h>>_package.lst
    if exist ipr\ipr_password.c echo ipr\ipr_password.c>>_package.lst
    if exist ipr\ipr_password_table_test.c echo ipr\ipr_password_table_test.c>>_package.lst
    if exist ipr\ipr_password_table.h echo ipr\ipr_password_table.h>>_package.lst
    if exist ipr\ipr_password_table.c echo ipr\ipr_password_table.c>>_package.lst
    if exist ipr\ipr_password_list_test.c echo ipr\ipr_password_list_test.c>>_package.lst
    if exist ipr\ipr_password_list.h echo ipr\ipr_password_list.h>>_package.lst
    if exist ipr\ipr_password_list.c echo ipr\ipr_password_list.c>>_package.lst
    if exist ipr\ipr_path_test.c echo ipr\ipr_path_test.c>>_package.lst
    if exist ipr\ipr_path.h echo ipr\ipr_path.h>>_package.lst
    if exist ipr\ipr_path.c echo ipr\ipr_path.c>>_package.lst
    if exist ipr\ipr_process_test.c echo ipr\ipr_process_test.c>>_package.lst
    if exist ipr\ipr_process.h echo ipr\ipr_process.h>>_package.lst
    if exist ipr\ipr_process.c echo ipr\ipr_process.c>>_package.lst
    if exist ipr\ipr_regexp_test.c echo ipr\ipr_regexp_test.c>>_package.lst
    if exist ipr\ipr_regexp.h echo ipr\ipr_regexp.h>>_package.lst
    if exist ipr\ipr_regexp.c echo ipr\ipr_regexp.c>>_package.lst
    if exist ipr\ipr_sasl_test.c echo ipr\ipr_sasl_test.c>>_package.lst
    if exist ipr\ipr_sasl.h echo ipr\ipr_sasl.h>>_package.lst
    if exist ipr\ipr_sasl.c echo ipr\ipr_sasl.c>>_package.lst
    if exist ipr\ipr_stat_test.c echo ipr\ipr_stat_test.c>>_package.lst
    if exist ipr\ipr_stat.h echo ipr\ipr_stat.h>>_package.lst
    if exist ipr\ipr_stat.c echo ipr\ipr_stat.c>>_package.lst
    if exist ipr\ipr_str_test.c echo ipr\ipr_str_test.c>>_package.lst
    if exist ipr\ipr_str.h echo ipr\ipr_str.h>>_package.lst
    if exist ipr\ipr_str.c echo ipr\ipr_str.c>>_package.lst
    if exist ipr\ipr_uid_test.c echo ipr\ipr_uid_test.c>>_package.lst
    if exist ipr\ipr_uid.h echo ipr\ipr_uid.h>>_package.lst
    if exist ipr\ipr_uid.c echo ipr\ipr_uid.c>>_package.lst
    if exist ipr\ipr_time_test.c echo ipr\ipr_time_test.c>>_package.lst
    if exist ipr\ipr_time.h echo ipr\ipr_time.h>>_package.lst
    if exist ipr\ipr_time.c echo ipr\ipr_time.c>>_package.lst
    if exist ipr\ipr_tree_test.c echo ipr\ipr_tree_test.c>>_package.lst
    if exist ipr\ipr_tree.h echo ipr\ipr_tree.h>>_package.lst
    if exist ipr\ipr_tree.c echo ipr\ipr_tree.c>>_package.lst
    if exist ipr\ipr_xml_test.c echo ipr\ipr_xml_test.c>>_package.lst
    if exist ipr\ipr_xml.h echo ipr\ipr_xml.h>>_package.lst
    if exist ipr\ipr_xml.c echo ipr\ipr_xml.c>>_package.lst
    if exist ipr\ipr_xml_list_test.c echo ipr\ipr_xml_list_test.c>>_package.lst
    if exist ipr\ipr_xml_list.h echo ipr\ipr_xml_list.h>>_package.lst
    if exist ipr\ipr_xml_list.c echo ipr\ipr_xml_list.c>>_package.lst
    if exist ipr\ipr_xml_attr_test.c echo ipr\ipr_xml_attr_test.c>>_package.lst
    if exist ipr\ipr_xml_attr.h echo ipr\ipr_xml_attr.h>>_package.lst
    if exist ipr\ipr_xml_attr.c echo ipr\ipr_xml_attr.c>>_package.lst
    if exist ipr\ipr_xml_attr_list_test.c echo ipr\ipr_xml_attr_list_test.c>>_package.lst
    if exist ipr\ipr_xml_attr_list.h echo ipr\ipr_xml_attr_list.h>>_package.lst
    if exist ipr\ipr_xml_attr_list.c echo ipr\ipr_xml_attr_list.c>>_package.lst
    if exist ipr\ipr_demo_portal_test.c echo ipr\ipr_demo_portal_test.c>>_package.lst
    if exist ipr\ipr_demo_portal.h echo ipr\ipr_demo_portal.h>>_package.lst
    if exist ipr\ipr_demo_portal.c echo ipr\ipr_demo_portal.c>>_package.lst
    if exist ipr\ipr_demo_portal_client_test.c echo ipr\ipr_demo_portal_client_test.c>>_package.lst
    if exist ipr\ipr_demo_portal_client.h echo ipr\ipr_demo_portal_client.h>>_package.lst
    if exist ipr\ipr_demo_portal_client.c echo ipr\ipr_demo_portal_client.c>>_package.lst
    if exist ipr\ipr_demo_portal_server_test.c echo ipr\ipr_demo_portal_server_test.c>>_package.lst
    if exist ipr\ipr_demo_portal_server.h echo ipr\ipr_demo_portal_server.h>>_package.lst
    if exist ipr\ipr_demo_portal_server.c echo ipr\ipr_demo_portal_server.c>>_package.lst
    if exist ipr\stamp_generate echo ipr\stamp_generate>>_package.lst
    if exist ipr\configure echo ipr\configure>>_package.lst
    if exist ipr\Makefile.unix echo ipr\Makefile.unix>>_package.lst
    if exist ipr\boomake echo ipr\boomake>>_package.lst
    if exist ipr\configure.bat echo ipr\configure.bat>>_package.lst
    if exist ipr\Makefile.win32 echo ipr\Makefile.win32>>_package.lst
    if exist ipr\boomake.bat echo ipr\boomake.bat>>_package.lst
    if exist ipr\boomakew.bat echo ipr\boomakew.bat>>_package.lst
    if exist ipr\libipr.vcproj echo ipr\libipr.vcproj>>_package.lst
    echo "Source package successfully generated">stamp_source
    echo "stamp_source">>_package.lst
    echo boom I: [ipr]: Building ipr-!MY_VERSION!-src.zip...
    zip  -rq _package -@<_package.lst
    unzip -q _package -d ipr-!MY_VERSION!
    if exist  ipr-!MY_VERSION!-src.zip del ipr-!MY_VERSION!-src.zip
    zip -rmq ipr-!MY_VERSION!-src.zip ipr-!MY_VERSION!
    del _package.zip
    del _package.lst
    del stamp_source
    goto :eof

:----------------------   CHECK ALL SOURCE FILES EXIST   ----------------------

:a_check_all_source_files_exist
    if not exist version.h (
        echo boom E: [ipr]: version.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.icl (
        echo boom E: [ipr]: ipr_bits.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.icl (
        echo boom E: [ipr]: ipr_bucket.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.icl (
        echo boom E: [ipr]: ipr_bucket_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.icl (
        echo boom E: [ipr]: ipr_mother.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.icl (
        echo boom E: [ipr]: ipr_config.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.icl (
        echo boom E: [ipr]: ipr_crc.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.icl (
        echo boom E: [ipr]: ipr_dict.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.icl (
        echo boom E: [ipr]: ipr_dict_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.icl (
        echo boom E: [ipr]: ipr_dict_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.icl (
        echo boom E: [ipr]: ipr_symbol.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.icl (
        echo boom E: [ipr]: ipr_symbol_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.icl (
        echo boom E: [ipr]: ipr_dir.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.icl (
        echo boom E: [ipr]: ipr_file.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.icl (
        echo boom E: [ipr]: ipr_finfo.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.icl (
        echo boom E: [ipr]: ipr_finfo_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.icl (
        echo boom E: [ipr]: ipr_hash.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.icl (
        echo boom E: [ipr]: ipr_hash_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.icl (
        echo boom E: [ipr]: ipr_http.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.icl (
        echo boom E: [ipr]: ipr_index.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.icl (
        echo boom E: [ipr]: ipr_log.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.icl (
        echo boom E: [ipr]: ipr_looseref.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.icl (
        echo boom E: [ipr]: ipr_looseref_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.icl (
        echo boom E: [ipr]: ipr_token.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.icl (
        echo boom E: [ipr]: ipr_token_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.icl (
        echo boom E: [ipr]: ipr_meter.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.icl (
        echo boom E: [ipr]: ipr_net.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.icl (
        echo boom E: [ipr]: ipr_nonce.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.icl (
        echo boom E: [ipr]: ipr_nonce_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.icl (
        echo boom E: [ipr]: ipr_password.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.icl (
        echo boom E: [ipr]: ipr_password_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.icl (
        echo boom E: [ipr]: ipr_password_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.icl (
        echo boom E: [ipr]: ipr_path.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.icl (
        echo boom E: [ipr]: ipr_process.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.icl (
        echo boom E: [ipr]: ipr_regexp.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.icl (
        echo boom E: [ipr]: ipr_sasl.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.icl (
        echo boom E: [ipr]: ipr_stat.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.icl (
        echo boom E: [ipr]: ipr_str.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.icl (
        echo boom E: [ipr]: ipr_uid.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.icl (
        echo boom E: [ipr]: ipr_time.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.icl (
        echo boom E: [ipr]: ipr_tree.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.icl (
        echo boom E: [ipr]: ipr_xml.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.icl (
        echo boom E: [ipr]: ipr_xml_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.icl (
        echo boom E: [ipr]: ipr_xml_attr.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.icl (
        echo boom E: [ipr]: ipr_xml_attr_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.h (
        echo boom E: [ipr]: ipr_xmll.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.c (
        echo boom E: [ipr]: ipr_xmll.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.icl (
        echo boom E: [ipr]: ipr_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.gsl (
        echo boom E: [ipr]: ipr_portal.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_sync.gsl (
        echo boom E: [ipr]: ipr_portal_sync.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_async.gsl (
        echo boom E: [ipr]: ipr_portal_async.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.icl (
        echo boom E: [ipr]: ipr_demo_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.icl (
        echo boom E: [ipr]: ipr_demo_portal_client.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.icl (
        echo boom E: [ipr]: ipr_demo_portal_server.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_front.icl (
        echo boom E: [ipr]: ipr_demo_portal_front.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_back.icl (
        echo boom E: [ipr]: ipr_demo_portal_back.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test1.xml (
        echo boom E: [ipr]: ipr_config_test1.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test2.xml (
        echo boom E: [ipr]: ipr_config_test2.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test3.xml (
        echo boom E: [ipr]: ipr_config_test3.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr.h (
        echo boom E: [ipr]: ipr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_classes.pdl (
        echo boom E: [ipr]: ipr_classes.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_resource.pl (
        echo boom E: [ipr]: ipr_resource.pl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist project.pdl (
        echo boom E: [ipr]: project.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist readme.txt (
        echo boom E: [ipr]: readme.txt is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits_test.c (
        echo boom E: [ipr]: ipr_bits_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.h (
        echo boom E: [ipr]: ipr_bits.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.c (
        echo boom E: [ipr]: ipr_bits.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_test.c (
        echo boom E: [ipr]: ipr_bucket_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.h (
        echo boom E: [ipr]: ipr_bucket.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.c (
        echo boom E: [ipr]: ipr_bucket.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list_test.c (
        echo boom E: [ipr]: ipr_bucket_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.h (
        echo boom E: [ipr]: ipr_bucket_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.c (
        echo boom E: [ipr]: ipr_bucket_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother_test.c (
        echo boom E: [ipr]: ipr_mother_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.h (
        echo boom E: [ipr]: ipr_mother.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.c (
        echo boom E: [ipr]: ipr_mother.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test.c (
        echo boom E: [ipr]: ipr_config_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.h (
        echo boom E: [ipr]: ipr_config.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.c (
        echo boom E: [ipr]: ipr_config.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc_test.c (
        echo boom E: [ipr]: ipr_crc_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.h (
        echo boom E: [ipr]: ipr_crc.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.c (
        echo boom E: [ipr]: ipr_crc.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_test.c (
        echo boom E: [ipr]: ipr_dict_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.h (
        echo boom E: [ipr]: ipr_dict.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.c (
        echo boom E: [ipr]: ipr_dict.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table_test.c (
        echo boom E: [ipr]: ipr_dict_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.h (
        echo boom E: [ipr]: ipr_dict_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.c (
        echo boom E: [ipr]: ipr_dict_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list_test.c (
        echo boom E: [ipr]: ipr_dict_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.h (
        echo boom E: [ipr]: ipr_dict_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.c (
        echo boom E: [ipr]: ipr_dict_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_test.c (
        echo boom E: [ipr]: ipr_symbol_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.h (
        echo boom E: [ipr]: ipr_symbol.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.c (
        echo boom E: [ipr]: ipr_symbol.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table_test.c (
        echo boom E: [ipr]: ipr_symbol_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.h (
        echo boom E: [ipr]: ipr_symbol_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.c (
        echo boom E: [ipr]: ipr_symbol_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir_test.c (
        echo boom E: [ipr]: ipr_dir_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.h (
        echo boom E: [ipr]: ipr_dir.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.c (
        echo boom E: [ipr]: ipr_dir.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file_test.c (
        echo boom E: [ipr]: ipr_file_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.h (
        echo boom E: [ipr]: ipr_file.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.c (
        echo boom E: [ipr]: ipr_file.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_test.c (
        echo boom E: [ipr]: ipr_finfo_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.h (
        echo boom E: [ipr]: ipr_finfo.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.c (
        echo boom E: [ipr]: ipr_finfo.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list_test.c (
        echo boom E: [ipr]: ipr_finfo_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.h (
        echo boom E: [ipr]: ipr_finfo_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.c (
        echo boom E: [ipr]: ipr_finfo_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_test.c (
        echo boom E: [ipr]: ipr_hash_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.h (
        echo boom E: [ipr]: ipr_hash.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.c (
        echo boom E: [ipr]: ipr_hash.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table_test.c (
        echo boom E: [ipr]: ipr_hash_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.h (
        echo boom E: [ipr]: ipr_hash_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.c (
        echo boom E: [ipr]: ipr_hash_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http_test.c (
        echo boom E: [ipr]: ipr_http_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.h (
        echo boom E: [ipr]: ipr_http.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.c (
        echo boom E: [ipr]: ipr_http.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index_test.c (
        echo boom E: [ipr]: ipr_index_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.h (
        echo boom E: [ipr]: ipr_index.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.c (
        echo boom E: [ipr]: ipr_index.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log_test.c (
        echo boom E: [ipr]: ipr_log_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.h (
        echo boom E: [ipr]: ipr_log.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.c (
        echo boom E: [ipr]: ipr_log.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_test.c (
        echo boom E: [ipr]: ipr_looseref_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.h (
        echo boom E: [ipr]: ipr_looseref.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.c (
        echo boom E: [ipr]: ipr_looseref.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list_test.c (
        echo boom E: [ipr]: ipr_looseref_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.h (
        echo boom E: [ipr]: ipr_looseref_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.c (
        echo boom E: [ipr]: ipr_looseref_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_test.c (
        echo boom E: [ipr]: ipr_token_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.h (
        echo boom E: [ipr]: ipr_token.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.c (
        echo boom E: [ipr]: ipr_token.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list_test.c (
        echo boom E: [ipr]: ipr_token_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.h (
        echo boom E: [ipr]: ipr_token_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.c (
        echo boom E: [ipr]: ipr_token_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter_test.c (
        echo boom E: [ipr]: ipr_meter_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.h (
        echo boom E: [ipr]: ipr_meter.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.c (
        echo boom E: [ipr]: ipr_meter.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net_test.c (
        echo boom E: [ipr]: ipr_net_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.h (
        echo boom E: [ipr]: ipr_net.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.c (
        echo boom E: [ipr]: ipr_net.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_test.c (
        echo boom E: [ipr]: ipr_nonce_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.h (
        echo boom E: [ipr]: ipr_nonce.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.c (
        echo boom E: [ipr]: ipr_nonce.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table_test.c (
        echo boom E: [ipr]: ipr_nonce_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.h (
        echo boom E: [ipr]: ipr_nonce_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.c (
        echo boom E: [ipr]: ipr_nonce_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_test.c (
        echo boom E: [ipr]: ipr_password_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.h (
        echo boom E: [ipr]: ipr_password.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.c (
        echo boom E: [ipr]: ipr_password.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table_test.c (
        echo boom E: [ipr]: ipr_password_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.h (
        echo boom E: [ipr]: ipr_password_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.c (
        echo boom E: [ipr]: ipr_password_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list_test.c (
        echo boom E: [ipr]: ipr_password_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.h (
        echo boom E: [ipr]: ipr_password_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.c (
        echo boom E: [ipr]: ipr_password_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path_test.c (
        echo boom E: [ipr]: ipr_path_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.h (
        echo boom E: [ipr]: ipr_path.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.c (
        echo boom E: [ipr]: ipr_path.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process_test.c (
        echo boom E: [ipr]: ipr_process_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.h (
        echo boom E: [ipr]: ipr_process.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.c (
        echo boom E: [ipr]: ipr_process.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp_test.c (
        echo boom E: [ipr]: ipr_regexp_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.h (
        echo boom E: [ipr]: ipr_regexp.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.c (
        echo boom E: [ipr]: ipr_regexp.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl_test.c (
        echo boom E: [ipr]: ipr_sasl_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.h (
        echo boom E: [ipr]: ipr_sasl.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.c (
        echo boom E: [ipr]: ipr_sasl.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat_test.c (
        echo boom E: [ipr]: ipr_stat_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.h (
        echo boom E: [ipr]: ipr_stat.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.c (
        echo boom E: [ipr]: ipr_stat.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str_test.c (
        echo boom E: [ipr]: ipr_str_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.h (
        echo boom E: [ipr]: ipr_str.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.c (
        echo boom E: [ipr]: ipr_str.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid_test.c (
        echo boom E: [ipr]: ipr_uid_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.h (
        echo boom E: [ipr]: ipr_uid.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.c (
        echo boom E: [ipr]: ipr_uid.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time_test.c (
        echo boom E: [ipr]: ipr_time_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.h (
        echo boom E: [ipr]: ipr_time.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.c (
        echo boom E: [ipr]: ipr_time.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree_test.c (
        echo boom E: [ipr]: ipr_tree_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.h (
        echo boom E: [ipr]: ipr_tree.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.c (
        echo boom E: [ipr]: ipr_tree.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_test.c (
        echo boom E: [ipr]: ipr_xml_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.h (
        echo boom E: [ipr]: ipr_xml.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.c (
        echo boom E: [ipr]: ipr_xml.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list_test.c (
        echo boom E: [ipr]: ipr_xml_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.h (
        echo boom E: [ipr]: ipr_xml_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.c (
        echo boom E: [ipr]: ipr_xml_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_test.c (
        echo boom E: [ipr]: ipr_xml_attr_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.h (
        echo boom E: [ipr]: ipr_xml_attr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.c (
        echo boom E: [ipr]: ipr_xml_attr.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list_test.c (
        echo boom E: [ipr]: ipr_xml_attr_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.h (
        echo boom E: [ipr]: ipr_xml_attr_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.c (
        echo boom E: [ipr]: ipr_xml_attr_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_test.c (
        echo boom E: [ipr]: ipr_demo_portal_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.h (
        echo boom E: [ipr]: ipr_demo_portal.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.c (
        echo boom E: [ipr]: ipr_demo_portal.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client_test.c (
        echo boom E: [ipr]: ipr_demo_portal_client_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.h (
        echo boom E: [ipr]: ipr_demo_portal_client.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.c (
        echo boom E: [ipr]: ipr_demo_portal_client.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server_test.c (
        echo boom E: [ipr]: ipr_demo_portal_server_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.h (
        echo boom E: [ipr]: ipr_demo_portal_server.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.c (
        echo boom E: [ipr]: ipr_demo_portal_server.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist stamp_generate (
        echo boom E: [ipr]: stamp_generate is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist configure (
        echo boom E: [ipr]: configure is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist Makefile.unix (
        echo boom E: [ipr]: Makefile.unix is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake (
        echo boom E: [ipr]: boomake is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist configure.bat (
        echo boom E: [ipr]: configure.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist Makefile.win32 (
        echo boom E: [ipr]: Makefile.win32 is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake.bat (
        echo boom E: [ipr]: boomake.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomakew.bat (
        echo boom E: [ipr]: boomakew.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist libipr.vcproj (
        echo boom E: [ipr]: libipr.vcproj is missing, cannot continue
        set _exception=1
        goto :eof
    )
    goto :eof

:------------------------   CHECK BINARY FILES EXIST   ------------------------

:a_check_binary_files_exist
    if not exist ipr_xmll.h (
        echo boom E: [ipr]: ipr_xmll.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.icl (
        echo boom E: [ipr]: ipr_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.gsl (
        echo boom E: [ipr]: ipr_portal.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_sync.gsl (
        echo boom E: [ipr]: ipr_portal_sync.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_async.gsl (
        echo boom E: [ipr]: ipr_portal_async.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist libipr.lib (
        echo boom E: [ipr]: libipr.lib is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr.h (
        echo boom E: [ipr]: ipr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_classes.pdl (
        echo boom E: [ipr]: ipr_classes.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_resource.pl (
        echo boom E: [ipr]: ipr_resource.pl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist readme.txt (
        echo boom E: [ipr]: readme.txt is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.h (
        echo boom E: [ipr]: ipr_bits.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.h (
        echo boom E: [ipr]: ipr_bucket.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.h (
        echo boom E: [ipr]: ipr_bucket_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.h (
        echo boom E: [ipr]: ipr_mother.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.h (
        echo boom E: [ipr]: ipr_config.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.h (
        echo boom E: [ipr]: ipr_crc.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.h (
        echo boom E: [ipr]: ipr_dict.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.h (
        echo boom E: [ipr]: ipr_dict_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.h (
        echo boom E: [ipr]: ipr_dict_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.h (
        echo boom E: [ipr]: ipr_symbol.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.h (
        echo boom E: [ipr]: ipr_symbol_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.h (
        echo boom E: [ipr]: ipr_dir.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.h (
        echo boom E: [ipr]: ipr_file.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.h (
        echo boom E: [ipr]: ipr_finfo.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.h (
        echo boom E: [ipr]: ipr_finfo_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.h (
        echo boom E: [ipr]: ipr_hash.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.h (
        echo boom E: [ipr]: ipr_hash_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.h (
        echo boom E: [ipr]: ipr_http.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.h (
        echo boom E: [ipr]: ipr_index.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.h (
        echo boom E: [ipr]: ipr_log.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.h (
        echo boom E: [ipr]: ipr_looseref.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.h (
        echo boom E: [ipr]: ipr_looseref_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.h (
        echo boom E: [ipr]: ipr_token.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.h (
        echo boom E: [ipr]: ipr_token_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.h (
        echo boom E: [ipr]: ipr_meter.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.h (
        echo boom E: [ipr]: ipr_net.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.h (
        echo boom E: [ipr]: ipr_nonce.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.h (
        echo boom E: [ipr]: ipr_nonce_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.h (
        echo boom E: [ipr]: ipr_password.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.h (
        echo boom E: [ipr]: ipr_password_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.h (
        echo boom E: [ipr]: ipr_password_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.h (
        echo boom E: [ipr]: ipr_path.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.h (
        echo boom E: [ipr]: ipr_process.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.h (
        echo boom E: [ipr]: ipr_regexp.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.h (
        echo boom E: [ipr]: ipr_sasl.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.h (
        echo boom E: [ipr]: ipr_stat.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.h (
        echo boom E: [ipr]: ipr_str.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.h (
        echo boom E: [ipr]: ipr_uid.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.h (
        echo boom E: [ipr]: ipr_time.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.h (
        echo boom E: [ipr]: ipr_tree.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.h (
        echo boom E: [ipr]: ipr_xml.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.h (
        echo boom E: [ipr]: ipr_xml_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.h (
        echo boom E: [ipr]: ipr_xml_attr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.h (
        echo boom E: [ipr]: ipr_xml_attr_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.h (
        echo boom E: [ipr]: ipr_demo_portal.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.h (
        echo boom E: [ipr]: ipr_demo_portal_client.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.h (
        echo boom E: [ipr]: ipr_demo_portal_server.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    goto :eof

:-------------------------   CHECK OPERATING CONTEXT   ------------------------

:a_check_operating_context
    set event=repository
    if exist stamp_source   set event=source
    if exist stamp_stripped set event=stripped
    goto :eof

:------------------------   CHECK PROJECT FILES EXIST   -----------------------

:a_check_project_files_exist
    if not exist version.h (
        echo boom E: [ipr]: version.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.icl (
        echo boom E: [ipr]: ipr_bits.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.icl (
        echo boom E: [ipr]: ipr_bucket.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.icl (
        echo boom E: [ipr]: ipr_bucket_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.icl (
        echo boom E: [ipr]: ipr_mother.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.icl (
        echo boom E: [ipr]: ipr_config.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.icl (
        echo boom E: [ipr]: ipr_crc.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.icl (
        echo boom E: [ipr]: ipr_dict.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.icl (
        echo boom E: [ipr]: ipr_dict_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.icl (
        echo boom E: [ipr]: ipr_symbol.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.icl (
        echo boom E: [ipr]: ipr_dir.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.icl (
        echo boom E: [ipr]: ipr_file.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.icl (
        echo boom E: [ipr]: ipr_finfo.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.icl (
        echo boom E: [ipr]: ipr_hash.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.icl (
        echo boom E: [ipr]: ipr_http.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.icl (
        echo boom E: [ipr]: ipr_index.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.icl (
        echo boom E: [ipr]: ipr_log.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.icl (
        echo boom E: [ipr]: ipr_looseref.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.icl (
        echo boom E: [ipr]: ipr_token.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.icl (
        echo boom E: [ipr]: ipr_token_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.icl (
        echo boom E: [ipr]: ipr_meter.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.icl (
        echo boom E: [ipr]: ipr_net.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.icl (
        echo boom E: [ipr]: ipr_nonce.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.icl (
        echo boom E: [ipr]: ipr_password.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.icl (
        echo boom E: [ipr]: ipr_password_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.icl (
        echo boom E: [ipr]: ipr_path.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.icl (
        echo boom E: [ipr]: ipr_process.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.icl (
        echo boom E: [ipr]: ipr_regexp.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.icl (
        echo boom E: [ipr]: ipr_sasl.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.icl (
        echo boom E: [ipr]: ipr_stat.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.icl (
        echo boom E: [ipr]: ipr_str.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.icl (
        echo boom E: [ipr]: ipr_uid.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.icl (
        echo boom E: [ipr]: ipr_time.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.icl (
        echo boom E: [ipr]: ipr_tree.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.icl (
        echo boom E: [ipr]: ipr_xml.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.icl (
        echo boom E: [ipr]: ipr_xml_attr.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.h (
        echo boom E: [ipr]: ipr_xmll.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.c (
        echo boom E: [ipr]: ipr_xmll.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.icl (
        echo boom E: [ipr]: ipr_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.gsl (
        echo boom E: [ipr]: ipr_portal.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_sync.gsl (
        echo boom E: [ipr]: ipr_portal_sync.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_async.gsl (
        echo boom E: [ipr]: ipr_portal_async.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.icl (
        echo boom E: [ipr]: ipr_demo_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.icl (
        echo boom E: [ipr]: ipr_demo_portal_client.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.icl (
        echo boom E: [ipr]: ipr_demo_portal_server.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test1.xml (
        echo boom E: [ipr]: ipr_config_test1.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test2.xml (
        echo boom E: [ipr]: ipr_config_test2.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test3.xml (
        echo boom E: [ipr]: ipr_config_test3.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_classes.pdl (
        echo boom E: [ipr]: ipr_classes.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_resource.pl (
        echo boom E: [ipr]: ipr_resource.pl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist project.pdl (
        echo boom E: [ipr]: project.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist readme.txt (
        echo boom E: [ipr]: readme.txt is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake (
        echo boom E: [ipr]: boomake is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake.bat (
        echo boom E: [ipr]: boomake.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomakew.bat (
        echo boom E: [ipr]: boomakew.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    goto :eof

:------------------------   CHECK SOURCE FILES EXIST   ------------------------

:a_check_source_files_exist
    if not exist version.h (
        echo boom E: [ipr]: version.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.icl (
        echo boom E: [ipr]: ipr_bits.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.icl (
        echo boom E: [ipr]: ipr_bucket.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.icl (
        echo boom E: [ipr]: ipr_bucket_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.icl (
        echo boom E: [ipr]: ipr_mother.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.icl (
        echo boom E: [ipr]: ipr_config.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.icl (
        echo boom E: [ipr]: ipr_crc.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.icl (
        echo boom E: [ipr]: ipr_dict.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.icl (
        echo boom E: [ipr]: ipr_dict_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.icl (
        echo boom E: [ipr]: ipr_dict_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.icl (
        echo boom E: [ipr]: ipr_symbol.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.icl (
        echo boom E: [ipr]: ipr_symbol_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.icl (
        echo boom E: [ipr]: ipr_dir.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.icl (
        echo boom E: [ipr]: ipr_file.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.icl (
        echo boom E: [ipr]: ipr_finfo.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.icl (
        echo boom E: [ipr]: ipr_finfo_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.icl (
        echo boom E: [ipr]: ipr_hash.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.icl (
        echo boom E: [ipr]: ipr_hash_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.icl (
        echo boom E: [ipr]: ipr_http.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.icl (
        echo boom E: [ipr]: ipr_index.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.icl (
        echo boom E: [ipr]: ipr_log.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.icl (
        echo boom E: [ipr]: ipr_looseref.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.icl (
        echo boom E: [ipr]: ipr_looseref_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.icl (
        echo boom E: [ipr]: ipr_token.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.icl (
        echo boom E: [ipr]: ipr_token_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.icl (
        echo boom E: [ipr]: ipr_meter.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.icl (
        echo boom E: [ipr]: ipr_net.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.icl (
        echo boom E: [ipr]: ipr_nonce.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.icl (
        echo boom E: [ipr]: ipr_nonce_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.icl (
        echo boom E: [ipr]: ipr_password.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.icl (
        echo boom E: [ipr]: ipr_password_table.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.icl (
        echo boom E: [ipr]: ipr_password_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.icl (
        echo boom E: [ipr]: ipr_path.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.icl (
        echo boom E: [ipr]: ipr_process.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.icl (
        echo boom E: [ipr]: ipr_regexp.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.icl (
        echo boom E: [ipr]: ipr_sasl.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.icl (
        echo boom E: [ipr]: ipr_stat.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.icl (
        echo boom E: [ipr]: ipr_str.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.icl (
        echo boom E: [ipr]: ipr_uid.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.icl (
        echo boom E: [ipr]: ipr_time.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.icl (
        echo boom E: [ipr]: ipr_tree.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.icl (
        echo boom E: [ipr]: ipr_xml.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.icl (
        echo boom E: [ipr]: ipr_xml_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.icl (
        echo boom E: [ipr]: ipr_xml_attr.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.icl (
        echo boom E: [ipr]: ipr_xml_attr_list.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.h (
        echo boom E: [ipr]: ipr_xmll.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xmll.c (
        echo boom E: [ipr]: ipr_xmll.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.icl (
        echo boom E: [ipr]: ipr_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal.gsl (
        echo boom E: [ipr]: ipr_portal.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_sync.gsl (
        echo boom E: [ipr]: ipr_portal_sync.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_portal_async.gsl (
        echo boom E: [ipr]: ipr_portal_async.gsl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.icl (
        echo boom E: [ipr]: ipr_demo_portal.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.icl (
        echo boom E: [ipr]: ipr_demo_portal_client.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.icl (
        echo boom E: [ipr]: ipr_demo_portal_server.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_front.icl (
        echo boom E: [ipr]: ipr_demo_portal_front.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_back.icl (
        echo boom E: [ipr]: ipr_demo_portal_back.icl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test1.xml (
        echo boom E: [ipr]: ipr_config_test1.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test2.xml (
        echo boom E: [ipr]: ipr_config_test2.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test3.xml (
        echo boom E: [ipr]: ipr_config_test3.xml is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr.h (
        echo boom E: [ipr]: ipr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_classes.pdl (
        echo boom E: [ipr]: ipr_classes.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_resource.pl (
        echo boom E: [ipr]: ipr_resource.pl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist project.pdl (
        echo boom E: [ipr]: project.pdl is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist readme.txt (
        echo boom E: [ipr]: readme.txt is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits_test.c (
        echo boom E: [ipr]: ipr_bits_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.h (
        echo boom E: [ipr]: ipr_bits.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bits.c (
        echo boom E: [ipr]: ipr_bits.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_test.c (
        echo boom E: [ipr]: ipr_bucket_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.h (
        echo boom E: [ipr]: ipr_bucket.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket.c (
        echo boom E: [ipr]: ipr_bucket.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list_test.c (
        echo boom E: [ipr]: ipr_bucket_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.h (
        echo boom E: [ipr]: ipr_bucket_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_bucket_list.c (
        echo boom E: [ipr]: ipr_bucket_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother_test.c (
        echo boom E: [ipr]: ipr_mother_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.h (
        echo boom E: [ipr]: ipr_mother.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_mother.c (
        echo boom E: [ipr]: ipr_mother.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config_test.c (
        echo boom E: [ipr]: ipr_config_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.h (
        echo boom E: [ipr]: ipr_config.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_config.c (
        echo boom E: [ipr]: ipr_config.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc_test.c (
        echo boom E: [ipr]: ipr_crc_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.h (
        echo boom E: [ipr]: ipr_crc.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_crc.c (
        echo boom E: [ipr]: ipr_crc.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_test.c (
        echo boom E: [ipr]: ipr_dict_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.h (
        echo boom E: [ipr]: ipr_dict.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict.c (
        echo boom E: [ipr]: ipr_dict.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table_test.c (
        echo boom E: [ipr]: ipr_dict_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.h (
        echo boom E: [ipr]: ipr_dict_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_table.c (
        echo boom E: [ipr]: ipr_dict_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list_test.c (
        echo boom E: [ipr]: ipr_dict_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.h (
        echo boom E: [ipr]: ipr_dict_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dict_list.c (
        echo boom E: [ipr]: ipr_dict_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_test.c (
        echo boom E: [ipr]: ipr_symbol_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.h (
        echo boom E: [ipr]: ipr_symbol.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol.c (
        echo boom E: [ipr]: ipr_symbol.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table_test.c (
        echo boom E: [ipr]: ipr_symbol_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.h (
        echo boom E: [ipr]: ipr_symbol_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_symbol_table.c (
        echo boom E: [ipr]: ipr_symbol_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir_test.c (
        echo boom E: [ipr]: ipr_dir_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.h (
        echo boom E: [ipr]: ipr_dir.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_dir.c (
        echo boom E: [ipr]: ipr_dir.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file_test.c (
        echo boom E: [ipr]: ipr_file_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.h (
        echo boom E: [ipr]: ipr_file.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_file.c (
        echo boom E: [ipr]: ipr_file.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_test.c (
        echo boom E: [ipr]: ipr_finfo_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.h (
        echo boom E: [ipr]: ipr_finfo.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo.c (
        echo boom E: [ipr]: ipr_finfo.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list_test.c (
        echo boom E: [ipr]: ipr_finfo_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.h (
        echo boom E: [ipr]: ipr_finfo_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_finfo_list.c (
        echo boom E: [ipr]: ipr_finfo_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_test.c (
        echo boom E: [ipr]: ipr_hash_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.h (
        echo boom E: [ipr]: ipr_hash.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash.c (
        echo boom E: [ipr]: ipr_hash.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table_test.c (
        echo boom E: [ipr]: ipr_hash_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.h (
        echo boom E: [ipr]: ipr_hash_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_hash_table.c (
        echo boom E: [ipr]: ipr_hash_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http_test.c (
        echo boom E: [ipr]: ipr_http_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.h (
        echo boom E: [ipr]: ipr_http.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_http.c (
        echo boom E: [ipr]: ipr_http.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index_test.c (
        echo boom E: [ipr]: ipr_index_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.h (
        echo boom E: [ipr]: ipr_index.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_index.c (
        echo boom E: [ipr]: ipr_index.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log_test.c (
        echo boom E: [ipr]: ipr_log_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.h (
        echo boom E: [ipr]: ipr_log.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_log.c (
        echo boom E: [ipr]: ipr_log.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_test.c (
        echo boom E: [ipr]: ipr_looseref_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.h (
        echo boom E: [ipr]: ipr_looseref.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref.c (
        echo boom E: [ipr]: ipr_looseref.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list_test.c (
        echo boom E: [ipr]: ipr_looseref_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.h (
        echo boom E: [ipr]: ipr_looseref_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_looseref_list.c (
        echo boom E: [ipr]: ipr_looseref_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_test.c (
        echo boom E: [ipr]: ipr_token_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.h (
        echo boom E: [ipr]: ipr_token.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token.c (
        echo boom E: [ipr]: ipr_token.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list_test.c (
        echo boom E: [ipr]: ipr_token_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.h (
        echo boom E: [ipr]: ipr_token_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_token_list.c (
        echo boom E: [ipr]: ipr_token_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter_test.c (
        echo boom E: [ipr]: ipr_meter_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.h (
        echo boom E: [ipr]: ipr_meter.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_meter.c (
        echo boom E: [ipr]: ipr_meter.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net_test.c (
        echo boom E: [ipr]: ipr_net_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.h (
        echo boom E: [ipr]: ipr_net.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_net.c (
        echo boom E: [ipr]: ipr_net.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_test.c (
        echo boom E: [ipr]: ipr_nonce_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.h (
        echo boom E: [ipr]: ipr_nonce.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce.c (
        echo boom E: [ipr]: ipr_nonce.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table_test.c (
        echo boom E: [ipr]: ipr_nonce_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.h (
        echo boom E: [ipr]: ipr_nonce_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_nonce_table.c (
        echo boom E: [ipr]: ipr_nonce_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_test.c (
        echo boom E: [ipr]: ipr_password_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.h (
        echo boom E: [ipr]: ipr_password.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password.c (
        echo boom E: [ipr]: ipr_password.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table_test.c (
        echo boom E: [ipr]: ipr_password_table_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.h (
        echo boom E: [ipr]: ipr_password_table.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_table.c (
        echo boom E: [ipr]: ipr_password_table.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list_test.c (
        echo boom E: [ipr]: ipr_password_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.h (
        echo boom E: [ipr]: ipr_password_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_password_list.c (
        echo boom E: [ipr]: ipr_password_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path_test.c (
        echo boom E: [ipr]: ipr_path_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.h (
        echo boom E: [ipr]: ipr_path.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_path.c (
        echo boom E: [ipr]: ipr_path.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process_test.c (
        echo boom E: [ipr]: ipr_process_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.h (
        echo boom E: [ipr]: ipr_process.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_process.c (
        echo boom E: [ipr]: ipr_process.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp_test.c (
        echo boom E: [ipr]: ipr_regexp_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.h (
        echo boom E: [ipr]: ipr_regexp.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_regexp.c (
        echo boom E: [ipr]: ipr_regexp.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl_test.c (
        echo boom E: [ipr]: ipr_sasl_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.h (
        echo boom E: [ipr]: ipr_sasl.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_sasl.c (
        echo boom E: [ipr]: ipr_sasl.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat_test.c (
        echo boom E: [ipr]: ipr_stat_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.h (
        echo boom E: [ipr]: ipr_stat.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_stat.c (
        echo boom E: [ipr]: ipr_stat.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str_test.c (
        echo boom E: [ipr]: ipr_str_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.h (
        echo boom E: [ipr]: ipr_str.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_str.c (
        echo boom E: [ipr]: ipr_str.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid_test.c (
        echo boom E: [ipr]: ipr_uid_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.h (
        echo boom E: [ipr]: ipr_uid.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_uid.c (
        echo boom E: [ipr]: ipr_uid.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time_test.c (
        echo boom E: [ipr]: ipr_time_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.h (
        echo boom E: [ipr]: ipr_time.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_time.c (
        echo boom E: [ipr]: ipr_time.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree_test.c (
        echo boom E: [ipr]: ipr_tree_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.h (
        echo boom E: [ipr]: ipr_tree.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_tree.c (
        echo boom E: [ipr]: ipr_tree.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_test.c (
        echo boom E: [ipr]: ipr_xml_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.h (
        echo boom E: [ipr]: ipr_xml.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml.c (
        echo boom E: [ipr]: ipr_xml.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list_test.c (
        echo boom E: [ipr]: ipr_xml_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.h (
        echo boom E: [ipr]: ipr_xml_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_list.c (
        echo boom E: [ipr]: ipr_xml_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_test.c (
        echo boom E: [ipr]: ipr_xml_attr_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.h (
        echo boom E: [ipr]: ipr_xml_attr.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr.c (
        echo boom E: [ipr]: ipr_xml_attr.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list_test.c (
        echo boom E: [ipr]: ipr_xml_attr_list_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.h (
        echo boom E: [ipr]: ipr_xml_attr_list.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_xml_attr_list.c (
        echo boom E: [ipr]: ipr_xml_attr_list.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_test.c (
        echo boom E: [ipr]: ipr_demo_portal_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.h (
        echo boom E: [ipr]: ipr_demo_portal.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal.c (
        echo boom E: [ipr]: ipr_demo_portal.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client_test.c (
        echo boom E: [ipr]: ipr_demo_portal_client_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.h (
        echo boom E: [ipr]: ipr_demo_portal_client.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_client.c (
        echo boom E: [ipr]: ipr_demo_portal_client.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server_test.c (
        echo boom E: [ipr]: ipr_demo_portal_server_test.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.h (
        echo boom E: [ipr]: ipr_demo_portal_server.h is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist ipr_demo_portal_server.c (
        echo boom E: [ipr]: ipr_demo_portal_server.c is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist stamp_generate (
        echo boom E: [ipr]: stamp_generate is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist configure (
        echo boom E: [ipr]: configure is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist Makefile.unix (
        echo boom E: [ipr]: Makefile.unix is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake (
        echo boom E: [ipr]: boomake is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist configure.bat (
        echo boom E: [ipr]: configure.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist Makefile.win32 (
        echo boom E: [ipr]: Makefile.win32 is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomake.bat (
        echo boom E: [ipr]: boomake.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist boomakew.bat (
        echo boom E: [ipr]: boomakew.bat is missing, cannot continue
        set _exception=1
        goto :eof
    )
    if not exist libipr.vcproj (
        echo boom E: [ipr]: libipr.vcproj is missing, cannot continue
        set _exception=1
        goto :eof
    )
    goto :eof

:--------------------------   INSTALL DELIVERABLES   --------------------------

:a_install_deliverables
    echo boom I: [ipr]: installing iPR into !_INSTALL_ROOT!...
    if not exist !_INSTALL_ROOT! mkdir !_INSTALL_ROOT!
    if not exist !_INSTALL_ROOT!\bin\nul mkdir !_INSTALL_ROOT!\bin\
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bits.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_bits.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bits.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bucket.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_bucket.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bucket.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bucket_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_bucket_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bucket_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_mother.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_mother.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_mother.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_config.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_config.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_config.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_crc.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_crc.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_crc.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_dict.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict_table.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_dict_table.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict_table.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_dict_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_symbol.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_symbol.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_symbol.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_symbol_table.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_symbol_table.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_symbol_table.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dir.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_dir.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dir.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_file.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_file.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_file.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_finfo.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_finfo.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_finfo.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_finfo_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_finfo_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_finfo_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_hash.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_hash.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_hash.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_hash_table.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_hash_table.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_hash_table.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_http.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_http.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_http.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_index.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_index.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_index.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_log.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_log.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_log.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_looseref.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_looseref.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_looseref.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_looseref_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_looseref_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_looseref_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_token.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_token.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_token.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_token_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_token_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_token_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_meter.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_meter.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_meter.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_net.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_net.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_net.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_nonce.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_nonce.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_nonce.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_nonce_table.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_nonce_table.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_nonce_table.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_password.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password_table.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_password_table.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password_table.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_password_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_path.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_path.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_path.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_process.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_process.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_process.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_regexp.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_regexp.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_regexp.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_sasl.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_sasl.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_sasl.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_stat.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_stat.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_stat.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_str.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_str.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_str.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_uid.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_uid.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_uid.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_time.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_time.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_time.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_tree.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_tree.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_tree.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_xml.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_xml_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_attr.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_xml_attr.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_attr.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_attr_list.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_xml_attr_list.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_attr_list.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xmll.h !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_xmll.h !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xmll.h !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_portal.icl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_portal.icl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_portal.icl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_portal.gsl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_portal.gsl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_portal.gsl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_portal_sync.gsl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_portal_sync.gsl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_portal_sync.gsl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_portal_async.gsl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_portal_async.gsl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_portal_async.gsl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if not exist !_INSTALL_ROOT!\lib\nul mkdir !_INSTALL_ROOT!\lib\
    if "!BOOM_TRACE!"=="1" echo copy/y libipr.lib !_INSTALL_ROOT!\lib\>nul
    verify>nul
    call copy/y libipr.lib !_INSTALL_ROOT!\lib\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y libipr.lib !_INSTALL_ROOT!\lib\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if not exist !_INSTALL_ROOT!\include\nul mkdir !_INSTALL_ROOT!\include\
    if "!BOOM_TRACE!"=="1" echo copy/y ipr.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if not exist !_INSTALL_ROOT!\bin\nul mkdir !_INSTALL_ROOT!\bin\
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_classes.pdl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_classes.pdl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_classes.pdl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_resource.pl !_INSTALL_ROOT!\bin\>nul
    verify>nul
    call copy/y ipr_resource.pl !_INSTALL_ROOT!\bin\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_resource.pl !_INSTALL_ROOT!\bin\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if not exist !_INSTALL_ROOT!\doc\iPR\nul mkdir !_INSTALL_ROOT!\doc\iPR\
    if "!BOOM_TRACE!"=="1" echo copy/y readme.txt !_INSTALL_ROOT!\doc\iPR\>nul
    verify>nul
    call copy/y readme.txt !_INSTALL_ROOT!\doc\iPR\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y readme.txt !_INSTALL_ROOT!\doc\iPR\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if not exist !_INSTALL_ROOT!\include\nul mkdir !_INSTALL_ROOT!\include\
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bits.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_bits.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bits.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bucket.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_bucket.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bucket.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_bucket_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_bucket_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_bucket_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_mother.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_mother.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_mother.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_config.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_config.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_config.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_crc.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_crc.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_crc.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_dict.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict_table.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_dict_table.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict_table.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dict_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_dict_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dict_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_symbol.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_symbol.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_symbol.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_symbol_table.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_symbol_table.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_symbol_table.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_dir.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_dir.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_dir.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_file.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_file.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_file.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_finfo.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_finfo.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_finfo.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_finfo_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_finfo_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_finfo_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_hash.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_hash.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_hash.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_hash_table.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_hash_table.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_hash_table.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_http.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_http.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_http.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_index.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_index.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_index.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_log.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_log.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_log.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_looseref.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_looseref.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_looseref.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_looseref_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_looseref_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_looseref_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_token.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_token.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_token.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_token_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_token_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_token_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_meter.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_meter.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_meter.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_net.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_net.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_net.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_nonce.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_nonce.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_nonce.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_nonce_table.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_nonce_table.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_nonce_table.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_password.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password_table.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_password_table.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password_table.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_password_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_password_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_password_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_path.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_path.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_path.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_process.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_process.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_process.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_regexp.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_regexp.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_regexp.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_sasl.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_sasl.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_sasl.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_stat.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_stat.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_stat.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_str.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_str.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_str.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_uid.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_uid.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_uid.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_time.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_time.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_time.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_tree.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_tree.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_tree.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_xml.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_xml_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_attr.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_xml_attr.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_attr.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_xml_attr_list.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_xml_attr_list.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_xml_attr_list.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_demo_portal.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_demo_portal.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_demo_portal.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_demo_portal_client.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_demo_portal_client.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_demo_portal_client.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo copy/y ipr_demo_portal_server.h !_INSTALL_ROOT!\include\>nul
    verify>nul
    call copy/y ipr_demo_portal_server.h !_INSTALL_ROOT!\include\>nul
    if errorlevel 1 (
        echo boom E: [ipr]: 'copy/y ipr_demo_portal_server.h !_INSTALL_ROOT!\include\>nul' failed - stop.
        set _exception=1
        goto :eof
    )
    if exist installer.bat (
    if "!BOOM_TRACE!"=="1" echo installer
    verify>nul
    call installer
    if errorlevel 1 (
        echo boom E: [ipr]: 'installer' failed - stop.
        set _exception=1
        goto :eof
    )
    )
    goto :eof

:-----------------------   PRODUCE ALL GENERATED FILES   ----------------------

:a_produce_all_generated_files
    echo boom I: [ipr]: Generating files...
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bits.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bits.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bits.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bucket.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bucket.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bucket.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bucket_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bucket_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bucket_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_mother.icl
    verify>nul
    call gsl -q -quiet:1 ipr_mother.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_mother.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_config.icl
    verify>nul
    call gsl -q -quiet:1 ipr_config.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_config.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_crc.icl
    verify>nul
    call gsl -q -quiet:1 ipr_crc.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_crc.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_symbol.icl
    verify>nul
    call gsl -q -quiet:1 ipr_symbol.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_symbol.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_symbol_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_symbol_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_symbol_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dir.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dir.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dir.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_file.icl
    verify>nul
    call gsl -q -quiet:1 ipr_file.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_file.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_finfo.icl
    verify>nul
    call gsl -q -quiet:1 ipr_finfo.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_finfo.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_finfo_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_finfo_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_finfo_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_hash.icl
    verify>nul
    call gsl -q -quiet:1 ipr_hash.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_hash.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_hash_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_hash_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_hash_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_http.icl
    verify>nul
    call gsl -q -quiet:1 ipr_http.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_http.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_index.icl
    verify>nul
    call gsl -q -quiet:1 ipr_index.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_index.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_log.icl
    verify>nul
    call gsl -q -quiet:1 ipr_log.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_log.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_looseref.icl
    verify>nul
    call gsl -q -quiet:1 ipr_looseref.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_looseref.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_looseref_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_looseref_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_looseref_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_token.icl
    verify>nul
    call gsl -q -quiet:1 ipr_token.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_token.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_token_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_token_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_token_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_meter.icl
    verify>nul
    call gsl -q -quiet:1 ipr_meter.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_meter.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_net.icl
    verify>nul
    call gsl -q -quiet:1 ipr_net.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_net.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_nonce.icl
    verify>nul
    call gsl -q -quiet:1 ipr_nonce.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_nonce.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_nonce_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_nonce_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_nonce_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_path.icl
    verify>nul
    call gsl -q -quiet:1 ipr_path.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_path.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_process.icl
    verify>nul
    call gsl -q -quiet:1 ipr_process.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_process.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_regexp.icl
    verify>nul
    call gsl -q -quiet:1 ipr_regexp.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_regexp.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_sasl.icl
    verify>nul
    call gsl -q -quiet:1 ipr_sasl.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_sasl.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_stat.icl
    verify>nul
    call gsl -q -quiet:1 ipr_stat.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_stat.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_str.icl
    verify>nul
    call gsl -q -quiet:1 ipr_str.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_str.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_uid.icl
    verify>nul
    call gsl -q -quiet:1 ipr_uid.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_uid.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_time.icl
    verify>nul
    call gsl -q -quiet:1 ipr_time.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_time.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_tree.icl
    verify>nul
    call gsl -q -quiet:1 ipr_tree.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_tree.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_attr.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_attr.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_attr.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_attr_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_attr_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_attr_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal_client.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal_client.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal_client.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal_server.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal_server.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal_server.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if exist ipr.h del ipr.h
    if "!BOOM_TRACE!"=="1" echo type ipr_bits.h>>ipr.h
    verify>nul
    call type ipr_bits.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_bits.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_bucket.h>>ipr.h
    verify>nul
    call type ipr_bucket.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_bucket.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_config.h>>ipr.h
    verify>nul
    call type ipr_config.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_config.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_crc.h>>ipr.h
    verify>nul
    call type ipr_crc.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_crc.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_dict.h>>ipr.h
    verify>nul
    call type ipr_dict.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_dict.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_dir.h>>ipr.h
    verify>nul
    call type ipr_dir.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_dir.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_file.h>>ipr.h
    verify>nul
    call type ipr_file.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_file.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_finfo.h>>ipr.h
    verify>nul
    call type ipr_finfo.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_finfo.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_hash.h>>ipr.h
    verify>nul
    call type ipr_hash.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_hash.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_http.h>>ipr.h
    verify>nul
    call type ipr_http.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_http.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_index.h>>ipr.h
    verify>nul
    call type ipr_index.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_index.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_log.h>>ipr.h
    verify>nul
    call type ipr_log.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_log.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_looseref.h>>ipr.h
    verify>nul
    call type ipr_looseref.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_looseref.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_meter.h>>ipr.h
    verify>nul
    call type ipr_meter.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_meter.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_net.h>>ipr.h
    verify>nul
    call type ipr_net.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_net.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_nonce.h>>ipr.h
    verify>nul
    call type ipr_nonce.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_nonce.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_path.h>>ipr.h
    verify>nul
    call type ipr_path.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_path.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_password.h>>ipr.h
    verify>nul
    call type ipr_password.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_password.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_process.h>>ipr.h
    verify>nul
    call type ipr_process.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_process.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_regexp.h>>ipr.h
    verify>nul
    call type ipr_regexp.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_regexp.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_sasl.h>>ipr.h
    verify>nul
    call type ipr_sasl.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_sasl.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_stat.h>>ipr.h
    verify>nul
    call type ipr_stat.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_stat.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_str.h>>ipr.h
    verify>nul
    call type ipr_str.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_str.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_symbol.h>>ipr.h
    verify>nul
    call type ipr_symbol.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_symbol.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_token.h>>ipr.h
    verify>nul
    call type ipr_token.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_token.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_tree.h>>ipr.h
    verify>nul
    call type ipr_tree.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_tree.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_xml.h>>ipr.h
    verify>nul
    call type ipr_xml.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_xml.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_xmll.h>>ipr.h
    verify>nul
    call type ipr_xmll.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_xmll.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_uid.h>>ipr.h
    verify>nul
    call type ipr_uid.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_uid.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_time.h>>ipr.h
    verify>nul
    call type ipr_time.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_time.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    echo Source files successfully generated>stamp_generate
    goto :eof

:-------------------------   PRODUCE GENERATED FILES   ------------------------

:a_produce_generated_files
    echo boom I: [ipr]: Generating files...
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bits.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bits.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bits.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bucket.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bucket.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bucket.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_bucket_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_bucket_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_bucket_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_mother.icl
    verify>nul
    call gsl -q -quiet:1 ipr_mother.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_mother.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_config.icl
    verify>nul
    call gsl -q -quiet:1 ipr_config.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_config.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_crc.icl
    verify>nul
    call gsl -q -quiet:1 ipr_crc.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_crc.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dict_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dict_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dict_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_symbol.icl
    verify>nul
    call gsl -q -quiet:1 ipr_symbol.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_symbol.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_symbol_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_symbol_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_symbol_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_dir.icl
    verify>nul
    call gsl -q -quiet:1 ipr_dir.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_dir.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_file.icl
    verify>nul
    call gsl -q -quiet:1 ipr_file.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_file.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_finfo.icl
    verify>nul
    call gsl -q -quiet:1 ipr_finfo.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_finfo.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_finfo_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_finfo_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_finfo_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_hash.icl
    verify>nul
    call gsl -q -quiet:1 ipr_hash.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_hash.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_hash_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_hash_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_hash_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_http.icl
    verify>nul
    call gsl -q -quiet:1 ipr_http.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_http.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_index.icl
    verify>nul
    call gsl -q -quiet:1 ipr_index.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_index.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_log.icl
    verify>nul
    call gsl -q -quiet:1 ipr_log.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_log.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_looseref.icl
    verify>nul
    call gsl -q -quiet:1 ipr_looseref.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_looseref.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_looseref_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_looseref_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_looseref_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_token.icl
    verify>nul
    call gsl -q -quiet:1 ipr_token.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_token.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_token_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_token_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_token_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_meter.icl
    verify>nul
    call gsl -q -quiet:1 ipr_meter.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_meter.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_net.icl
    verify>nul
    call gsl -q -quiet:1 ipr_net.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_net.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_nonce.icl
    verify>nul
    call gsl -q -quiet:1 ipr_nonce.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_nonce.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_nonce_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_nonce_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_nonce_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password_table.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password_table.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password_table.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_password_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_password_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_password_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_path.icl
    verify>nul
    call gsl -q -quiet:1 ipr_path.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_path.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_process.icl
    verify>nul
    call gsl -q -quiet:1 ipr_process.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_process.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_regexp.icl
    verify>nul
    call gsl -q -quiet:1 ipr_regexp.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_regexp.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_sasl.icl
    verify>nul
    call gsl -q -quiet:1 ipr_sasl.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_sasl.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_stat.icl
    verify>nul
    call gsl -q -quiet:1 ipr_stat.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_stat.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_str.icl
    verify>nul
    call gsl -q -quiet:1 ipr_str.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_str.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_uid.icl
    verify>nul
    call gsl -q -quiet:1 ipr_uid.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_uid.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_time.icl
    verify>nul
    call gsl -q -quiet:1 ipr_time.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_time.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_tree.icl
    verify>nul
    call gsl -q -quiet:1 ipr_tree.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_tree.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_attr.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_attr.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_attr.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_xml_attr_list.icl
    verify>nul
    call gsl -q -quiet:1 ipr_xml_attr_list.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_xml_attr_list.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal_client.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal_client.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal_client.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo gsl -q -quiet:1 ipr_demo_portal_server.icl
    verify>nul
    call gsl -q -quiet:1 ipr_demo_portal_server.icl
    if errorlevel 1 (
        echo boom E: [ipr]: 'gsl -q -quiet:1 ipr_demo_portal_server.icl' failed - stop.
        set _exception=1
        goto :eof
    )
    if exist ipr.h del ipr.h
    if "!BOOM_TRACE!"=="1" echo type ipr_bits.h>>ipr.h
    verify>nul
    call type ipr_bits.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_bits.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_bucket.h>>ipr.h
    verify>nul
    call type ipr_bucket.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_bucket.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_config.h>>ipr.h
    verify>nul
    call type ipr_config.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_config.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_crc.h>>ipr.h
    verify>nul
    call type ipr_crc.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_crc.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_dict.h>>ipr.h
    verify>nul
    call type ipr_dict.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_dict.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_dir.h>>ipr.h
    verify>nul
    call type ipr_dir.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_dir.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_file.h>>ipr.h
    verify>nul
    call type ipr_file.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_file.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_finfo.h>>ipr.h
    verify>nul
    call type ipr_finfo.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_finfo.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_hash.h>>ipr.h
    verify>nul
    call type ipr_hash.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_hash.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_http.h>>ipr.h
    verify>nul
    call type ipr_http.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_http.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_index.h>>ipr.h
    verify>nul
    call type ipr_index.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_index.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_log.h>>ipr.h
    verify>nul
    call type ipr_log.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_log.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_looseref.h>>ipr.h
    verify>nul
    call type ipr_looseref.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_looseref.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_meter.h>>ipr.h
    verify>nul
    call type ipr_meter.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_meter.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_net.h>>ipr.h
    verify>nul
    call type ipr_net.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_net.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_nonce.h>>ipr.h
    verify>nul
    call type ipr_nonce.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_nonce.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_path.h>>ipr.h
    verify>nul
    call type ipr_path.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_path.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_password.h>>ipr.h
    verify>nul
    call type ipr_password.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_password.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_process.h>>ipr.h
    verify>nul
    call type ipr_process.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_process.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_regexp.h>>ipr.h
    verify>nul
    call type ipr_regexp.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_regexp.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_sasl.h>>ipr.h
    verify>nul
    call type ipr_sasl.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_sasl.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_stat.h>>ipr.h
    verify>nul
    call type ipr_stat.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_stat.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_str.h>>ipr.h
    verify>nul
    call type ipr_str.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_str.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_symbol.h>>ipr.h
    verify>nul
    call type ipr_symbol.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_symbol.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_token.h>>ipr.h
    verify>nul
    call type ipr_token.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_token.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_tree.h>>ipr.h
    verify>nul
    call type ipr_tree.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_tree.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_xml.h>>ipr.h
    verify>nul
    call type ipr_xml.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_xml.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_xmll.h>>ipr.h
    verify>nul
    call type ipr_xmll.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_xmll.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_uid.h>>ipr.h
    verify>nul
    call type ipr_uid.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_uid.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" echo type ipr_time.h>>ipr.h
    verify>nul
    call type ipr_time.h>>ipr.h
    if errorlevel 1 (
        echo boom E: [ipr]: 'type ipr_time.h>>ipr.h' failed - stop.
        set _exception=1
        goto :eof
    )
    echo Source files successfully generated>stamp_generate
    goto :eof

:------------------------   REMOVE GENERATED BINARIES   -----------------------

:a_remove_generated_binaries
    if exist libipr.lib del libipr.lib
    if exist ipr_bits_test_test.obj del ipr_bits_test_test.obj
    if exist ipr_bits_test_test.exe del ipr_bits_test_test.exe
    if exist ipr_bits.obj del ipr_bits.obj
    if exist ipr_bucket_test_test.obj del ipr_bucket_test_test.obj
    if exist ipr_bucket_test_test.exe del ipr_bucket_test_test.exe
    if exist ipr_bucket.obj del ipr_bucket.obj
    if exist ipr_bucket_list_test_test.obj del ipr_bucket_list_test_test.obj
    if exist ipr_bucket_list_test_test.exe del ipr_bucket_list_test_test.exe
    if exist ipr_bucket_list.obj del ipr_bucket_list.obj
    if exist ipr_mother_test_test.obj del ipr_mother_test_test.obj
    if exist ipr_mother_test_test.exe del ipr_mother_test_test.exe
    if exist ipr_mother.obj del ipr_mother.obj
    if exist ipr_config_test_test.obj del ipr_config_test_test.obj
    if exist ipr_config_test_test.exe del ipr_config_test_test.exe
    if exist ipr_config.obj del ipr_config.obj
    if exist ipr_crc_test_test.obj del ipr_crc_test_test.obj
    if exist ipr_crc_test_test.exe del ipr_crc_test_test.exe
    if exist ipr_crc.obj del ipr_crc.obj
    if exist ipr_dict_test_test.obj del ipr_dict_test_test.obj
    if exist ipr_dict_test_test.exe del ipr_dict_test_test.exe
    if exist ipr_dict.obj del ipr_dict.obj
    if exist ipr_dict_table_test_test.obj del ipr_dict_table_test_test.obj
    if exist ipr_dict_table_test_test.exe del ipr_dict_table_test_test.exe
    if exist ipr_dict_table.obj del ipr_dict_table.obj
    if exist ipr_dict_list_test_test.obj del ipr_dict_list_test_test.obj
    if exist ipr_dict_list_test_test.exe del ipr_dict_list_test_test.exe
    if exist ipr_dict_list.obj del ipr_dict_list.obj
    if exist ipr_symbol_test_test.obj del ipr_symbol_test_test.obj
    if exist ipr_symbol_test_test.exe del ipr_symbol_test_test.exe
    if exist ipr_symbol.obj del ipr_symbol.obj
    if exist ipr_symbol_table_test_test.obj del ipr_symbol_table_test_test.obj
    if exist ipr_symbol_table_test_test.exe del ipr_symbol_table_test_test.exe
    if exist ipr_symbol_table.obj del ipr_symbol_table.obj
    if exist ipr_dir_test_test.obj del ipr_dir_test_test.obj
    if exist ipr_dir_test_test.exe del ipr_dir_test_test.exe
    if exist ipr_dir.obj del ipr_dir.obj
    if exist ipr_file_test_test.obj del ipr_file_test_test.obj
    if exist ipr_file_test_test.exe del ipr_file_test_test.exe
    if exist ipr_file.obj del ipr_file.obj
    if exist ipr_finfo_test_test.obj del ipr_finfo_test_test.obj
    if exist ipr_finfo_test_test.exe del ipr_finfo_test_test.exe
    if exist ipr_finfo.obj del ipr_finfo.obj
    if exist ipr_finfo_list_test_test.obj del ipr_finfo_list_test_test.obj
    if exist ipr_finfo_list_test_test.exe del ipr_finfo_list_test_test.exe
    if exist ipr_finfo_list.obj del ipr_finfo_list.obj
    if exist ipr_hash_test_test.obj del ipr_hash_test_test.obj
    if exist ipr_hash_test_test.exe del ipr_hash_test_test.exe
    if exist ipr_hash.obj del ipr_hash.obj
    if exist ipr_hash_table_test_test.obj del ipr_hash_table_test_test.obj
    if exist ipr_hash_table_test_test.exe del ipr_hash_table_test_test.exe
    if exist ipr_hash_table.obj del ipr_hash_table.obj
    if exist ipr_http_test_test.obj del ipr_http_test_test.obj
    if exist ipr_http_test_test.exe del ipr_http_test_test.exe
    if exist ipr_http.obj del ipr_http.obj
    if exist ipr_index_test_test.obj del ipr_index_test_test.obj
    if exist ipr_index_test_test.exe del ipr_index_test_test.exe
    if exist ipr_index.obj del ipr_index.obj
    if exist ipr_log_test_test.obj del ipr_log_test_test.obj
    if exist ipr_log_test_test.exe del ipr_log_test_test.exe
    if exist ipr_log.obj del ipr_log.obj
    if exist ipr_looseref_test_test.obj del ipr_looseref_test_test.obj
    if exist ipr_looseref_test_test.exe del ipr_looseref_test_test.exe
    if exist ipr_looseref.obj del ipr_looseref.obj
    if exist ipr_looseref_list_test_test.obj del ipr_looseref_list_test_test.obj
    if exist ipr_looseref_list_test_test.exe del ipr_looseref_list_test_test.exe
    if exist ipr_looseref_list.obj del ipr_looseref_list.obj
    if exist ipr_token_test_test.obj del ipr_token_test_test.obj
    if exist ipr_token_test_test.exe del ipr_token_test_test.exe
    if exist ipr_token.obj del ipr_token.obj
    if exist ipr_token_list_test_test.obj del ipr_token_list_test_test.obj
    if exist ipr_token_list_test_test.exe del ipr_token_list_test_test.exe
    if exist ipr_token_list.obj del ipr_token_list.obj
    if exist ipr_meter_test_test.obj del ipr_meter_test_test.obj
    if exist ipr_meter_test_test.exe del ipr_meter_test_test.exe
    if exist ipr_meter.obj del ipr_meter.obj
    if exist ipr_net_test_test.obj del ipr_net_test_test.obj
    if exist ipr_net_test_test.exe del ipr_net_test_test.exe
    if exist ipr_net.obj del ipr_net.obj
    if exist ipr_nonce_test_test.obj del ipr_nonce_test_test.obj
    if exist ipr_nonce_test_test.exe del ipr_nonce_test_test.exe
    if exist ipr_nonce.obj del ipr_nonce.obj
    if exist ipr_nonce_table_test_test.obj del ipr_nonce_table_test_test.obj
    if exist ipr_nonce_table_test_test.exe del ipr_nonce_table_test_test.exe
    if exist ipr_nonce_table.obj del ipr_nonce_table.obj
    if exist ipr_password_test_test.obj del ipr_password_test_test.obj
    if exist ipr_password_test_test.exe del ipr_password_test_test.exe
    if exist ipr_password.obj del ipr_password.obj
    if exist ipr_password_table_test_test.obj del ipr_password_table_test_test.obj
    if exist ipr_password_table_test_test.exe del ipr_password_table_test_test.exe
    if exist ipr_password_table.obj del ipr_password_table.obj
    if exist ipr_password_list_test_test.obj del ipr_password_list_test_test.obj
    if exist ipr_password_list_test_test.exe del ipr_password_list_test_test.exe
    if exist ipr_password_list.obj del ipr_password_list.obj
    if exist ipr_path_test_test.obj del ipr_path_test_test.obj
    if exist ipr_path_test_test.exe del ipr_path_test_test.exe
    if exist ipr_path.obj del ipr_path.obj
    if exist ipr_process_test_test.obj del ipr_process_test_test.obj
    if exist ipr_process_test_test.exe del ipr_process_test_test.exe
    if exist ipr_process.obj del ipr_process.obj
    if exist ipr_regexp_test_test.obj del ipr_regexp_test_test.obj
    if exist ipr_regexp_test_test.exe del ipr_regexp_test_test.exe
    if exist ipr_regexp.obj del ipr_regexp.obj
    if exist ipr_sasl_test_test.obj del ipr_sasl_test_test.obj
    if exist ipr_sasl_test_test.exe del ipr_sasl_test_test.exe
    if exist ipr_sasl.obj del ipr_sasl.obj
    if exist ipr_stat_test_test.obj del ipr_stat_test_test.obj
    if exist ipr_stat_test_test.exe del ipr_stat_test_test.exe
    if exist ipr_stat.obj del ipr_stat.obj
    if exist ipr_str_test_test.obj del ipr_str_test_test.obj
    if exist ipr_str_test_test.exe del ipr_str_test_test.exe
    if exist ipr_str.obj del ipr_str.obj
    if exist ipr_uid_test_test.obj del ipr_uid_test_test.obj
    if exist ipr_uid_test_test.exe del ipr_uid_test_test.exe
    if exist ipr_uid.obj del ipr_uid.obj
    if exist ipr_time_test_test.obj del ipr_time_test_test.obj
    if exist ipr_time_test_test.exe del ipr_time_test_test.exe
    if exist ipr_time.obj del ipr_time.obj
    if exist ipr_tree_test_test.obj del ipr_tree_test_test.obj
    if exist ipr_tree_test_test.exe del ipr_tree_test_test.exe
    if exist ipr_tree.obj del ipr_tree.obj
    if exist ipr_xml_test_test.obj del ipr_xml_test_test.obj
    if exist ipr_xml_test_test.exe del ipr_xml_test_test.exe
    if exist ipr_xml.obj del ipr_xml.obj
    if exist ipr_xml_list_test_test.obj del ipr_xml_list_test_test.obj
    if exist ipr_xml_list_test_test.exe del ipr_xml_list_test_test.exe
    if exist ipr_xml_list.obj del ipr_xml_list.obj
    if exist ipr_xml_attr_test_test.obj del ipr_xml_attr_test_test.obj
    if exist ipr_xml_attr_test_test.exe del ipr_xml_attr_test_test.exe
    if exist ipr_xml_attr.obj del ipr_xml_attr.obj
    if exist ipr_xml_attr_list_test_test.obj del ipr_xml_attr_list_test_test.obj
    if exist ipr_xml_attr_list_test_test.exe del ipr_xml_attr_list_test_test.exe
    if exist ipr_xml_attr_list.obj del ipr_xml_attr_list.obj
    if exist ipr_xmll.obj del ipr_xmll.obj
    if exist ipr_demo_portal_test_test.obj del ipr_demo_portal_test_test.obj
    if exist ipr_demo_portal_test_test.exe del ipr_demo_portal_test_test.exe
    if exist ipr_demo_portal.obj del ipr_demo_portal.obj
    if exist ipr_demo_portal_client_test_test.obj del ipr_demo_portal_client_test_test.obj
    if exist ipr_demo_portal_client_test_test.exe del ipr_demo_portal_client_test_test.exe
    if exist ipr_demo_portal_client.obj del ipr_demo_portal_client.obj
    if exist ipr_demo_portal_server_test_test.obj del ipr_demo_portal_server_test_test.obj
    if exist ipr_demo_portal_server_test_test.exe del ipr_demo_portal_server_test_test.exe
    if exist ipr_demo_portal_server.obj del ipr_demo_portal_server.obj
    if exist ipr_bits_test.obj del ipr_bits_test.obj
    if exist ipr_bits_test.exe del ipr_bits_test.exe
    if exist ipr_bits.obj del ipr_bits.obj
    if exist ipr_bucket_test.obj del ipr_bucket_test.obj
    if exist ipr_bucket_test.exe del ipr_bucket_test.exe
    if exist ipr_bucket.obj del ipr_bucket.obj
    if exist ipr_bucket_list_test.obj del ipr_bucket_list_test.obj
    if exist ipr_bucket_list_test.exe del ipr_bucket_list_test.exe
    if exist ipr_bucket_list.obj del ipr_bucket_list.obj
    if exist ipr_mother_test.obj del ipr_mother_test.obj
    if exist ipr_mother_test.exe del ipr_mother_test.exe
    if exist ipr_mother.obj del ipr_mother.obj
    if exist ipr_config_test.obj del ipr_config_test.obj
    if exist ipr_config_test.exe del ipr_config_test.exe
    if exist ipr_config.obj del ipr_config.obj
    if exist ipr_crc_test.obj del ipr_crc_test.obj
    if exist ipr_crc_test.exe del ipr_crc_test.exe
    if exist ipr_crc.obj del ipr_crc.obj
    if exist ipr_dict_test.obj del ipr_dict_test.obj
    if exist ipr_dict_test.exe del ipr_dict_test.exe
    if exist ipr_dict.obj del ipr_dict.obj
    if exist ipr_dict_table_test.obj del ipr_dict_table_test.obj
    if exist ipr_dict_table_test.exe del ipr_dict_table_test.exe
    if exist ipr_dict_table.obj del ipr_dict_table.obj
    if exist ipr_dict_list_test.obj del ipr_dict_list_test.obj
    if exist ipr_dict_list_test.exe del ipr_dict_list_test.exe
    if exist ipr_dict_list.obj del ipr_dict_list.obj
    if exist ipr_symbol_test.obj del ipr_symbol_test.obj
    if exist ipr_symbol_test.exe del ipr_symbol_test.exe
    if exist ipr_symbol.obj del ipr_symbol.obj
    if exist ipr_symbol_table_test.obj del ipr_symbol_table_test.obj
    if exist ipr_symbol_table_test.exe del ipr_symbol_table_test.exe
    if exist ipr_symbol_table.obj del ipr_symbol_table.obj
    if exist ipr_dir_test.obj del ipr_dir_test.obj
    if exist ipr_dir_test.exe del ipr_dir_test.exe
    if exist ipr_dir.obj del ipr_dir.obj
    if exist ipr_file_test.obj del ipr_file_test.obj
    if exist ipr_file_test.exe del ipr_file_test.exe
    if exist ipr_file.obj del ipr_file.obj
    if exist ipr_finfo_test.obj del ipr_finfo_test.obj
    if exist ipr_finfo_test.exe del ipr_finfo_test.exe
    if exist ipr_finfo.obj del ipr_finfo.obj
    if exist ipr_finfo_list_test.obj del ipr_finfo_list_test.obj
    if exist ipr_finfo_list_test.exe del ipr_finfo_list_test.exe
    if exist ipr_finfo_list.obj del ipr_finfo_list.obj
    if exist ipr_hash_test.obj del ipr_hash_test.obj
    if exist ipr_hash_test.exe del ipr_hash_test.exe
    if exist ipr_hash.obj del ipr_hash.obj
    if exist ipr_hash_table_test.obj del ipr_hash_table_test.obj
    if exist ipr_hash_table_test.exe del ipr_hash_table_test.exe
    if exist ipr_hash_table.obj del ipr_hash_table.obj
    if exist ipr_http_test.obj del ipr_http_test.obj
    if exist ipr_http_test.exe del ipr_http_test.exe
    if exist ipr_http.obj del ipr_http.obj
    if exist ipr_index_test.obj del ipr_index_test.obj
    if exist ipr_index_test.exe del ipr_index_test.exe
    if exist ipr_index.obj del ipr_index.obj
    if exist ipr_log_test.obj del ipr_log_test.obj
    if exist ipr_log_test.exe del ipr_log_test.exe
    if exist ipr_log.obj del ipr_log.obj
    if exist ipr_looseref_test.obj del ipr_looseref_test.obj
    if exist ipr_looseref_test.exe del ipr_looseref_test.exe
    if exist ipr_looseref.obj del ipr_looseref.obj
    if exist ipr_looseref_list_test.obj del ipr_looseref_list_test.obj
    if exist ipr_looseref_list_test.exe del ipr_looseref_list_test.exe
    if exist ipr_looseref_list.obj del ipr_looseref_list.obj
    if exist ipr_token_test.obj del ipr_token_test.obj
    if exist ipr_token_test.exe del ipr_token_test.exe
    if exist ipr_token.obj del ipr_token.obj
    if exist ipr_token_list_test.obj del ipr_token_list_test.obj
    if exist ipr_token_list_test.exe del ipr_token_list_test.exe
    if exist ipr_token_list.obj del ipr_token_list.obj
    if exist ipr_meter_test.obj del ipr_meter_test.obj
    if exist ipr_meter_test.exe del ipr_meter_test.exe
    if exist ipr_meter.obj del ipr_meter.obj
    if exist ipr_net_test.obj del ipr_net_test.obj
    if exist ipr_net_test.exe del ipr_net_test.exe
    if exist ipr_net.obj del ipr_net.obj
    if exist ipr_nonce_test.obj del ipr_nonce_test.obj
    if exist ipr_nonce_test.exe del ipr_nonce_test.exe
    if exist ipr_nonce.obj del ipr_nonce.obj
    if exist ipr_nonce_table_test.obj del ipr_nonce_table_test.obj
    if exist ipr_nonce_table_test.exe del ipr_nonce_table_test.exe
    if exist ipr_nonce_table.obj del ipr_nonce_table.obj
    if exist ipr_password_test.obj del ipr_password_test.obj
    if exist ipr_password_test.exe del ipr_password_test.exe
    if exist ipr_password.obj del ipr_password.obj
    if exist ipr_password_table_test.obj del ipr_password_table_test.obj
    if exist ipr_password_table_test.exe del ipr_password_table_test.exe
    if exist ipr_password_table.obj del ipr_password_table.obj
    if exist ipr_password_list_test.obj del ipr_password_list_test.obj
    if exist ipr_password_list_test.exe del ipr_password_list_test.exe
    if exist ipr_password_list.obj del ipr_password_list.obj
    if exist ipr_path_test.obj del ipr_path_test.obj
    if exist ipr_path_test.exe del ipr_path_test.exe
    if exist ipr_path.obj del ipr_path.obj
    if exist ipr_process_test.obj del ipr_process_test.obj
    if exist ipr_process_test.exe del ipr_process_test.exe
    if exist ipr_process.obj del ipr_process.obj
    if exist ipr_regexp_test.obj del ipr_regexp_test.obj
    if exist ipr_regexp_test.exe del ipr_regexp_test.exe
    if exist ipr_regexp.obj del ipr_regexp.obj
    if exist ipr_sasl_test.obj del ipr_sasl_test.obj
    if exist ipr_sasl_test.exe del ipr_sasl_test.exe
    if exist ipr_sasl.obj del ipr_sasl.obj
    if exist ipr_stat_test.obj del ipr_stat_test.obj
    if exist ipr_stat_test.exe del ipr_stat_test.exe
    if exist ipr_stat.obj del ipr_stat.obj
    if exist ipr_str_test.obj del ipr_str_test.obj
    if exist ipr_str_test.exe del ipr_str_test.exe
    if exist ipr_str.obj del ipr_str.obj
    if exist ipr_uid_test.obj del ipr_uid_test.obj
    if exist ipr_uid_test.exe del ipr_uid_test.exe
    if exist ipr_uid.obj del ipr_uid.obj
    if exist ipr_time_test.obj del ipr_time_test.obj
    if exist ipr_time_test.exe del ipr_time_test.exe
    if exist ipr_time.obj del ipr_time.obj
    if exist ipr_tree_test.obj del ipr_tree_test.obj
    if exist ipr_tree_test.exe del ipr_tree_test.exe
    if exist ipr_tree.obj del ipr_tree.obj
    if exist ipr_xml_test.obj del ipr_xml_test.obj
    if exist ipr_xml_test.exe del ipr_xml_test.exe
    if exist ipr_xml.obj del ipr_xml.obj
    if exist ipr_xml_list_test.obj del ipr_xml_list_test.obj
    if exist ipr_xml_list_test.exe del ipr_xml_list_test.exe
    if exist ipr_xml_list.obj del ipr_xml_list.obj
    if exist ipr_xml_attr_test.obj del ipr_xml_attr_test.obj
    if exist ipr_xml_attr_test.exe del ipr_xml_attr_test.exe
    if exist ipr_xml_attr.obj del ipr_xml_attr.obj
    if exist ipr_xml_attr_list_test.obj del ipr_xml_attr_list_test.obj
    if exist ipr_xml_attr_list_test.exe del ipr_xml_attr_list_test.exe
    if exist ipr_xml_attr_list.obj del ipr_xml_attr_list.obj
    if exist ipr_demo_portal_test.obj del ipr_demo_portal_test.obj
    if exist ipr_demo_portal_test.exe del ipr_demo_portal_test.exe
    if exist ipr_demo_portal.obj del ipr_demo_portal.obj
    if exist ipr_demo_portal_client_test.obj del ipr_demo_portal_client_test.obj
    if exist ipr_demo_portal_client_test.exe del ipr_demo_portal_client_test.exe
    if exist ipr_demo_portal_client.obj del ipr_demo_portal_client.obj
    if exist ipr_demo_portal_server_test.obj del ipr_demo_portal_server_test.obj
    if exist ipr_demo_portal_server_test.exe del ipr_demo_portal_server_test.exe
    if exist ipr_demo_portal_server.obj del ipr_demo_portal_server.obj
    if exist vc60.pdb del vc60.pdb
    goto :eof

:------------------------   REMOVE GENERATED SOURCES   ------------------------

:a_remove_generated_sources
    if exist ipr_dict_list.icl del ipr_dict_list.icl
    if exist ipr_symbol_table.icl del ipr_symbol_table.icl
    if exist ipr_finfo_list.icl del ipr_finfo_list.icl
    if exist ipr_hash_table.icl del ipr_hash_table.icl
    if exist ipr_looseref_list.icl del ipr_looseref_list.icl
    if exist ipr_nonce_table.icl del ipr_nonce_table.icl
    if exist ipr_password_list.icl del ipr_password_list.icl
    if exist ipr_xml_list.icl del ipr_xml_list.icl
    if exist ipr_xml_attr_list.icl del ipr_xml_attr_list.icl
    if exist ipr_demo_portal_front.icl del ipr_demo_portal_front.icl
    if exist ipr_demo_portal_back.icl del ipr_demo_portal_back.icl
    if exist ipr.h del ipr.h
    if exist ipr_bits_test.c del ipr_bits_test.c
    if exist ipr_bits.h del ipr_bits.h
    if exist ipr_bits.c del ipr_bits.c
    if exist ipr_bucket_test.c del ipr_bucket_test.c
    if exist ipr_bucket.h del ipr_bucket.h
    if exist ipr_bucket.c del ipr_bucket.c
    if exist ipr_bucket_list_test.c del ipr_bucket_list_test.c
    if exist ipr_bucket_list.h del ipr_bucket_list.h
    if exist ipr_bucket_list.c del ipr_bucket_list.c
    if exist ipr_mother_test.c del ipr_mother_test.c
    if exist ipr_mother.h del ipr_mother.h
    if exist ipr_mother.c del ipr_mother.c
    if exist ipr_config_test.c del ipr_config_test.c
    if exist ipr_config.h del ipr_config.h
    if exist ipr_config.c del ipr_config.c
    if exist ipr_crc_test.c del ipr_crc_test.c
    if exist ipr_crc.h del ipr_crc.h
    if exist ipr_crc.c del ipr_crc.c
    if exist ipr_dict_test.c del ipr_dict_test.c
    if exist ipr_dict.h del ipr_dict.h
    if exist ipr_dict.c del ipr_dict.c
    if exist ipr_dict_table_test.c del ipr_dict_table_test.c
    if exist ipr_dict_table.h del ipr_dict_table.h
    if exist ipr_dict_table.c del ipr_dict_table.c
    if exist ipr_dict_list_test.c del ipr_dict_list_test.c
    if exist ipr_dict_list.h del ipr_dict_list.h
    if exist ipr_dict_list.c del ipr_dict_list.c
    if exist ipr_symbol_test.c del ipr_symbol_test.c
    if exist ipr_symbol.h del ipr_symbol.h
    if exist ipr_symbol.c del ipr_symbol.c
    if exist ipr_symbol_table_test.c del ipr_symbol_table_test.c
    if exist ipr_symbol_table.h del ipr_symbol_table.h
    if exist ipr_symbol_table.c del ipr_symbol_table.c
    if exist ipr_dir_test.c del ipr_dir_test.c
    if exist ipr_dir.h del ipr_dir.h
    if exist ipr_dir.c del ipr_dir.c
    if exist ipr_file_test.c del ipr_file_test.c
    if exist ipr_file.h del ipr_file.h
    if exist ipr_file.c del ipr_file.c
    if exist ipr_finfo_test.c del ipr_finfo_test.c
    if exist ipr_finfo.h del ipr_finfo.h
    if exist ipr_finfo.c del ipr_finfo.c
    if exist ipr_finfo_list_test.c del ipr_finfo_list_test.c
    if exist ipr_finfo_list.h del ipr_finfo_list.h
    if exist ipr_finfo_list.c del ipr_finfo_list.c
    if exist ipr_hash_test.c del ipr_hash_test.c
    if exist ipr_hash.h del ipr_hash.h
    if exist ipr_hash.c del ipr_hash.c
    if exist ipr_hash_table_test.c del ipr_hash_table_test.c
    if exist ipr_hash_table.h del ipr_hash_table.h
    if exist ipr_hash_table.c del ipr_hash_table.c
    if exist ipr_http_test.c del ipr_http_test.c
    if exist ipr_http.h del ipr_http.h
    if exist ipr_http.c del ipr_http.c
    if exist ipr_index_test.c del ipr_index_test.c
    if exist ipr_index.h del ipr_index.h
    if exist ipr_index.c del ipr_index.c
    if exist ipr_log_test.c del ipr_log_test.c
    if exist ipr_log.h del ipr_log.h
    if exist ipr_log.c del ipr_log.c
    if exist ipr_looseref_test.c del ipr_looseref_test.c
    if exist ipr_looseref.h del ipr_looseref.h
    if exist ipr_looseref.c del ipr_looseref.c
    if exist ipr_looseref_list_test.c del ipr_looseref_list_test.c
    if exist ipr_looseref_list.h del ipr_looseref_list.h
    if exist ipr_looseref_list.c del ipr_looseref_list.c
    if exist ipr_token_test.c del ipr_token_test.c
    if exist ipr_token.h del ipr_token.h
    if exist ipr_token.c del ipr_token.c
    if exist ipr_token_list_test.c del ipr_token_list_test.c
    if exist ipr_token_list.h del ipr_token_list.h
    if exist ipr_token_list.c del ipr_token_list.c
    if exist ipr_meter_test.c del ipr_meter_test.c
    if exist ipr_meter.h del ipr_meter.h
    if exist ipr_meter.c del ipr_meter.c
    if exist ipr_net_test.c del ipr_net_test.c
    if exist ipr_net.h del ipr_net.h
    if exist ipr_net.c del ipr_net.c
    if exist ipr_nonce_test.c del ipr_nonce_test.c
    if exist ipr_nonce.h del ipr_nonce.h
    if exist ipr_nonce.c del ipr_nonce.c
    if exist ipr_nonce_table_test.c del ipr_nonce_table_test.c
    if exist ipr_nonce_table.h del ipr_nonce_table.h
    if exist ipr_nonce_table.c del ipr_nonce_table.c
    if exist ipr_password_test.c del ipr_password_test.c
    if exist ipr_password.h del ipr_password.h
    if exist ipr_password.c del ipr_password.c
    if exist ipr_password_table_test.c del ipr_password_table_test.c
    if exist ipr_password_table.h del ipr_password_table.h
    if exist ipr_password_table.c del ipr_password_table.c
    if exist ipr_password_list_test.c del ipr_password_list_test.c
    if exist ipr_password_list.h del ipr_password_list.h
    if exist ipr_password_list.c del ipr_password_list.c
    if exist ipr_path_test.c del ipr_path_test.c
    if exist ipr_path.h del ipr_path.h
    if exist ipr_path.c del ipr_path.c
    if exist ipr_process_test.c del ipr_process_test.c
    if exist ipr_process.h del ipr_process.h
    if exist ipr_process.c del ipr_process.c
    if exist ipr_regexp_test.c del ipr_regexp_test.c
    if exist ipr_regexp.h del ipr_regexp.h
    if exist ipr_regexp.c del ipr_regexp.c
    if exist ipr_sasl_test.c del ipr_sasl_test.c
    if exist ipr_sasl.h del ipr_sasl.h
    if exist ipr_sasl.c del ipr_sasl.c
    if exist ipr_stat_test.c del ipr_stat_test.c
    if exist ipr_stat.h del ipr_stat.h
    if exist ipr_stat.c del ipr_stat.c
    if exist ipr_str_test.c del ipr_str_test.c
    if exist ipr_str.h del ipr_str.h
    if exist ipr_str.c del ipr_str.c
    if exist ipr_uid_test.c del ipr_uid_test.c
    if exist ipr_uid.h del ipr_uid.h
    if exist ipr_uid.c del ipr_uid.c
    if exist ipr_time_test.c del ipr_time_test.c
    if exist ipr_time.h del ipr_time.h
    if exist ipr_time.c del ipr_time.c
    if exist ipr_tree_test.c del ipr_tree_test.c
    if exist ipr_tree.h del ipr_tree.h
    if exist ipr_tree.c del ipr_tree.c
    if exist ipr_xml_test.c del ipr_xml_test.c
    if exist ipr_xml.h del ipr_xml.h
    if exist ipr_xml.c del ipr_xml.c
    if exist ipr_xml_list_test.c del ipr_xml_list_test.c
    if exist ipr_xml_list.h del ipr_xml_list.h
    if exist ipr_xml_list.c del ipr_xml_list.c
    if exist ipr_xml_attr_test.c del ipr_xml_attr_test.c
    if exist ipr_xml_attr.h del ipr_xml_attr.h
    if exist ipr_xml_attr.c del ipr_xml_attr.c
    if exist ipr_xml_attr_list_test.c del ipr_xml_attr_list_test.c
    if exist ipr_xml_attr_list.h del ipr_xml_attr_list.h
    if exist ipr_xml_attr_list.c del ipr_xml_attr_list.c
    if exist ipr_demo_portal_test.c del ipr_demo_portal_test.c
    if exist ipr_demo_portal.h del ipr_demo_portal.h
    if exist ipr_demo_portal.c del ipr_demo_portal.c
    if exist ipr_demo_portal_client_test.c del ipr_demo_portal_client_test.c
    if exist ipr_demo_portal_client.h del ipr_demo_portal_client.h
    if exist ipr_demo_portal_client.c del ipr_demo_portal_client.c
    if exist ipr_demo_portal_server_test.c del ipr_demo_portal_server_test.c
    if exist ipr_demo_portal_server.h del ipr_demo_portal_server.h
    if exist ipr_demo_portal_server.c del ipr_demo_portal_server.c
    if exist stamp_generate del stamp_generate
    if exist configure del configure
    if exist Makefile.unix del Makefile.unix
    if exist configure.bat del configure.bat
    if exist Makefile.win32 del Makefile.win32
    if exist libipr.vcproj del libipr.vcproj
    if exist ipr_*.zip del ipr_*.zip
    goto :eof

:-------------------------   REPORT HELP INFORMATION   ------------------------

:a_report_help_information
    echo The commands you can currently use on this project are:
    echo.
    goto r_!state!
    goto :eof

:-------------------------   REPORT PROJECT VERSION   -------------------------

:a_report_project_version
    echo ipr-1.0a1
    goto :eof

:--------------------------   RUN REGRESSION TESTS   --------------------------

:a_run_regression_tests
    echo boom I: [ipr]: Running regression tests...
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_bits_test
    ) else (
        set RUN_COMMAND=ipr_bits_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_bucket_test
    ) else (
        set RUN_COMMAND=ipr_bucket_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_bucket_list_test
    ) else (
        set RUN_COMMAND=ipr_bucket_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_mother_test
    ) else (
        set RUN_COMMAND=ipr_mother_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_config_test
    ) else (
        set RUN_COMMAND=ipr_config_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_crc_test
    ) else (
        set RUN_COMMAND=ipr_crc_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_dict_test
    ) else (
        set RUN_COMMAND=ipr_dict_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_dict_table_test
    ) else (
        set RUN_COMMAND=ipr_dict_table_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_dict_list_test
    ) else (
        set RUN_COMMAND=ipr_dict_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_symbol_test
    ) else (
        set RUN_COMMAND=ipr_symbol_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_symbol_table_test
    ) else (
        set RUN_COMMAND=ipr_symbol_table_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_dir_test
    ) else (
        set RUN_COMMAND=ipr_dir_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_file_test
    ) else (
        set RUN_COMMAND=ipr_file_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_finfo_test
    ) else (
        set RUN_COMMAND=ipr_finfo_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_finfo_list_test
    ) else (
        set RUN_COMMAND=ipr_finfo_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_hash_test
    ) else (
        set RUN_COMMAND=ipr_hash_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_hash_table_test
    ) else (
        set RUN_COMMAND=ipr_hash_table_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_http_test
    ) else (
        set RUN_COMMAND=ipr_http_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_index_test
    ) else (
        set RUN_COMMAND=ipr_index_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_log_test
    ) else (
        set RUN_COMMAND=ipr_log_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_looseref_test
    ) else (
        set RUN_COMMAND=ipr_looseref_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_looseref_list_test
    ) else (
        set RUN_COMMAND=ipr_looseref_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_token_test
    ) else (
        set RUN_COMMAND=ipr_token_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_token_list_test
    ) else (
        set RUN_COMMAND=ipr_token_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_meter_test
    ) else (
        set RUN_COMMAND=ipr_meter_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_net_test
    ) else (
        set RUN_COMMAND=ipr_net_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_nonce_test
    ) else (
        set RUN_COMMAND=ipr_nonce_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_nonce_table_test
    ) else (
        set RUN_COMMAND=ipr_nonce_table_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_password_test
    ) else (
        set RUN_COMMAND=ipr_password_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_password_table_test
    ) else (
        set RUN_COMMAND=ipr_password_table_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_password_list_test
    ) else (
        set RUN_COMMAND=ipr_password_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_path_test
    ) else (
        set RUN_COMMAND=ipr_path_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_process_test
    ) else (
        set RUN_COMMAND=ipr_process_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_regexp_test
    ) else (
        set RUN_COMMAND=ipr_regexp_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_sasl_test
    ) else (
        set RUN_COMMAND=ipr_sasl_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_stat_test
    ) else (
        set RUN_COMMAND=ipr_stat_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_str_test
    ) else (
        set RUN_COMMAND=ipr_str_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_uid_test
    ) else (
        set RUN_COMMAND=ipr_uid_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_time_test
    ) else (
        set RUN_COMMAND=ipr_time_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_tree_test
    ) else (
        set RUN_COMMAND=ipr_tree_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_xml_test
    ) else (
        set RUN_COMMAND=ipr_xml_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_xml_list_test
    ) else (
        set RUN_COMMAND=ipr_xml_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_xml_attr_test
    ) else (
        set RUN_COMMAND=ipr_xml_attr_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_xml_attr_list_test
    ) else (
        set RUN_COMMAND=ipr_xml_attr_list_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_demo_portal_test
    ) else (
        set RUN_COMMAND=ipr_demo_portal_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_demo_portal_client_test
    ) else (
        set RUN_COMMAND=ipr_demo_portal_client_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    if "!BOOM_TRACE!"=="1" (
        set RUN_COMMAND=ipr_demo_portal_server_test
    ) else (
        set RUN_COMMAND=ipr_demo_portal_server_test -q
    )
    if "!BOOM_TRACE!"=="1" echo !RUN_COMMAND!
    verify>nul
    call !RUN_COMMAND!
    if errorlevel 1 (
        echo boom E: [ipr]: '!RUN_COMMAND!' failed - stop.
        set _exception=1
        goto :eof
    )
    :-  Run local selftest script if present
    if exist selftest.bat (
    if "!BOOM_TRACE!"=="1" echo selftest
    verify>nul
    call selftest
    if errorlevel 1 (
        echo boom E: [ipr]: 'selftest' failed - stop.
        set _exception=1
        goto :eof
    )
    )
    goto :eof

:-----------------------   USE SOURCE CONTROL REVISION   ----------------------

:a_use_source_control_revision
    set SVN_REVISION=svn
    if exist .svn
ul (
        for /f "usebackq tokens=1,2 delims=: " %%v in (`svn info`) do if "%%v"=="Revision" set SVN_REVISION=%%w
    )
    set MY_VERSION=!MY_VERSION!-!SVN_REVISION!
    goto :eof

:s_initial
    if "!debug!"=="1" echo State: initial
    if "!event!"=="" goto s_1_empty
    if "!event!"=="ok" goto s_1_1
    goto s_win32
:s_1_1
    if "!debug!"=="1" echo Event: ok
    set event=
    if "!debug!"=="1" echo Action: check operating context
    set _exception=
    call :a_check_operating_context
    if "!_exception!"=="1" exit /b 1
    set state=initial_check
    goto s_!state!
:s_1_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_initial
:r_initial
    goto r_win32

:s_initial_check
    if "!debug!"=="1" echo State: initial check
    if "!event!"=="" goto s_2_empty
    if "!event!"=="repository" goto s_2_1
    if "!event!"=="source" goto s_2_2
    if "!event!"=="stripped" goto s_2_3
    goto s_win32
:s_2_1
    if "!debug!"=="1" echo Event: repository
    set event=
    set state=repository
    goto s_!state!
:s_2_2
    if "!debug!"=="1" echo Event: source
    set event=
    set state=source
    goto s_!state!
:s_2_3
    if "!debug!"=="1" echo Event: stripped
    set event=
    set state=stripped
    goto s_!state!
:s_2_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_initial_check
:r_initial_check
    goto r_win32

:s_repository
    if "!debug!"=="1" echo State: repository
    if "!event!"=="" goto s_3_empty
    if "!event!"=="build" goto s_3_1
    if "!event!"=="compile" goto s_3_2
    if "!event!"=="clean" goto s_3_3
    if "!event!"=="regen" goto s_3_4
    if "!event!"=="allgen" goto s_3_5
    if "!event!"=="distrib" goto s_3_6
    if "!event!"=="distsrc" goto s_3_7
    if "!event!"=="distrev" goto s_3_8
    goto s_default
:s_3_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: check project files exist
    set _exception=
    call :a_check_project_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: produce generated files
    set _exception=
    call :a_produce_generated_files
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: check source files exist
    set _exception=
    call :a_check_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build binary files
    set _exception=
    call :a_build_binary_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_2
    if "!debug!"=="1" echo Event: compile
    set event=
    if "!debug!"=="1" echo Action: check source files exist
    set _exception=
    call :a_check_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build binary files
    set _exception=
    call :a_build_binary_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_3
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: remove generated sources
    set _exception=
    call :a_remove_generated_sources
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: remove generated binaries
    set _exception=
    call :a_remove_generated_binaries
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_4
    if "!debug!"=="1" echo Event: regen
    set event=
    if "!debug!"=="1" echo Action: check project files exist
    set _exception=
    call :a_check_project_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: produce generated files
    set _exception=
    call :a_produce_generated_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_5
    if "!debug!"=="1" echo Event: allgen
    set event=
    if "!debug!"=="1" echo Action: check project files exist
    set _exception=
    call :a_check_project_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: produce all generated files
    set _exception=
    call :a_produce_all_generated_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_6
    if "!debug!"=="1" echo Event: distrib
    set event=
    if "!debug!"=="1" echo Action: produce all generated files
    set _exception=
    call :a_produce_all_generated_files
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: check all source files exist
    set _exception=
    call :a_check_all_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build source packages
    set _exception=
    call :a_build_source_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_7
    if "!debug!"=="1" echo Event: distsrc
    set event=
    if "!debug!"=="1" echo Action: produce all generated files
    set _exception=
    call :a_produce_all_generated_files
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: check all source files exist
    set _exception=
    call :a_check_all_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build source packages
    set _exception=
    call :a_build_source_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_8
    if "!debug!"=="1" echo Event: distrev
    set event=
    if "!debug!"=="1" echo Action: produce all generated files
    set _exception=
    call :a_produce_all_generated_files
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: check all source files exist
    set _exception=
    call :a_check_all_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: use source control revision
    set _exception=
    call :a_use_source_control_revision
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build source packages
    set _exception=
    call :a_build_source_packages
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_3_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_repository
:r_repository
echo build:
    echo   From the raw project sources, produces all generated files, and
    echo     compiles all source files.
echo compile:
    echo   From the raw project sources, compiles all source files without any
    echo     code generation.
echo clean:
    echo   When working with the raw project sources, removes all generated
    echo     source and binary files from the project directory.
echo regen:
    echo   Produces generated files required for building using the
    echo     current model.
echo allgen:
    echo   Produces all generated files.
echo distrib:
    echo   Creates a source distribution for the project.  Note that binary
    echo     distributions can only be created at the product level.
echo distsrc:
    echo   Equivalent to distrib, provided for compatibility.
echo distrev:
    echo   Creates a source distribution for the project.  Builds distribution
    echo     packages based on source control version number. Note that binary
    echo     distributions can only be created at the product level.
    goto r_default

:s_source
    if "!debug!"=="1" echo State: source
    if "!event!"=="" goto s_4_empty
    if "!event!"=="build" goto s_4_1
    if "!event!"=="clean" goto s_4_2
    if "!event!"=="regen" goto s_4_3
    if "!event!"=="allgen" goto s_4_4
    goto s_default
:s_4_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: check source files exist
    set _exception=
    call :a_check_source_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: build binary files
    set _exception=
    call :a_build_binary_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_2
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: remove generated binaries
    set _exception=
    call :a_remove_generated_binaries
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_3
    if "!debug!"=="1" echo Event: regen
    set event=
    if "!debug!"=="1" echo Action: check project files exist
    set _exception=
    call :a_check_project_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: produce generated files
    set _exception=
    call :a_produce_generated_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_4
    if "!debug!"=="1" echo Event: allgen
    set event=
    if "!debug!"=="1" echo Action: check project files exist
    set _exception=
    call :a_check_project_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: produce all generated files
    set _exception=
    call :a_produce_all_generated_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_4_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_source
:r_source
echo build:
    echo   From the packaged sources, compiles all source files without any
    echo     code generation.
echo clean:
    echo   When working with the packaged sources, removes all generated
    echo     binary files from the project directory.
echo regen:
    echo   Produces generated files required for building using the
    echo     current model.
echo allgen:
    echo   Produces all generated files.
    goto r_default

:s_stripped
    if "!debug!"=="1" echo State: stripped
    if "!event!"=="" goto s_5_empty
    if "!event!"=="build" goto s_5_1
    if "!event!"=="clean" goto s_5_2
    goto s_default
:s_5_1
    if "!debug!"=="1" echo Event: build
    set event=
    if "!debug!"=="1" echo Action: build binary files
    set _exception=
    call :a_build_binary_files
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_5_2
    if "!debug!"=="1" echo Event: clean
    set event=
    if "!debug!"=="1" echo Action: remove generated binaries
    set _exception=
    call :a_remove_generated_binaries
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_5_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_stripped
:r_stripped
echo build:
    echo   From the stripped-down packaged sources, compiles all source files
    echo     without any code generation.
echo clean:
    echo   When working with the packaged sources, removes all generated
    echo     binary files from the project directory.
    goto r_default

:s_default
    if "!debug!"=="1" echo State: default
    if "!event!"=="" goto s_6_empty
    if "!event!"=="install" goto s_6_1
    if "!event!"=="test" goto s_6_2
    if "!event!"=="help" goto s_6_3
    if "!event!"=="version" goto s_6_4
    if "!event!"=="empty" goto s_6_5
    goto s_win32
:s_6_1
    if "!debug!"=="1" echo Event: install
    set event=
    if "!debug!"=="1" echo Action: check binary files exist
    set _exception=
    call :a_check_binary_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: install deliverables
    set _exception=
    call :a_install_deliverables
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_2
    if "!debug!"=="1" echo Event: test
    set event=
    if "!debug!"=="1" echo Action: check binary files exist
    set _exception=
    call :a_check_binary_files_exist
    if "!_exception!"=="1" exit /b 1
    if "!debug!"=="1" echo Action: run regression tests
    set _exception=
    call :a_run_regression_tests
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_3
    if "!debug!"=="1" echo Event: help
    set event=
    if "!debug!"=="1" echo Action: report help information
    set _exception=
    call :a_report_help_information
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_4
    if "!debug!"=="1" echo Event: version
    set event=
    if "!debug!"=="1" echo Action: report project version
    set _exception=
    call :a_report_project_version
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_5
    if "!debug!"=="1" echo Event: empty
    set event=
    if "!debug!"=="1" echo Action: report help information
    set _exception=
    call :a_report_help_information
    if "!_exception!"=="1" exit /b 1
    if not "%1"=="" goto process
    exit /b 0
:s_6_empty
    if "!debug!"=="1" echo Get event from user
    set event=%1
    shift
    if "!event!"=="" set event=empty
    goto s_default
:r_default
echo install:
    echo   Installs deliverables into the final or temporary install tree.
    echo     This action is only valid after a successful build.
echo test:
    echo   Runs regression tests for the project.
echo help:
    echo   Shows a list of the commands allowed on the project.
echo version:
    echo   Show project version.
    goto r_win32


exit /b 0
